<?php
/**
 * Add / update admin form
 */

	if (!defined("ENV") || defined('IS_INTUIT_FEDERATED')) exit();

	$mode = isset($_GET["mode"]) ? trim($_GET["mode"]) : "insert";
	$admin_id = isset($_GET["aid"])? intval($_GET["aid"]) : 0;
	
	$password_history = array();
	
	// Nonce created above the switch since the $admin variable is reset here
	$admin_nonce = create_nonce('admin_'.$mode);
	
	switch ($mode)
	{
		/**
		 * Get update data
		 */
		case "update" :
		{
			$db->query("SELECT * FROM ".DB_PREFIX."admins WHERE aid='".intval($admin_id)."' AND aid<>'".intval($admin_auth_id)."'");
			if (($admin = $db->moveNext()) != false)
			{
				$admin["privileges"] = explode(",", $admin["rights"]);
				$admin["password_history"] = $admin["password_history"] != "" ? unserialize(base64_decode($admin["password_history"])) : array();
				$admin["receive_notifications"] = explode(",", $admin["receive_notifications"]);
				break;
			}
		}
		/**
		 * Preset new user data
		 */
		default :
		case "insert" :
		{
			$mode = "insert";
			$admin = array(
				"name" => "",
				"email" => "",
				"username" => "",
				"email_mode" => "html",
				"active" => "Yes",
				"expires" => 0,
				"expiration_date" => date("Y-m-d H:i:s"),
				"privileges" => array(),
				"password_history" => array(),
				"receive_notifications" => array('invoice','outofstock','signup','product_review','pwdchange30')
			);
			break;
		}
	}
	
	loadJS("cf_admin.js");
	loadJS("cd_admin.js");
	loadJS("content/vendors/sha1/sha1-min.js", '');
	pageHeader("Site Administrator", $mode, 'icb-administrator');
	
	
	$db->query('SELECT COUNT(*) AS c FROM '.DB_PREFIX.'admins');
	$db->moveNext();
	$adminsCount = $db->col['c'];
	
	if (AccessManager::checkAccess('MAX_ADMINS') > 1 && (($mode != 'insert') || ($mode == 'insert' && $adminsCount < AccessManager::checkAccess('MAX_ADMINS'))))
	{
		$exp_date = strtotime($admin["expiration_date"]);

		pageNote(
			array(
				array("class"=>"ic-info", "text"=>"<b>Please note: required fields are bold</b>", "visible"=>true),
				array("class"=>"ic-info", "text"=>"Please leave password field blank if you don't want to change it", "visible"=>$mode == "update"),
				array("class"=>"ic-delete", "url"=>"javascript:ConfirmDeleteAdmin(".$admin_id.")","text"=>"Remove this account", "visible"=>$mode == "update")
			)
		);
?>
<form name="frmAdmin" action="admin.php?p=admin_process" method="post" onsubmit="return CheckAdminForm(this, '<?=$mode?>')">
	<input type="hidden" name="nonce" value="<?=$admin_nonce?>" />
	<input type="hidden" name="aid" value="<?=$admin_id?>">
	<input type="hidden" name="mode" value="<?=$mode?>">
	<div class="admin-tabs admin-tabs-framed" id="tabs-admin">
<?php 
		pageTabs(array(
			array("title"=>"Administrator Properties", "id"=>"main"),
		), "tabs-admin");
?>
<script type="text/javascript"><!--
var ForcePCIPasswd = <?=$settings["SecurityForceCompliantAdminPasswords"] == "YES" ? "true" : "false"; ?>;
var password_history = new Array();
<?php
		if (count($password_history) > 0)
		{
			$i = 0;
			foreach ($password_history as $passwd)
			{
				echo "password_history[".($i++)."] = '".$passwd["p"]."';\n";  
			}
		}
?>
--></script>
		<div id="admin-tab-sheet-main" class="admin-tab-sheet">
			<div class="admin-tab-sheet-wrap">
				<div class="admin-form-header first"><span class="icon ic-icon"></span>Basic Information &amp; Security</div>
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr valign="top">
						<td class="formItemCaption required">First &amp; Last Name</td>
						<td class="formItemControl"><input maxlength="30" type="text" name="name" value="<?=htmlspecialchars($admin["name"])?>"></td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption required">Email Address</td>
						<td class="formItemControl"><input type="text" name="email" maxlength="200" value="<?=htmlspecialchars($admin["email"])?>"></td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Email Type</td>
						<td class="formItemControl">
							<select name="email_mode">
								<option value="html" <?=$admin["email_mode"]=="html"?"selected":""?>>HTML enriched messages</option>
								<option value="text" <?=$admin["email_mode"]=="text"?"selected":""?>>Plain text messages</option>
							</select>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">&nbsp;</td>
						<td class="formItemControl">
							<input <?=in_array("invoice", $admin["receive_notifications"]) ? "checked" : ""?> type="checkbox" name="receive_notification[invoice]" value="invoice" id="rn_invoice"> <label for="rn_invoice">Receive invoice notifications</label><br/>
							<input <?=in_array("outofstock", $admin["receive_notifications"]) ? "checked" : ""?> type="checkbox" name="receive_notification[outofstock]" value="outofstock" id="rn_outofstock"> <label for="rn_outofstock">Receive out of stock messages</label><br/>
							<input <?=in_array("signup", $admin["receive_notifications"]) ? "checked" : ""?> type="checkbox" name="receive_notification[signup]" value="signup" id="rn_signup"> <label for="rn_signup">New user registration notifications</label><br/>
							<input <?=in_array("product_review", $admin["receive_notifications"]) ? "checked" : ""?> type="checkbox" name="receive_notification[product_review]" value="product_review" id="rn_product_review"> <label for="rn_product_review">Email admin when a review is created</label><br/>
							<input <?=in_array("notactive", $admin["receive_notifications"]) ? "checked" : ""?> type="checkbox" name="receive_notification[notactive]" value="notactive" id="rn_notactive"> <label for="rn_notactive">Notify if an administrator account has been inactive for over 90 days</label><br/>
							<br/>Remind me to change password after<br/>
							<input value="pwdchange30" <?=in_array("pwdchange30", $admin["receive_notifications"]) ? "checked" : ""?> type="radio" name="receive_notification[password_change]" id="rn_password_change_30"> <label for="rn_password_change_30">30 days</label><br/>
							<input value="pwdchange60" <?=in_array("pwdchange60", $admin["receive_notifications"]) ? "checked" : ""?> type="radio" name="receive_notification[password_change]" id="rn_password_change_60"> <label for="rn_password_change_60">60 days</label><br/>
							<input value="pwdchange90" <?=in_array("pwdchange90", $admin["receive_notifications"]) ? "checked" : ""?> type="radio" name="receive_notification[password_change]" id="rn_password_change_90"> <label for="rn_password_change_90">90 days</label><br/>
							<input value="pwdchangenever" <?=in_array("pwdchangenever", $admin["receive_notifications"]) ? "checked" : ""?> value="" type="radio" name="receive_notification[password_change]" id="rn_password_change_never"> <label for="rn_password_change_never">Never</label>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption required">Username</td>
						<td class="formItemControl"><input type="text" name="username" maxlength="200" value="<?=htmlspecialchars($admin["username"])?>"></td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption required">Password</td>
						<td class="formItemControl">
							<input type="password" name="password" maxlength="200" value="" onKeyUp="pwdStrength(this.value)">
							<div id="pwdDescription"></div>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption required">Password Confirmation</td>
						<td class="formItemControl"><input type="password" name="password2" maxlength="200" value=""></td>
					</tr>
				</table>
				<div class="admin-form-header"><span class="icon ic-icon"></span>Account Lock</div>
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr valign="top">
						<td class="formItemCaption">Current status:</td>
						<td class="formItemControl">
							<select name="active" class="short">
								<option value="Yes">Unlocked</option>
								<option value="No" <?=$admin["active"]=="No" ? "selected" : ""?>>Locked</option>
							</select>
						</td>
					</tr>
				</table>
				<div class="admin-form-header"><span class="icon ic-icon"></span>Expiration</div>
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr valign="top">
						<td class="formItemCaption">Does this account expire?</td>
						<td class="formItemControl">
							<select name="expires" class="short">
								<option value="1">Yes</option>
								<option value="0" <?php echo $admin["expires"]== "0" ? "selected" : ""?>>No</option>
							</select>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Expiration date / time</td>
						<td class="formItemControl">
							<select name="exp_month" class="date-month">
<?php
		$exp_month = date("n", $exp_date);
		for ($i=1; $i<=12; $i++)
		{
			echo '<option value="'.$i.'" '.($i == $exp_month ? "selected" : "").'>'.$months[$i].'</option>';
		}
?>			
							</select>
							<select name="exp_day" class="date-day">
<?php
		$exp_day = date("j", $exp_date);
		for ($i=1; $i<=31; $i++)
		{
			echo '<option value="'.$i.'" '.($i == $exp_day ? "selected" : "").'>'.$i.'</option>';
		}
?>
							</select>
							<select name="exp_year" class="date-year">
<?php
		$exp_year = date("Y", $exp_date);
		for ($i=2003; $i<=date("Y")+10; $i++)
		{
			echo '<option value="'.$i.'" '.($i == $exp_year ? "selected" : "").'>'.$i.'</option>';
		}
?>
							</select>
							<select name="exp_hour" style="width:80px;margin-left:15px;">		
<?php
		$exp_hour = date("G", $exp_date);
		for ($i=0; $i<=23; $i++)
		{
			if ($i == 0) $h = "12";
			elseif ($i < 13) $h = $i;
			else $h = $i - 12;
			$h .= $i >= 12 ? " pm" : " am";
			
			echo '<option value="'.$i.'" '.($i == $exp_hour ? "selected" : "").'>'.$h.'</option>';
		}
?>
							</select>
							<select name="exp_minute" style="width:80px;">		
<?php
		$exp_minute = intval(date("i", $exp_date));
		for ($i=0; $i<=59; $i++)
		{
			echo '<option value="'.$i.'" '.($i == $exp_minute ? "selected" : "").'>'.$i.'</option>';
		}
?>
							</select>
						</td>
					</tr>
				</table>
				<div class="admin-form-header"><span class="icon ic-icon"></span>Administrator Privileges</div>
				<div class="formItemControl big clearfix">
					<div class="privilegeItem">
						<div class="privilegeItemCheck"><input type="checkbox" name="privilege[categories]" value="categories" id="id_categories" <?=in_array("categories", $admin["privileges"])?"checked":""?>></div>
						<div class="privilegeItemLabel"><label for="id_categories">Manage product categories</label></div>
					</div>
					<div class="privilegeItem">
						<div class="privilegeItemCheck"><input type="checkbox" name="privilege[products]" value="products" id="id_products" <?=in_array("products", $admin["privileges"])?"checked":""?>></div>
						<div class="privilegeItemLabel"><label for="id_products">Add/edit/delete products, bulk loaders</label></div>
					</div>
					<div class="privilegeItem">
						<div class="privilegeItemCheck"><input type="checkbox" name="privilege[users]" value="users" id="id_users" <?=in_array("users", $admin["privileges"])?"checked":""?>></div>
						<div class="privilegeItemLabel"><label for="id_users">Manage site users</label></div>
					</div>
					<div class="privilegeItem">
						<div class="privilegeItemCheck"><input type="checkbox" name="privilege[orders]" value="orders" id="id_orders" <?=in_array("orders", $admin["privileges"])?"checked":""?>></div>
						<div class="privilegeItemLabel"><label for="id_orders">Manage orders</label></div>
					</div>
					<div class="privilegeItem">
						<div class="privilegeItemCheck"><input type="checkbox" name="privilege[emails]" value="emails" id="id_emails" <?=in_array("emails", $admin["privileges"])?"checked":""?>></div>
						<div class="privilegeItemLabel"><label for="id_emails">Edit and send emails</label></div>
					</div>
					<div class="privilegeItem">
						<div class="privilegeItemCheck"><input type="checkbox" name="privilege[admins]" value="admins" id="id_admins" <?=in_array("admins", $admin["privileges"])?"checked":""?>></div>
						<div class="privilegeItemLabel"><label for="id_admins">Manage site administrators</label></div>
					</div>
					<div class="privilegeItem">
						<div class="privilegeItemCheck"><input type="checkbox" name="privilege[global]" value="global" id="id_global" <?=in_array("global", $admin["privileges"])?"checked":""?>></div>
						<div class="privilegeItemLabel"><label for="id_global">Edit global site settings</label></div>
					</div>
					<div class="privilegeItem">
						<div class="privilegeItemCheck"><input type="checkbox" name="privilege[business]" value="business" id="id_business" <?=in_array("business", $admin["privileges"])?"checked":""?>></div>
						<div class="privilegeItemLabel"><label for="id_business">Manage payment, shipping, taxes and discounts</label></div>
					</div>
					<div class="privilegeItem">
						<div class="privilegeItemCheck"><input type="checkbox" name="privilege[content]" value="content" id="id_content" <?=in_array("content", $admin["privileges"])?"checked":""?>></div>
						<div class="privilegeItemLabel"><label for="id_content">Manage site content (pages, themes, colors and files)</label></div>
					</div>
					<div class="privilegeItem">
						<div class="privilegeItemCheck"><input type="checkbox" name="privilege[database]" value="database" id="id_export" <?=in_array("database", $admin["privileges"])?"checked":""?>></div>
						<div class="privilegeItemLabel"><label for="id_export">Clear / Export MySQL database</label></div>
					</div>
					<div class="privilegeItem">
						<div class="privilegeItemCheck"><input type="checkbox" name="privilege[stats]" value="stats" id="id_stats" <?=in_array("stats", $admin["privileges"])?"checked":""?>></div>
						<div class="privilegeItemLabel"><label for="id_stats">See statistics</label></div>
					</div>
					<div class="privilegeItem">
						<div class="privilegeItemCheck"><input type="checkbox" name="privilege[marketing]" value="marketing" id="id_marketing" <?=in_array("marketing", $admin["privileges"])?"checked":""?>></div>
						<div class="privilegeItemLabel"><label for="id_marketing">Marketing</label></div>
					</div>
					<div class="privilegeItem">
						<div class="privilegeItemCheck"><input type="checkbox" name="privilege[ccs]" id="id_ccs" value="ccs" <?=in_array("ccs", $admin["privileges"]) ? "checked" : ""?>></div>
						<div class="privilegeItemLabel"><label for="id_ccs">Access to CCS</label></div>
					</div>
					<div class="privilegeItem">
						<div class="privilegeItemCheck"><input type="checkbox" name="privilege[demo]" id="id_demo" value="demo" <?=in_array("demo", $admin["privileges"]) ? "checked" : ""?>></div>
						<div class="privilegeItemLabel"><label for="id_demo"><b>Demo Mode Admin</b></label></div>
					</div>
					<div class="privilegeItem">
						<div class="privilegeItemCheck"><input type="checkbox" name="privilege[all]" id="id_all" value="all" <?=in_array("all", $admin["privileges"]) ? "checked" : ""?>></div>
						<div class="privilegeItemLabel"><label for="id_all"><b>All privileges</b></label></div>
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="admin-form-buttons">
		<input type="submit" value="Save changes"/>
		<input type="reset" value="Reset form"/>
	</div>
</form>
<?php
	}
	else
	{
		AccessManager::notAllowed("Your current license agreement only allows ".AccessManager::checkAccess('MAX_ADMINS')." admin(s).");
	}

