<?php
/**
 * Bulk uploader step 3
 */

	if (!defined("ENV")) exit();
	
	$skipped_cats = 0;
	
	$fields = isset($fields) ? $fields : array();
	$fields = is_array($fields) ? $fields : array();
	$make_categories_visible = isset($make_categories_visible) ? $make_categories_visible : 'No';
	if (!in_array($make_categories_visible, array('Yes', 'No')))
		$make_categories_visible = 'No';
	$make_categories_visible_type = isset($make_categories_visible_type) ? $make_categories_visible_type : 'inserted';

	$is_error = false;
	$file_name = isset($file_name)?$file_name:"";
	$f = @fopen("content/cache/tmp/".$file_name, "r");
	
	if (!$f)
	{
		$is_error = true;
		$error_message = "Can't open file with categories!";
	}
	else
	{
		if ((!in_array("key_name", $fields)) || (!in_array("name", $fields)))
		{
			$is_error = true;
			$error_message = "Please choose all required fields!";
		}
		
		if (DEMO_LOCK)
		{
			$is_error = true;
			$error_message = "This feature is not available in demo mode";
		}
		
		if (!$is_error)
		{
			$lines = array();
			$max_fields = 0;
			while ($line = fgetcsv ($f, 8192, $fields_separator))
			{
				if (!empty($line))
				{
					$lines[count($lines)] = $line;
					$max_fields = $max_fields > count($line)?$max_fields:count($line);
				}
			}
			fclose($f);
			//@unlink("content/cache/tmp/".$file_name);

			$insert_count = 0;
			$update_count = 0;
			
			// first pass - insert new categories first
			// preload category data - on this step we only need categories keys to check does category already exists
			$catalog = array();
			$db->query("SELECT key_name FROM ".DB_PREFIX."catalog");
			while ($db->moveNext())
			{
				$catalog[strtolower(trim($db->col["key_name"]))] = true;
			}
			
			for ($i = 0; $i < count($lines); $i++)
			{
				$line = $lines[$i];
				$data = array();
				for ($j=0; $j<count($line); $j++) if ($fields[$j] != "skip")
				{
					$data[$fields[$j]] = getUTF8(trim($line[$j]));
				}
				
				// check is it a new category or existing one
				// basically on that pass we only create an empty category record to assign key_name with cid
				$_key_name = strtolower(trim($data["key_name"]));
				if (!isset($catalog[$_key_name]) && $_key_name != "" && !($_key_name == 'categorykey' || $_key_name == 'key_name'))
				{
					// update category
					$db->reset();
					$db->assignStr("key_name", $data["key_name"]);
					$db->assignStr("is_visible", $make_categories_visible);
					$db->insert(DB_PREFIX."catalog");
					$insert_count++;
				}
			}
			
			// second pass - reassign levels / parents
			// preload category data second time - now we need little bit more data
			function bulkloaderUpdateCategoryChildren(&$db, $cid, $level)
			{
				$db->query("SELECT cid FROM ".DB_PREFIX."catalog WHERE parent='".$cid."'");
				if ($db->numRows() > 0)
				{
					$records = $db->getRecords();
					$cids = array();
					foreach ($records as $record)
					{
						bulkloaderUpdateCategoryChildren($db, $record["cid"], $level+1);
						$cids[] = $record["cid"];
					}
					$db->query("UPDATE ".DB_PREFIX."catalog SET level='".($level+1)."' WHERE cid IN (".implode(",", $cids).")");
				}
			}
			
			$catalog = array();
			$db->query("SELECT cid, level, key_name FROM ".DB_PREFIX."catalog ORDER BY level, priority, cid");
			while ($db->moveNext())
			{
				$catalog[strtolower(trim($db->col["key_name"]))] = $db->col;
			}
			
			for ($i = 0; $i < count($lines); $i++)
			{
				$db->reset();					

				$line = $lines[$i];
				$data = array();
				for ($j=0; $j<count($line); $j++) if ($fields[$j] != "skip") $data[$fields[$j]] = trim($line[$j]);
				
				$_key_name = strtolower(trim($data["key_name"]));
				
				if ($_key_name != "" && !($_key_name == 'categorykey' || $_key_name == 'key_name'))
				{
					// check parent first
					$parent = 0;
					$level = 1;
				
					$_parent = "";
					if (isset($data["parent"]) && $data["parent"] != "" && isset($catalog[strtolower(trim($data["parent"]))]))
					{
						$_parent = strtolower(trim($data["parent"]));
						$parent = $catalog[$_parent]["cid"];
						$level = $catalog[$_parent]["level"] + 1;
						
						// Changing parent only when set and not empty
						$db->assignStr("parent", $parent);
						$catalog[$_key_name]["parent"] = $parent;
					}
					else
					{
						$db->assignStr("parent", 0);
					}
					
					$data["parent"] = $parent;
					
					$db->assignStr("level", $level);
					$catalog[$_key_name]["level"] = $level;
				
					// check the rest of fields
					foreach ($data as $key=>$value)
					{
						//check boolean values
						if ($fields_names[$key][3])
						{
							if (in_array(strtolower($value), $bool_true)) $value = "Yes";
							elseif (in_array(strtolower($value), $bool_false)) $value = "No";
							else $value = $fields_names[$key][1]; // default
						}
						$db->assignStr($key, $value);
					}
					if ($make_categories_visible_type == "updated")
					{
						$db->assignStr('is_visible', $make_categories_visible);
					}
				
					$db->update(DB_PREFIX."catalog", "WHERE cid='".$catalog[$_key_name]["cid"]."'");
					bulkloaderUpdateCategoryChildren($db, $catalog[$_key_name]["cid"], $level);
					
					$update_count++;
				}
			}
			$update_count = $update_count - $insert_count;
			
			
			// Update seo URLs
			updateSeoURLs($db, $settings, true, true, false, true);
			
			// Get fileds involved in update
			$used_fields = "Level"; // <-- those always used
			$j = 0;
			for ($i=0; $i<count($fields); $i++)
			{	
				if ($fields[$i] != "skip")
				{
					$used_fields.= ", ".$fields_names[$fields[$i]][0];
					$j++;
				}
			}
			
			// Final notes
			pageNote(array(
				array(
					"class"=>"ic-info", 
					"text"=>
						"New Categories: <b>".$insert_count."</b><br/>".
						"Updated Categories: <b>".$update_count."</b><br/>".
						"Used fields: <b>".$used_fields."</b>",
					"url"=>"",
					"visible"=>true
				)
			));
			
			pageWhat(array(
				array("text"=>"Start loading categories again",	"url"=>"admin.php?p=bulk_categories"),
				array("text"=>"Manage categories", "url"=>"admin.php?p=categories"),
				array("text"=>"Start loading products",	"url"=>"admin.php?p=bulk_products"),
				array("text"=>"Manage products", "url"=>"admin.php?p=products")
			));
		}
	}
	
	if ($is_error)
	{
		pageNote(array(
			array("class"=>"ic-cross", "text"=>"<b>".$error_message."</b>", "url"=>"", "visible"=>true)
		));
?>
<blockquote>
	<form action="admin.php?p=bulk_categories" method="GET">
		<input type="submit" value="Back"/>
	</form>
</blockquote>
<?
	}