<?php
/**
 * Bulk uploader step 2
 */

	if (!defined("ENV")) exit();
	
	$is_error = false;
	$file_path_info = pathinfo($_FILES["bulk"]["name"]);
	
	// check is file is really CSV file
	if ($_FILES["bulk"]["name"] == "" || strtolower($file_path_info["extension"]) != "csv")
	{
		$is_error = true;
		$error_message = "Please choose .CSV file with products";
	}
	else
	{
		// open temporary file
		$f = @fopen($_FILES["bulk"]["tmp_name"], "r");
		if (!$f)
		{
			$is_error = true;
			$error_message = "Can't open file with products!";
		}
		else
		{
			// check is primary category selected
			$db->query("SELECT * FROM ".DB_PREFIX."catalog WHERE cid='".$cid."'");
			if (($category = $db->moveNext()) == false)
			{
				$is_error = true;
				$error_message = "Incorrect category ID";
			}
			else
			{
				$cat_name = $category["name"];
				// load CSV file
				$lines = array();
				$lines_count = 0;
				$max_fields = 0;

				while ($line = fgetcsv($f, 4096 * 2, $fields_separator))
				{
					$max_fields = $max_fields > count($line)?$max_fields:count($line);
					if ($lines_count < 10) $lines[] = $line;
					$lines_count = $lines_count + 1;
				}
				
				fclose($f);
				
				// move uplaoded file to a temporary folder
				$tmp_file_name =  md5(uniqid(rand(),1));
				
				if (!move_uploaded_file($_FILES["bulk"]["tmp_name"], "content/cache/tmp/".$tmp_file_name))
				{
					$is_error = true;
					$error_message = "Can not save temporary file. Please check free space and permissions.";
				}
				else
				{
					pageNote(array(
						array("class"=>"ic-download", "text"=>
							"Uploaded file name : <b>".$_FILES["bulk"]["name"]."</b><br>".
							"Total lines : <b>".$lines_count."</b><br>".
							//"Displayed : <b>First ".(($lines<10)?$lines:10)." lines</b><br>".
							"Products category : <b>".$cat_name."</b><br>".
							"Data loading rule : <b>".$update_rule."</b>",
							"url"=>"", "visible"=>true
						),
						array("class"=>"ic-info", "text"=>"<b>Please make sure so data is loaded correctly!</b>", "url"=>"", "visible"=>true),
						array("class"=>"ic-info", "text"=>"Please note : all blank lines and lines with wrong price will be skipped. Required fields are Product ID, Name and Price", "url"=>"", "visible"=>true)
					));
					loadJS("bulkloader.js");
					
?>
<form action="admin.php?p=bulk_products" method="post" onSubmit="return checkAssignForm(this)">
	<input type="hidden" name="step" value="3" />
	<input type="hidden" name="file_name" value="<?=$tmp_file_name?>" />
	<input type="hidden" name="cid" value="<?=$cid?>" />
	<input type="hidden" name="make_products_visible" value="<?=$make_products_visible?>" />
	<input type="hidden" name="fields_separator" value="<?=$fields_separator?>" />
	<input type="hidden" name="update_rule" value="<?=$update_rule?>" />
	<div class="admin-tabs admin-tabs-framed" id="tabs-product">
<?php 
					pageTabs(array(
						array("title"=>"Bulk Uploading - Step 1", "id"=>"main"),
					), "tabs-product", false);
?>
		<div id="admin-tab-sheet-main" class="admin-tab-sheet">
			<div class="admin-tab-sheet-wrap">
				<div class="admin-form-header first"><span class="icon ic-icon"></span>Assign fields with data</div>
				<table width="100%" cellpadding="5" cellspacing="0" border="0" class="admin-list-table">
					<thead>
						<tr>
							<th class="icon">&nbsp;</th>
							<th style="width:160px;">Select Field</th>
							<th style="width:135px;">CSV Line 1</th>
							<th style="width:135px;">CSV Line 2</th>
							<th style="width:135px;">CSV Line 3</th>
							<th style="width:135px;">CSV Line 4</th>
							<th>&nbsp;</td>
						</tr>
					</thead>
					<tbody>
<?php
					$autoAssign = $lines[0];
					for ($i=0; $i<count($autoAssign); $i++)
					{
						$autoAssign[$i] = strtolower(preg_replace("/[^A-Za-z0-9]/", "", $autoAssign[$i]));
					}

					$max_fields = $max_fields > 250 ? 250 : $max_fields; 
					for ($i=0; $i<$max_fields; $i++)
					{
						echo '<tr>';
							echo '<td class="icon">&nbsp;</td>';
							echo '<td>';
								echo '<select name="fields['.$i.']" class="fields-selector" style="font-size:12px;font-family:Arial Narrow">';
								reset($fields_names);
								foreach ($fields_names as $field_name => $field_data)
								{
									$selected = false;
									if (isset($autoAssign[$i]) && in_array($autoAssign[$i], $field_data[4])) $selected = true;
									echo '<option value="'.$field_name.'" '.($field_data[2]?'style="color:red"':'').' '.($selected?" selected":"").'>'.htmlspecialchars($field_data[0]).'</option>';
								}
								echo '</select>';
							echo '</td>';
							
							for ($j=0;(($j < $lines_count) && ($j < 4)); $j++)
							{
								echo '<td onMouseOver="showDiv(\'div'.($i."_".$j).'\', this)" onMouseOut="hideDiv(\'div'.($i."_".$j).'\', this)" style="border-bottom:1px solid #e0e0e0;width:135px;">';
								if(isset($lines[$j][$i])) echo $j<count($lines[$j])?(is_numeric(trim($lines[$j][$i]))?($lines[$j][$i]):(htmlspecialchars(substr(getUTF8($lines[$j][$i]), 0, 30)).(strlen($lines[$j][$i])>30?"...":""))):"&nbsp;";
								echo $j<count($lines[$j])?('<div id="div'.($i."_".$j).'" style="width:200px;border:1px solid black;padding:5px;background-color:#F7F7FF;display:none;position:absolute;">'.htmlspecialchars(isset($lines[$j][$i]) && !empty($lines[$j][$i])  ? getUTF8($lines[$j][$i]) : "** EMPTY **").'</div>'):"&nbsp;";
								echo "&nbsp;</td>";
							}
						echo '<td>&nbsp;</td>';
						echo '</tr>';
					}
?>
					</tbody>
				</table>
			</div>
		</div>
	</div>
	<div class="admin-form-buttons">
		<input type="submit" value="Update products" />
		<input type="button" value="Back" onClick="history.back();return false;"/>
	</div>
</form>
<?php
				}
			}
		}
	}
	
	if ($is_error)
	{
		pageNote(array(
			array("class"=>"ic-cross", "text"=>"<b>".$error_message."</b><br/><br/><br/>".'<input type="button" value="Back" onClick="javascript:history.back();return false;">', "url"=>"", "visible"=>true)
		));
	}