<?php

	if (!defined("ENV")) exit();
	
	/**
	 * Option param
	 */
	class OPTION_PARAM
	{
		var $id;
		var $parent_id;
		var $level;
		
		function OPTION_PARAM($id, $parent_id, $level)
		{
			$this->id = $id;
			$this->parent_id = $parent_id;
			$this->level = $level;
			return $this;
		}
	}
	
	/**
	 * Option node
	 */
	class OPTION_NODE extends DB_TREE_NODE
	{
		public function drawNode($param)
		{
			if ($this->id!=$param->id)
			{
				if ($this->id != TREE_ROOT)
				{
					echo 
						'<tr>'.
							'<td class="text-align-right"><input type="checkbox" name="catDelete" value="'.$this->id.'"/></td>'.
							'<td style="padding-left:'.(($param->level-1)*20+7).'px;">'.
								'<a href="admin.php?p=category&mode=update&cid='.$this->id.'" '.($this->is_visible=="Yes"?"":' style="color:gray"').'>'.htmlspecialchars($this->caption).'</a>'.
							'</td>'.
							'<td class="text-align-right">'.
								'<a href="admin.php?p=category&mode=update&cid='.$this->id.'"><img src="images/icons/a/pencil.png" border="0" hspace="2" title="Edit Category"></a>'.
								'<a href="admin.php?p=category&mode=insert&parent='.$this->id.'"><img src="images/icons/a/add.png" hspace="2" title="Add Subcategory" border="0"></a>'.
								'<a href="javascript:ConfirmDeleteCategory('.$this->id.');"><img src="images/icons/a/delete.png" border="0" title="Delete Category"></a>'.
							'</td>'.
						'</tr>';
				}
				
				if (count($this->nodes) > 0)
				{
					foreach ($this->nodes as $id => $node)
					{
						$node->drawNode(
							new OPTION_PARAM($param->id, $param->parent_id, $param->level+1)
						);
					}
				}
			}
		}
	}

	$tree = new DB_TREE();
	$tree->collection[TREE_ROOT] = (new OPTION_NODE(TREE_ROOT, -1, 0, "Yes", "Category Root"));
	
	$db->query("SELECT * FROM ".DB_PREFIX."catalog ORDER BY level, priority, name");
	$cats_count = $db->numRows();
	
	while ($db->moveNext())
	{
		$tree->addNode(
			new OPTION_NODE(
				$db->col["cid"], 
				$db->col["parent"], 
				$db->col["level"], 
				$db->col["is_visible"],
				$db->col["name"]
			)
		);
	}
	
	loadJS("cd_category.js");
	pageHeader("Manage Catalog Categories", "", "icb-folder");
	
	pageNote(array(
		array("class"=>"ic-add", "url"=>"admin.php?p=category&mode=insert", "text"=>"<b>Click to Add a New Category</b>", "visible"=>true),
		array("class"=>"ic-info", "text"=>"<strong>You currently do not have any categories in your catalog.<br>Please click \"Add a New Category\".</strong>", "visible"=>$cats_count < 1)
	));
	
?>
<script type="text/javascript">
$(document).ready(function(){
	$("#delete-categories").click(function()
	{
		DeleteCategories();
	});
	
	$("#selectAll").change(function()
	{
		if ($("#selectAll").attr('checked'))
		{
			$("input[name='catDelete']").attr('checked', 'true');
		}
		else
		{
			$("input[name='catDelete']").removeAttr('checked');
		}
	});
	
	$('input[name="catDelete"]').each(function(){
		$(this).click(function(){
			var total = $('input[name="catDelete"]').length;
			var checked = $('input[name="catDelete"]:checked').length;
			
			if (checked >= total)
				$('#selectAll').attr('checked', 'checked');
			else
				$('#selectAll').removeAttr('checked', 'checked');
		});
	});
});
</script>

<?php
	if ($cats_count > 0)
	{
?>
<input type="hidden" id="delete-category-nonce" value="<?php echo create_nonce('category_delete'); ?>"/>
<input type="hidden" id="nonce-category-bulk-delete" value="<?php echo create_nonce('category_bulkDelete'); ?>"/>

<table width="100%" cellpadding="0" cellspacing="0" border="0" class="admin-list-table no-stripes">
	<thead>
		<tr>
			<th class="icon"><span class="icon ic-icon ic-folder"></span></th>
			<th>Product Category Name</th>
			<th style="width:100px;">&nbsp;</th>
		</tr>
	</thead>
	<tbody>
<?php
	
	$cid = -1;
	$parent = TREE_ROOT;
	$tree->collection[TREE_ROOT]->drawNode(
		new OPTION_PARAM($cid, $parent, 0)
	);
	
?>		
	</tbody>
	<tfoot>
		<tr>
			<td><input type="checkbox" id="selectAll"/></td>
			<td colspan="2"><label for="selectAll">Select All</label></td>
		</tr>
		<tr>
			<td colspan="3">
				<input type="button" value="Delete Categories" class="warning" id="delete-categories"/>
			</td>
		</tr>
	</tfoot>
</table>
<?php
	}
	