<?php
/**
 * Category
 */

	if (!defined("ENV")) exit();

	///////////////////////////////////////////
	// inherit basic node & override drawNode
	class OPTION_PARAM
	{
		var $id;
		var $parent_id;
		var $level;
		function OPTION_PARAM($id, $parent_id, $level)
		{
			$this->id = $id;
			$this->parent_id = $parent_id;
			$this->level = $level;
			return $this;
		}
	}

	class OPTION_NODE extends DB_TREE_NODE
	{
		function drawNode($param)
		{
			if ($this->id!=$param->id)
			{
				echo '<option value="'.$this->id.'" '.($this->id == $param->parent_id?"selected":"").' '.($this->is_visible=="No"?"style='color:gray;'":"").'>';
				for ($i=0; $i<$param->level*4; $i++)
				{
					echo "&nbsp;";
				}
				echo htmlspecialchars($this->caption).'</option>';
				if (count($this->nodes)>0)
				{
					foreach ($this->nodes as $id => $node)
					{
						$node->drawNode(
							new OPTION_PARAM($param->id, $param->parent_id, $param->level+1)
						);
					}
				}
			}
		}
	}

	$tree = new DB_TREE();
	$tree->collection[TREE_ROOT] = (new OPTION_NODE(TREE_ROOT, -1, 0, "Yes", "Category Root"));

	$db->query("SELECT * FROM ".DB_PREFIX."catalog ORDER BY level, priority, name");
	while ($db->moveNext())
	{
		$tree->addNode(
			new OPTION_NODE(
				$db->col["cid"],
				$db->col["parent"],
				$db->col["level"],
				$db->col["is_visible"],
				$db->col["name"]
			)
		);
	}

	$cid = isset($cid)?$cid*1:"";
	$mode = isset($mode)?trim($mode):"";
	switch ($mode)
	{
		case "update" : 
		{
			$db->query("SELECT * FROM ".DB_PREFIX."catalog WHERE cid='".$cid."'");
			if ($db->moveNext())
			{

				$name = $db->col["name"];
				$parent = $db->col["parent"];
				$description = $db->col["description"];
				$description_bottom = $db->col["description_bottom"];
				$priority = $db->col["priority"];
				$is_visible = $db->col["is_visible"];
				$list_subcats = $db->col["list_subcats"];
				$key_name = $db->col["key_name"];
				$meta_keywords = $db->col["meta_keywords"];
				$meta_title = $db->col["meta_title"];
				$meta_description = $db->col["meta_description"];
				$category_header = $db->col["category_header"];
				$url_default = $db->col["url_default"];
				$url_custom = $db->col["url_custom"];
				$list_subcats_images = intval($db->col['list_subcats_images']);

				break;
			}
		}
		default :
		case "insert" : 
		{
			$mode = "insert";
			$cid = -1;
			$name = "";
			$parent = isset($parent)?$parent:TREE_ROOT;
			$description = "";
			$description_bottom = "";
			$key_name = "";
			$priority = 5;
			$is_visible = "Yes";
			$list_subcats = "No";
			$meta_keywords = "";
			$meta_title = "";
			$meta_description = "";
			$category_header = "";
			$url_default = "will be generated after category saved";
			$url_custom = "";
			$list_subcats_images = 0;
		}
	}
	loadJS("cf_category.js");
	loadJS("cd_category.js");

	pageHeader("Category", ucfirst(strtolower($mode)), "icb-folder");
	pageNote(array(
		array("class"=>"ic-info", "text"=>"<b>Please note : required fields are bold</b>", "url"=>"", "visible"=>true),
		array("class"=>"ic-trash-can", "text"=>"Remove this category", "url"=>"JavaScript:ConfirmDeleteCategory('".$cid."')", "visible" => $mode == "update")
	));
?>
<div style="display:none;"><input type="hidden" id="delete-category-nonce" value="<?php echo create_nonce('category_delete'); ?>"/></div>

<form name="frmCategory" action="admin.php?p=category_process" method="post" onsubmit="return CheckCategoryForm(this)" enctype="multipart/form-data">
	<input type="hidden" name="cid" value="<?=$cid?>">
	<input type="hidden" name="mode" value="<?=$mode?>">
	<input type="hidden" name="nonce" value="<?=create_nonce('category_'.$mode)?>">

<div class="admin-tabs admin-tabs-framed" id="tabs-category">
<?php 
	pageTabs(array(
		array("title"=>"Category Properties", "id"=>"main"),
		array("title"=>"QR Codes", "id"=>"qr", "visible" => $settings["qr_active"] == "Yes" && $mode == "update")
	), "tabs-category", false);
?>
	<div id="admin-tab-sheet-main" class="admin-tab-sheet">
		<div class="admin-tab-sheet-wrap">
			<div class="admin-form-header first"><span class="icon ic-icon ic-folder"></span>Parent Category</div>
			<table width="100%" cellpadding="0" cellspacing="0" border="0">
				<tr valign="top">
					<td class="formItemCaption required">Select Parent Category</td>
					<td class="formItemControl">
						<select name="parent" class="multiselect" size="10">
<?php
		$tree->collection[TREE_ROOT]->drawNode(
			new OPTION_PARAM($cid, $parent, 0)
		);
?>
						</select>
						<div class="formItemComment">
							To add a parent category, highlight Category Root at the top.
							To assign a child category, highlight the category you want the new category appear under
						</div>
					</td>
				</tr>
			</table>
			<div class="admin-form-header"><span class="icon ic-icon ic-pencil"></span>Category Properties</div>
			<table width="100%" cellpadding="0" cellspacing="0" border="0">
				<tr valign="top">
					<td class="formItemCaption required">Category Name</td>
					<td class="formItemControl">
						<input type="text" name="name" maxlength="255" value="<?=htmlspecialchars($name)?>">
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption required">Category Key / ID</td>
					<td class="formItemControl">
						<input type="text" name="key_name" maxlength="255" value="<?=htmlspecialchars($key_name)?>">
						<div class="formItemComment">
							This will be used for bulk loading products. This might be
							the same as the Category name, but without spaces.
							Example: digital_recorders.
						</div>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Category Header</td>
					<td class="formItemControl">
						<input type="text" name="category_header" maxlength="255" value="<?=htmlspecialchars($category_header)?>">
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption"><label for="checkbox_is_visible">Is category visible to users?</a></td>
					<td class="formItemControl">
						<input id="checkbox_is_visible" type="checkbox" name="is_visible" value="Yes" <?=$is_visible=='Yes'?'checked="checked"':''?>>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption"><label for="list_subcats">List subcategories on Catalog Page?</label></td>
					<td class="formItemControl">
						<input id="list_subcats" type="checkbox" name="list_subcats" value="Yes" <?=$list_subcats=='Yes'?'checked="checked"':''?>>
					</td>
				</tr>
				<tr valign="top" class="list_subcats_images">
					<td class="formItemCaption"><label for="list_subcats_images">Display subcategory images on Catalog Page?</label></td>
					<td class="formItemControl">
						<input id="list_subcats_images" type="checkbox" name="list_subcats_images" value="Yes" <?php echo (intval($list_subcats_images) == 1) ? 'checked="checked"' : ''; ?>>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Priority (used for sorting)</td>
					<td class="formItemControl">
						<input class="short" type="text" name="priority" maxlength="200" value="<?=htmlspecialchars($priority)?>">
					</td>
				</tr>
			</table>
			
			<div class="admin-form-header slide-manager"><span class="icon ic-icon ic-zoom"></span>SEO Properties</div>
			<div class="slide-area">
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr valign="top">
						<td class="formItemCaption">Meta Keywords</td>
						<td class="formItemControl">
							<input type="text" name="meta_keywords" maxlength="255" value="<?=htmlspecialchars($meta_keywords)?>">
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Meta Title</td>
						<td class="formItemControl">
							<input type="text" name="meta_title" maxlength="255" value="<?=htmlspecialchars($meta_title)?>">
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Meta Description</td>
						<td class="formItemControl">
							<textarea class="no-mce" name="meta_description"><?=htmlspecialchars($meta_description)?></textarea>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Category URL (pre-generated)</td>
						<td class="formItemControl static">
							<span style="text-decoration:underline;color:blue;"><?=htmlspecialchars($url_default)?></span>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Category URL (custom)</td>
						<td class="formItemControl">
							<input type="text" name="url_custom" maxlength="255" value="<?=htmlspecialchars($url_custom)?>">
						</td>
					</tr>
				</table>
			</div>
			
			<div class="admin-form-header slide-manager editor-manager"><span class="icon ic-icon ic-pencil"></span>Category Description (Top of Page)</div>
			<div class="slide-area">
				<div class="formItemControl big">
					<textarea class="editor-area no-mce" wrap="off" id="description" name="description"><?=htmlspecialchars($description)?></textarea>
				</div>
			</div>
			
			<div class="admin-form-header slide-manager editor-manager"><span class="icon ic-icon ic-pencil"></span>Category Description (Bottom of Page)</div>
			<div class="slide-area">
				<div class="formItemControl big">
					<textarea class="editor-area no-mce" wrap="off" id="description_bottom" name="description_bottom"><?=htmlspecialchars($description_bottom)?></textarea>
				</div>
			</div>
			
			<div class="admin-form-header"><span class="icon ic-icon ic-file-format-jpg"></span>Category Image</div>
			<table width="100%" cellpadding="0" cellspacing="0" border="0">
				<tr valign="top">
					<td class="formItemCaption">Image File</td>
					<td class="formItemControl">
						<input type="file" name="image" value="">
						<div class="formItemComment">(note: accepted file types are JPG, PNG and GIF)</div>
					</td>
				</tr>
	<?php
		if ($settings['CatalogCategoryThumbAuto'] == 'NO')
		{
	?>
				<tr valign="top">
					<td class="formItemCaption">Thumbnail Image</td>
					<td class="formItemControl">
						<input type="file" name="image_thumb">
					</td>
				</tr>
	<?php
		}
		$img_file = CategoryHasImage($cid);
		$thumb = CategoryHasThumb($cid);

		if ($img_file)
		{
			$size = getimagesize($img_file);
	?>
				<tr valign="top">
					<td class="formItemCaption"><b>Current Image:</b> (<?=$size[0]?>x<?=$size[1]?> pixels)</td>
					<td class="formItemControl">
						<input type="hidden" name="delete-category-image-nonce" id="delete-category-image-nonce" value="<?=create_nonce('category_delete_image');?>" />
						<img src="<?=$img_file?>?<?php echo filemtime($img_file); ?>" border="1" width="<?=$size[0]>500?500:$size[0]?>" border="0"><br/>
						<a href="javascript:ConfirmDeleteCategoryImage(<?=$cid?>)">Delete this image</a>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Thumbnail for this image</td>
					<td class="formItemControl">
	<?php
					if ($thumb)
					{
	?>
						<input type="hidden" name="delete-category-thumb-nonce" id="delete-category-thumb-nonce" value="<?=create_nonce('category_delete_thumb');?>" />
						<img src="<?=$thumb?>?<?=filemtime($thumb)?>" border="1"><br/>
						<a href="javascript:ConfirmDeleteCategoryThumb(<?=$cid?>)">Delete this image</a>
	<?php			
					}
					else
					{
						echo "There is no thumbnail for this image";
					}
	?>
					</td>
				</tr>
	<?php
		}
	?>
			</table>
		</div>
	</div>
	
<?php
	if ($settings["qr_active"] == "Yes" && $mode == "update")
	{
		require_once('content/classes/class.offsite_commerce_campaigns.php');
		$offsite_commerce_campaigns = new OffsiteCommerceCampaigns($db, $settings);
		$campaigns = $offsite_commerce_campaigns->getCampaigns("qr");

		loadJS('category_qr.js');
?>
	<div id="admin-tab-sheet-qr" class="admin-tab-sheet hidden">
		<div class="admin-tab-sheet-wrap">
			<div class="admin-form-header first"><span class="icon ic-icon ic-raster"></span>QR Code for this category</div>
			<table width="100%" cellpadding="0" cellspacing="0" border="0">
				<tr valign="top">
					<td class="formItemCaption">QR Campaign</td>
					<td class="formItemControl">
						<select id="qr-generate-campaign-id">
							<option value="">No campaign</option>
<?php
if ($campaigns)
{
	foreach ($campaigns as $campaign)
	{
		echo '<option value="'.$campaign["campaign_id"].'">'.htmlspecialchars($campaign["name"]).'</option>';
	}
}
?>
						</select>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Image type</td>
					<td class="formItemControl">
						<select class="short" id="qr-generate-image-type">
							<option value="<?php echo IMAGETYPE_PNG;?>" <?php echo $settings["qr_image_type"] == IMAGETYPE_PNG ? "selected" : "";?>>PNG</option>
							<option value="<?php echo IMAGETYPE_JPG;?>" <?php echo $settings["qr_image_type"] == IMAGETYPE_JPG ? "selected" : "";?>>JPG</option>
							<option value="<?php echo IMAGETYPE_GIF;?>" <?php echo $settings["qr_image_type"] == IMAGETYPE_GIF ? "selected" : "";?>>GIF</option>
						</select>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Media</td>
					<td class="formItemControl">
						<select id="qr-generate-media">
							<option value="1" <?php echo $settings["qr_media"] == "1" ? "selected" : "";?>>Web - Small</option>
							<option value="2" <?php echo $settings["qr_media"] == "2" ? "selected" : "";?>>Web - Big</option>
							<option value="3" <?php echo $settings["qr_media"] == "3" ? "selected" : "";?>>Print Ad - Small</option>
							<option value="4" <?php echo $settings["qr_media"] == "4" ? "selected" : "";?>>Print Ad - Big</option>
							<option value="5" <?php echo $settings["qr_media"] == "5" ? "selected" : "";?>>Parcel Label</option>
							<option value="6" <?php echo $settings["qr_media"] == "6" ? "selected" : "";?>>Factory Environment</option>
							<option value="0" <?php echo $settings["qr_media"] == "0" ? "selected" : "";?>>Custom</option>
						</select>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Error correction level</td>
					<td class="formItemControl">
						<select class="short" id="qr-generate-error-check">
							<option value="L">Low</option>
							<option value="M" <?php echo $settings["qr_error_check"] == "M" ? "selected" : "";?>>Medium</option>
							<option value="Q" <?php echo $settings["qr_error_check"] == "Q" ? "selected" : "";?>>Good</option>
							<option value="H" <?php echo $settings["qr_error_check"] == "H" ? "selected" : "";?>>The best</option>
						</select>
						<div class="formItemComment">
							Low - approx. 7% of codewords can be restored.<br/>
							Medium - approx. 15% of codewords can be restored.<br/>
							Good - approx. 25% of codewords can be restored.<br/>
							The best - approx. 30% of codewords can be restored.
						</div>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Pixels per QR Code dot</td>
					<td class="formItemControl">
						<select class="short" id="qr-generate-default-size">
<?php
	for($i=4; $i<=12; $i++)
	{
?>
							<option value="<?php echo $i;?>" <?php if($settings["qr_default_size"] == $i) echo "selected";?>><?php echo $i;?></option>
<?php
	}
?>
						</select>
						<div class="formHelp">QR Code dot size in pixels</div>
					</td>
				</tr>
			</table>
			<div class="admin-form-buttons">
				<input type="button" value="Generate" id="qr-generate-button"/>
			</div>

			<div id="dialog-qr-generated" style="display:none;">
				<div>
					<img id="dialog-qr-generated-image" src="images/icons/a/raster.png"/><br/>
					<div id="dialog-qr-generated-link-url"></div>
				</div>
			</div>
			<iframe id="iframe-qr-download" style="display:none"></iframe>
		</div>
	</div>
<?php	
	}
?>
</div>
<div class="admin-form-buttons">
	<input type="submit" value="Save changes" default="default"/>
	<input type="reset" value="Reset form"/>
</div>
</form>
