<?php
/**
 * Process category
 */

	if (!defined("ENV")) exit();
	
	$mode = isset($mode)?trim($mode):"";
	$parent = isset($parent)?intval($parent):TREE_ROOT;
	$name = isset($name)?trim($name):"";
	$key_name = isset($key_name)?trim($key_name):"";
	$description = isset($description)?trim($description):"";
	$description_bottom = isset($description_bottom)?trim($description_bottom):"";
	$cid = isset($cid)?intval($cid):0;
	$priority = isset($priority)?intval($priority):5;
	$is_visible = isset($is_visible)?trim($is_visible):"No";
	$list_subcats = isset($list_subcats)?trim($list_subcats):"No";
	$list_subcats_images = isset($_POST['list_subcats_images']) ? 1 : 0;
	$may_upload_image = false;

	$image = isset($image)?$image:"";
	
	$meta_title = isset($meta_title)?trim($meta_title):"";
	$meta_keywords = isset($meta_keywords)?trim($meta_keywords):"";
	$meta_description = isset($meta_description)?trim($meta_description):"";
	$category_header = isset($category_header)?trim($category_header):"";
	$url_custom = isset($url_custom)?$url_custom:"";
	$generate_url = false;
	
	//check category id exists
	$duplicate_category_key = false;
	if($mode == "insert" || $mode == "update"){
		$db->query("SELECT cid, name FROM ".DB_PREFIX."catalog WHERE key_name = '".$db->escape($key_name)."' AND cid<>'".$cid."'");
		if($db->moveNext()){
			$duplicate_category_key = true;
			$key_name = substr(md5(uniqid(rand(),1)), rand(0, 10), 16); 
		}
	}
	
	$nonce_valid = verify_nonce($nonce, 'category_'.$mode);
	if (!$nonce_valid)
	{
		invalid_nonce_message();
		exit;
	}
	
	switch($mode){
/////////////////////
// INSERT CATEGORY
		case "insert" : {
			if($parent==TREE_ROOT){
				$level = 1;
				$parent_name = "Root";
			}
			else{
				$db->query("SELECT * FROM ".DB_PREFIX."catalog WHERE cid ='".$parent."'");
				if($db->moveNext()){
					$level = $db->col["level"] + 1;
					$parent_name = $db->col["name"];
					$is_visible = $db->col["is_visible"] == "No"?"No":$is_visible;
				}
				else{
					$level = 1;
					$parent_name = "Root";
					$is_visible = "No";
				}
			}
			if(!DEMO_LOCK){
				$db->reset();
				$db->assign("parent", $parent);
				$db->assignStr("is_visible", $is_visible);
				$db->assignStr("list_subcats", $list_subcats);
				$db->assignStr("list_subcats_images", $list_subcats_images);
				$db->assign("level", $level);
				$db->assign("priority", $priority);
				$db->assignStr("key_name", $key_name);
				$db->assignStr("name", $name);
				$db->assignStr("meta_title", $meta_title);
				$db->assignStr("meta_keywords", $meta_keywords);
				$db->assignStr("meta_description", $meta_description);
				$db->assignStr("url_custom", $url_custom);
				$db->assignStr("category_header", $category_header);
				$db->assignStr("description", $description);
				$db->assignStr("description_bottom", $description_bottom);
				$cid = $db->insert(DB_PREFIX."catalog");
				$generate_url = true;
				$may_upload_image = true;
				
				pageHeader("Category Added", "", "icb-folder");
				
				pageNote(array(
					array("class"=>"ic-info", "text"=>"<b>New products category has been successfully created</b>", "url"=>"", "visible"=>true),
					array("class"=>"ic-warning", "text"=>"<b><span style=\"color:#dd0000\">Duplicate Categrory Key - the category you entered contained a Category Key already found in the database. The category was assigned a New Category Key. To change it, please go to edit category.</span></b>", "url"=>"", "visible"=>$duplicate_category_key)
				));
				
				pageWhat(array(
					array("text"=>"Edit just added category", "url"=>"admin.php?p=category&mode=update&cid=".$cid),
					array("text"=>"Add new category again", "url"=>"admin.php?p=category&mode=insert&parent=".$parent),
					array("text"=>"Add subcategory into created category", "url"=>"admin.php?p=category&mode=insert&parent=".$cid),
					array("text"=>"Browse categories", "url"=>"admin.php?p=categories")
				));
			}
			else
			{
				pageHeader("Category Added", "", "icb-folder");
				
				pageNote(array(
					array("class"=>"ic-info", "text"=>"<b>New products category has been successfully created</b>", "url"=>"", "visible"=>true),
					array("class"=>"ic-warning", "text"=>"<b><span style=\"color:#dd0000\">Duplicate Categrory Key - the category you entered contained a Category Key already found in the database. The category was assigned a New Category Key. To change it, please go to edit category.</span></b>", "url"=>"", "visible"=>$duplicate_category_key)
				));
				
				pageWhat(array(
					array("text"=>"Add new category again", "url"=>"admin.php?p=category&mode=insert&parent=".$parent),
					array("text"=>"Add subcategory into created category", "url"=>"admin.php?p=category&mode=insert&parent=".$cid),
					array("text"=>"Browse categories", "url"=>"admin.php?p=categories")
				));
			}
			break;
		}
////////////////////////
// UPDATE CATEGORY
		case "update" : {
			if(!DEMO_LOCK){
				if($parent==TREE_ROOT){
					$level = 1;
					$parent_name = "Root";
				}
				else{
					$db->query("SELECT * FROM ".DB_PREFIX."catalog WHERE cid ='".$parent."'");
					if($db->moveNext()){
						$level = $db->col["level"] + 1;
						$parent_name = $db->col["name"];
						$is_visible = $db->col["is_visible"] == "No"?"No":$is_visible;
					}
				}
				// update children levels
				$db->query("SELECT * FROM ".DB_PREFIX."catalog ORDER BY level, name");
				$tree = new DB_TREE();
				$tree->collection[TREE_ROOT] = (new DB_TREE_NODE(TREE_ROOT, -1, 0, "Yes", "Root"));
		
				$db->query("SELECT * FROM ".DB_PREFIX."catalog ORDER BY level, name");
				while($db->moveNext()){
					$tree->addNode(
						new DB_TREE_NODE(
							$db->col["cid"], 
							$db->col["parent"], 
							$db->col["level"], 
							$db->col["is_visible"],
							$db->col["name"]
						)
					);
				}
				
				function ScanTree($db, $nodes, $parent_id, $new_level, $visible, $do_update, $got_parent){
					reset($nodes);
					foreach ($nodes as $id => $node)
					{
						if($do_update){
							//is_visible='".$visible."' removed according to bug 208
							//$db->query("UPDATE ".DB_PREFIX."catalog SET level='".$new_level."', is_visible='".$visible."' WHERE cid='".($node->id)."'");
							$db->query("UPDATE ".DB_PREFIX."catalog SET level='".$new_level."' WHERE cid='".($node->id)."'");
							//echo "Updating node : ".$node->caption."; new level: ".$new_level."; node id:".$node->id."; is_visible:".$visible."<br>";
						}
						if($got_parent){
						//is_visible='".$visible."' commented according to bug 208
						//	$db->query("UPDATE ".DB_PREFIX."catalog SET is_visible='".$visible."' WHERE cid='".($node->id)."'");
						}
						if(count($node->nodes)>0){
							//echo "Compare nodes : ".$node->id." - ".$parent_id."<br>";
							if($node->id==$parent_id){
								//echo "Parent detected : ".$node->caption."<br>";
								$new_level +=1;
								ScanTree($db, $node->nodes, $parent_id, $new_level + ($do_update?1:0), $visible, true, true);
							}
							else{
								ScanTree($db, $node->nodes, $parent_id, $new_level + ($do_update?1:0), $visible, false, $got_parent);
							}
						}
					}
				}
				
				ScanTree($db, $tree->collection[TREE_ROOT]->nodes, $cid, $level, $is_visible, false, false);
				
				$db->reset();
				$db->assign("parent", $parent);
				$db->assignStr("is_visible", $is_visible);
				$db->assignStr("list_subcats", $list_subcats);
				$db->assignStr("list_subcats_images", $list_subcats_images);
				$db->assign("level", $level);
				$db->assign("priority", $priority);
				$db->assignStr("key_name", $key_name);
				$db->assignStr("name", $name);
				$db->assignStr("meta_title", $meta_title);
				$db->assignStr("meta_keywords", $meta_keywords);
				$db->assignStr("meta_description", $meta_description);
				$db->assignStr("url_custom", $url_custom);
				$db->assignStr("category_header", $category_header);
				$db->assignStr("description", $description);
				$db->assignStr("description_bottom", $description_bottom);
				$db->update(DB_PREFIX."catalog", "WHERE cid='".$cid."'");
				$generate_url = true;
				$may_upload_image = true;
			}
			
			pageHeader("Category Updated", "", "icb-folder");
			
			pageNote(array(
				array("class"=>"ic-info", "text"=>"<b>Category data has been successfully updated</b>", "url"=>"",  "visible"=>true),
				array("class"=>"ic-warning", "text"=>"<b><span style=\"color:#dd0000\">Duplicate Categrory Key - the category you entered contained a Category Key already found in the database. The category was assigned a New Category Key. To change it, please go to edit category.</span></b>", "url"=>"", "visible"=>$duplicate_category_key)
			));
			
			pageWhat(array(
				array("text"=>"Back to category editing", "url"=>"admin.php?p=category&mode=update&cid=".$cid),
				array("text"=>"Add new category", "url"=>"admin.php?p=category&mode=insert&parent=".$parent),
				array("text"=>"Add subcategory into last category", "url"=>"admin.php?p=category&mode=insert&parent=".$cid),
				array("text"=>"Browse categories", "url"=>"admin.php?p=categories")
			));
			break;
		}
////////////////////////
// DELETE CATEGORY
		case "delete" : {
			if (!Admin_CategoryProcess::canRemoveCategory($cid, $db))
			{
				pageHeader("Can't Delete Category", "", "icb-folder");
				pageNote(array(
					array("class"=>"ic-cross", "text"=>"<b>Can't delete category while it contains subcategories and products</b>", "url"=>"",  "visible"=>true)
				));
				pageWhat(array(
					array("text"=>"Browse categories", "url"=>"admin.php?p=categories"),
					array("text"=>"Browse products", "url"=>"admin.php?p=products")
					
				));
			}
			else{
				Admin_CategoryProcess::deleteCategory($cid, $db);
				pageHeader("Category Removed", "", "icb-folder");
				pageNote(array(
					array("class"=>"ic-info", "text"=>"<b>Category has been successfully removed</b>", "url"=>"",  "visible"=>true)
				));
				pageWhat(array(
					array("text"=>"Browse categories", "url"=>"admin.php?p=categories"),
					array("text"=>"Add new category", "url"=>"admin.php?p=category&mode=insert")
				));
			}
			break;
		}
		case "bulkDelete" : {
			$categories_deleted = true;
			if (isset($_REQUEST['cids']))
			{
				$categories_deleted = Admin_CategoryProcess::bulkDeleteCategories($_REQUEST['cids'], $db);
			}
			if (count($categories_deleted) == 0)
			{
				pageHeader("Categories Removed", "", "icb-folder");
				pageNote(array(
					array("class"=>"ic-info", "text"=>"<b>Category has been successfully removed</b>", "url"=>"",  "visible"=>true)
				));
			}
			else
			{
				pageHeader("Couldn't delete all categories", "", "icb-folder");
				foreach ($categories_deleted as $cid)
				{
					$category = Admin_CategoryProcess::getCategory($cid, $db);

					pageNote(array(
						array("class"=>"ic-info", "text"=>"<b>".$category['name']." - Can't delete category while it contains subcategories and/or products</b>", "url"=>"admin.php?p=category&mode=update&cid=$cid",  "visible"=>true)
					));
				}
			}
			pageWhat(array(
				array("text"=>"Browse categories",	"url"=>"admin.php?p=categories"),
				array("text"=>"Add new category",	"url"=>"admin.php?p=category&mode=insert")
			));
			break;
		}
		case "delete_image" : {
			$img_file = CategoryHasImage($cid);
			if($img_file){
				if(!DEMO_LOCK){
					if(@unlink($img_file)){
						pageHeader("Image Removed", "", "icb-folder");
						pageNote(array(
							array("class"=>"ic-info", "text"=>"<b>Category image has been successfully removed</b>", "url"=>"",  "visible"=>true)
						));
					}
					else{
						pageHeader("Can't Delete Category Image", "", "icb-folder");
						pageNote(array(
							array("class"=>"ic-info", "text"=>"<b>Please check does image file exists and file permissions</b>", "url"=>"",  "visible"=>true)
						));
					}
				}
				else{
					pageHeader("Can't Delete Category Image", "", "icb-folder");
					pageNote(array(
						array("class"=>"ic-info", "text"=>"<b>Please check does image file exists and file permissions</b>", "url"=>"",  "visible"=>true)
					));
				}
			}
			else{
				pageHeader("Can't Delete Category Image", "", "icb-folder");
				pageNote(array(
					array("class"=>"ic-cross", "text"=>"<b>Category image file does not exists</b>", "url"=>"",  "visible"=>true)
				));
			}
			pageWhat(array(
				array("text"=>"Back to category editing", "url"=>"admin.php?p=category&mode=update&cid=".$cid),
				array("text"=>"Browse categories", "url"=>"admin.php?p=categories"),
				array("text"=>"Add new category", "url"=>"admin.php?p=category&mode=insert")
			));
			break;
		}
		
		case "delete_thumb" : {
			$img_file = CategoryHasThumb($cid);
			if($img_file){
				if(!DEMO_LOCK){
					if(@unlink($img_file)){
						pageHeader("Thumbnail Removed", "", "icb-folder");
						pageNote(array(
							array("class"=>"ic-info", "text"=>"<b>Category thumbnail image has been successfully removed</b>", "url"=>"",  "visible"=>true)
						));
					}
					else{
						pageHeader("Can't Delete Category Image", "", "icb-folder");
						pageNote(array(
							array("class"=>"ic-info", "text"=>"<b>Please check does image file exists and file permissions</b>", "url"=>"",  "visible"=>true)
						));
					}
				}
				else{
					pageHeader("Can't Delete Category Thumbnail Image", "", "icb-folder");
					pageNote(array(
						array("class"=>"ic-info", "text"=>"<b>Please check does image file exists and file permissions</b>", "url"=>"",  "visible"=>true)
					));
				}
			}
			else{
				pageHeader("Can't Delete Category Thumbnail Image", "", "icb-folder");
				pageNote(array(
					array("class"=>"ic-cross", "text"=>"<b>Category image file does not exists</b>", "url"=>"",  "visible"=>true)
				));
			}
			pageWhat(array(
				array("text"=>"Back to category editing", "url"=>"admin.php?p=category&mode=update&cid=".$cid),
				array("text"=>"Browse categories", "url"=>"admin.php?p=categories"),
				array("text"=>"Add new category", "url"=>"admin.php?p=category&mode=insert")
			));
			break;
		}
////////////////////////
// INCORRECT ACTION
		default : {
			pageHeader("Incorrect Action", "", "icb-folder");
			pageWhat(array(
				array("text"=>"Browse categories", "url"=>"admin.php?p=categories"),
				array("text"=>"Add new category", "url"=>"admin.php?p=category&mode=insert&parent=".$parent)
			));
		}
	}

//////////////////////////
// GENERATE SEO URLs
	if($generate_url)
	{
		//render URL
		updateSeoURLs($db, $settings, true, true, false, true);
	}
	
//////////////////////////
// UPLOAD CATEGORY IMAGE

	if (!DEMO_LOCK && in_array($mode, array("insert", "update")) && $may_upload_image)
	{
		try
		{
			// Resizing fullsize image if necessary
			if (@isset($_FILES["image"]["tmp_name"]) && trim($_FILES["image"]["tmp_name"]) != "" && is_uploaded_file($_FILES["image"]["tmp_name"]))
			{
				$destination = 'images/catalog/category'.$cid.'.'.strtolower(File_Utility::getFileExtension($_FILES["image"]["name"]));
				
				if (@copy($_FILES["image"]["tmp_name"], $destination))
				{
					Admin_CategoryProcess::uploadImage($_FILES["image"]["tmp_name"], $destination, false);
				}
			}
			
			// Create a new thumbnail image when necessary
			if (
				$settings['CatalogCategoryThumbAuto'] == 'YES' || 
				(isset($_FILES['image_thumb']['tmp_name']) && trim($_FILES['image_thumb']['tmp_name']) != '' && is_uploaded_file($_FILES['image_thumb']['tmp_name'])) )
			{
				$thumbnail_source = ($settings['CatalogCategoryThumbAuto'] == 'YES' && @isset($_FILES['image']['tmp_name']))
					? $_FILES['image']
					: $_FILES['image_thumb'];
				
				$destination_thumbnail = $catalog_thumbs_dir.'/category'.$cid.'.'.strtolower(File_Utility::getFileExtension($thumbnail_source['name']));
				
				if (@copy($thumbnail_source['tmp_name'], $destination_thumbnail))
				{
					Admin_CategoryProcess::uploadImage($thumbnail_source['tmp_name'], $destination_thumbnail, true);
				}
			}
		}
		catch (Exception $e)
		{
			$error = $e->getMessage();
			pageNote(array(
				array("class"=>"ic-cross", "text"=>"<strong>Can't upload category image.</strong><p>".$e->getMessage()."</p>", "url"=>"",  "visible"=>true)
			));
		}
	}
?>
