<?php
/**
 * Charts
 */

	if (!defined("ENV")) exit();
	
	header('Cache-Control: cache, must-revalidate');
	header('Pragma: public');
	
	$repo = DataAccess_Repository::get('ChartRepository');
	$year  = isset($year)  ? intval($year)  : date('Y');
	$month = isset($month) ? intval($month) : date('m');
	
	switch($mode)
	{
		/**
		 * Usage statistics by month (hits)
		 */
		default:
		case "usage_by_month_hits" :
		{
			$chart = $repo->getUsageHitsByMonth($month, $year);
			break;
		}

		/**
		 * Usage statistics by month (unique hosts)
		 */
		case "usage_by_month_hosts" : 
		{
			$chart = $repo->getUsageHostsByMonth($month, $year);
			break;
		}

		/**
		 * Sales statistics by month
		 */
		case "sales_by_month" :
		{
			$chart = $repo->getSalesByMonth($month, $year);
			break;
		}
	}
	
	print $chart->asFlot();