<?php
	if (!defined("ENV")) exit();
	loadJS("email_list.js");
	pageHeader("Manage Subscriber Email Addresses", "", "icb-envelope2-right");
	pageNote(array(
		array("class"=>"ic-info", "text"=>"<b>Please enter in your search criteria.</b><br>You need to enter at least one search criteria for search to be effective
		<br> Please use \"Search by email\" option to get search result from registered user's database.", "url"=>"", "visible"=>true),
	));
	
	$action = isset($_GET["action"])?trim($_GET["action"]):"";
	$search_where = isset($_GET["search_where"])?trim($_GET["search_where"]):"";
	$search_by = isset($_GET["search_by"])?trim($_GET["search_by"]):"date";
	$fromdate = isset($fromdate)?trim($fromdate):"";
	$email = isset($email)?trim($email):"";
	$todate = isset($todate)?trim($todate):"";
	
	$date_select = isset($date_select)?trim($date_select):"";
	$email_select = isset($email_select)?trim($email_select):"";
	
	// Setting date
	$from_y = isset($from_y)?$from_y:date("Y");
	$from_m = isset($from_m)?$from_m:date("n");
	$from_d = isset($from_d)?$from_d:1;
	$to_y = isset($to_y)?$to_y:date("Y");	
	$to_m = isset($to_m)?$to_m:date("n");
	$to_d = isset($to_d)?$to_d:date("t", mktime(1,1,1,$to_m, 1, $to_y));
	
	// Select MailList Base
	$mlist = isset($mlist)?$mlist:"news";
	//switch($search_where) {
	switch ($mlist)
	{
		default :
    	case "all" : { $query_params = "(updates = 'Yes' OR newsletters = 'Yes')"; break; }
	    case "news" : { $query_params = "(newsletters = 'Yes')"; break; }
	    case "update" : { $query_params = "(updates = 'Yes')"; break; }
		case "empty" : { $query_params = "(updates = 'No' OR newsletters = 'No')"; break; }
	}	

	// Select Search criteria (by date, by e-mail, or date + e-mail)
	if ($search_by == "date")
	{
		// Setting search limits by date
		$mysql_from =  $from_y."-".$from_m."-".$from_d;
		$mysql_to =  $to_y."-".$to_m."-".$to_d;
		$query_params .=  " AND added >= '".($mysql_from)." 00:00:01' AND added <= '".($mysql_to)." 23:59:59'";
	}
	
	// Setting search  by e-mail
	if ($search_by == "email") 
	{
  		$query_params .=  " AND email LIKE '%".$email."%'";  		
	}
	
?>
	<div class="admin-search-form clearfix">
		<div class="admin-search-form-header">Search Subscribers Base</div>
		
		<div class="admin-search-form-wrap clearfix">
			<div class="admin-search-form-subheader">Search By Date</div>
			<div class="admin-search-form-subheader">Search By Email</div>
			<div class="admin-search-form-item">
				<form action="admin.php?p=email_list" method="get" name="frmFilter1">
					<input type="hidden" name="p" value="email_list"/>
					<input type="hidden" name="action" value="search"/>
					<input type="hidden" name="email_select" value="on"/>
					<input type="hidden" name="mlist" value="news"/>
					<input type="hidden" name="search_by" value="date"/>
					<label>From:</label>
					<select name="from_m" style="width:120px;">
						<?php for($i=1; $i<=12; $i++){?><option value="<?=$i?>" <?=$i == $from_m?"selected":""?>><?=$months[$i]?></option><?}?>
					</select>
					<select name="from_d" style="width:57px;">
						<?php for($i=1; $i<=31; $i++){?><option value="<?=$i?>" <?=$i == $from_d?"selected":""?>><?=$i?></option><?}?>
					</select>
					<select name="from_y" style="width:75px;">
						<?php for($i=2004; $i<=date("Y")+10; $i++){?><option value="<?=$i?>" <?=$i == $from_y?"selected":""?>><?=$i?></option><?}?>
					</select>
					<br/><br/>

					<label>To:</label>
					<select name="to_m" style="width:120px;">
						<? for($i=1; $i<=12; $i++){?><option value="<?=$i?>" <?=$i == $to_m?"selected":""?>><?=$months[$i]?></option><?}?>
					</select>
					<select name="to_d" style="width:57px;">
						<? for($i=1; $i<=31; $i++){?><option value="<?=$i?>" <?=$i == $to_d?"selected":""?>><?=$i?></option><?}?>
					</select>
					<select name="to_y" style="width:75px;">
						<? for($i=2004; $i<=date("Y")+10; $i++){?><option value="<?=$i?>" <?=$i == $to_y?"selected":""?>><?=$i?></option><?}?>
					</select>
					<div class="admin-form-buttons admin-search-form-buttons">
						<input type="submit" value="Search Users"/>
					</div>
				</form>
			</div>

			<div class="admin-search-form-item">
				<form action="admin.php?p=email_list" method="get" name="frmFilter2">
					<input type="hidden" name="p" value="email_list"/>
					<input type="hidden" name="action" value="search"/>
					<input type="hidden" name="email_select" value="on"/>
					<input type="hidden" name="mlist" value="news"/>
					<input type="hidden" name="search_by" value="email"/>
					<label>Search by email:</label>
					<input type="text" name="email" value="<?=htmlspecialchars($email)?>"/>
					<div class="admin-form-buttons admin-search-form-buttons">
						<input type="submit" value="Search Users"/>
					</div>
				</form>
			</div>
		</div>
	</div>


<?php
	if ($action == "search")
	{
		$db->query("
			SELECT eid, date_format(added,'%m-%d-%Y %H:%i') as added, email, newsletters, updates  
			FROM ".DB_PREFIX."emails WHERE ".$query_params."
			ORDER BY ".($search_by == "email"?"email":"added")."
		");
?>
<br/>&nbsp;<br/>
<div class="listHeader" style="clear:both;">
	<div class="listHeaderIcon">&nbsp;</div>
	<div class="listHeaderCaption" style="width:280px;">Email Address</div>
	<div class="listHeaderCaption" style="width:180px;">Added At</div>
</div>
<form name="frmEmails" id="frmEmails" action="admin.php?p=email_process" method="post">
	<input type="hidden" name="mode" value="globaldelete"/>
<?php
		if ($db->numRows()>0)
		{
			while ($db->moveNext())
			{
?>
	<div class="listItem">
		<div class="listItemIcon">
			<input type="checkbox" class="checkbox-email" name="emails[<?=$db->col["eid"]?>]" value="<?=$db->col["eid"]?>">
		</div>	
		<div class="listItemText" style="width:280px;"><a href="mailto:<?=($db->col["email"])?>"><?=htmlspecialchars(substr($db->col["email"], 0, 50))?><?=strlen($db->col["email"])>50?"...":""?></a></div>
		<div class="listItemText" style="width:180px;"><?=htmlspecialchars($db->col["added"])?></div>
		<div class="listItemButtons">
			<a href="admin.php?p=email_edit&mode=select&eid=<?=$db->col["eid"]?>"><img src="images/icons/a/pencil.png" border="0" title="Edit email"></a>
			<a href="javascript:ConfirmDeleteEmail(<?=$db->col["eid"]?>)"><img src="images/icons/a/delete.png" title="Delete email from subscribers list" border="0"></a>&nbsp;
		</div>
	</div>
<?php
			}
?>		

<div class="listFooter">
	<div class="listFooterCaption">
		<a href="javascript:checkBoxes(true)">check all</a> | 
		<a href="javascript:checkBoxes(false)">uncheck all</a>
	</div>
</div>
<div class="listButtons">
	<input type="submit" value="Delete checked"/>
</div>
</form>

<?php
		}
		else
		{
?>
<div class="listEmpty">
	No Results Were Found. Please Check Search Criteria.<br/>&nbsp;<br/>
</div>
<?
		}
 		
?>
</div>
<?php
	} 
?>