<?php
	if (!defined("ENV")) exit();
	
	$db->query("SELECT COUNT(*) AS c FROM ".DB_PREFIX."users WHERE newsletters='Yes' AND removed='No'");
	$db->moveNext(); $c = $db->col["c"];
	
	$db->query("SELECT COUNT(*) AS c FROM ".DB_PREFIX."emails WHERE newsletters='Yes'");
	$db->moveNext(); $c = $c + $db->col["c"];
	
	if ($c > 1001)
	{
		pageHeader("Newsletter Email Wizard", "", "icb-wizard");
		pageNote(array(
			array("class"=>"ic-info", "text"=>
			"You currently have over 1001 email addresses subscribed to receive your newsletter. This exceeds the number of emails that can be sent out using this system.<br/><br/>". 
			"We suggest you export your email address to our partner, Mail Chimp or use another third-party email system to manage your newsletters.<br/><br/>".
			"Our integration with MailChimp will automatically sync your users email addresses to your MailChimp account making newsletter management a breeze.<br/><br/>". 
			"<img src=\"images/admin/mailchimp_sm.png\"/><br/><br/>".
			"To learn more about MailChimp, <a target=\"_blank\" href=\"http://eepurl.com/L3JD\">click here</a>.<br/><br/>".
			"If you'd like to export your email addresses to import to another program, <a href=\"admin.php?p=users_emails&mode=subscribers\">click here</a>.", 
			"url"=>"", "visible"=>true),
		));
	}
	else
	{
		$mode = isset($mode)?trim($mode):"insert";
		$eid = isset($eid)?$eid*1:0;
		$step = isset($step)?$step*1:1;
		$step = in_array($step, array(1,2,3))?$step:1;
	
		$skin_name = $settings["DesignSkinName"];
		
		$hint_texts = 
			array(
				"1" => 
					"You can insert HTML and text versions of your newsletter. ".
					"Step two will allow you to preview the message you have created before it is sent.<br/>".
					"Adding a top (header) and bottom (footer) to the newsletter will improve its appearance. ".
					"To create the top and bottom click on the link in the left hand navigation.",
			
				"2" => 
					"Please review both the HTML and TEXT versions of your newsletter.<br>".
					"To make changes, please select \"Edit email\" below."
				);
				
		pageHeader("Newsletter Email Wizard", "step ".gs($step)." of 3", "icb-wizard");
		
		if (DEMO_LOCK)
		{
			pageNote(array(
				array("class"=>"ic-info", "text"=>"This feature is not available in Demo Mode", "url"=>"", "visible"=>true),
			));
		}
		else
		{
			if ($step < 3)
			{
				pageNote(array(
					array("class"=>"ic-info", "text"=>$hint_texts[$step], "url"=>"", "visible"=>true),
				));
			}
		
			loadJS("cf_email.js");
		
			if ($step < 3)
			{
?>
	<div class="admin-tabs admin-tabs-framed" id="tabs-newsletter">
<?php 
				pageTabs(array(
					array("title"=>"Newsletter Email", "id"=>"main"),
				), "tabs-newsletter", false);
?>
		<div id="admin-tab-sheet-main" class="admin-tab-sheet">
			<div class="admin-tab-sheet-wrap">
<?php
			}
			switch($step)
			{
				/**
				 * Edit email
				 */
				case 1 :
				{
					//////////////////////////
					// EDIT EMAILS
					$body_html = readTemplateFile("templates/emails/newsletter_body_html.html");
					$body_text = readTemplateFile("templates/emails/newsletter_body_text.html");
					
					if ($mode=="insert")
					{
						$from_name = "";//$auth_admin_name;
						$from_email = "";//$auth_admin_email;
						$subject = "";//$settings["CompanyName"].": Newsletter!";
					}
					else
					{
						$db->query("SELECT * FROM ".DB_PREFIX."emails_archive WHERE eid='".$eid."'");
						if ($db->moveNext())
						{
							$from_name = $db->col["from_name"];
							$from_email = $db->col["from_email"];
							$subject = $db->col["subject"];
						}
					}
?>
				<form name="frmEmail" action="admin.php?p=email_newsletter&step=2&hidemenus=true" method="post" onSubmit="return checkEmailForm(this)">
					<input type="hidden" name="eid" value="<?=$eid?>">
					<input type="hidden" name="mode" value="<?=gs($mode)?>">
					
					<div class="admin-form-header first"><span class="icon ic-icon ic-checkmark"></span>Newsletter Email Properties</div>
					<table width="100%" cellpadding="0" cellspacing="0" border="0">
						<tr valign="top">
							<td class="formItemCaption required">Subject</td>
							<td class="formItemControl"><input type="text" name="subject" value="<?=htmlspecialchars($subject)?>"></td>
						</tr>
						<tr valign="top">
							<td class="formItemCaption"><b>From Name</b></td>
							<td class="formItemControl"><input type="text" name="from_name" value="<?=htmlspecialchars($from_name)?>"></td>
						</tr>
						<tr valign="top">
							<td class="formItemCaption"><b>From Email</b></td>
							<td class="formItemControl"><input type="text" name="from_email" value="<?=htmlspecialchars($from_email)?>"></td>
						</tr>
					</table>
					
					<div class="admin-form-header editor-manager"><span class="icon ic-icon ic-pencil"></span>Content for HTML Email</div>
					<div class="formItemControl big">
						<textarea wrap="off" cols="50" rows="8" id="body_html" class="no-mce editor-area" name="body_html"><?=htmlspecialchars($body_html)?></textarea>
					</div>
					
					<div class="admin-form-header"><span class="icon ic-icon ic-pencil"></span>Content for Text Email</div>
					<div class="formItemControl big">
						<textarea class="no-mce" wrap="off" cols="50" class="no-mce" rows="8" name="body_text"><?=htmlspecialchars($body_text)?></textarea>
					</div>
					
					<div class="admin-form-buttons">
						<input type="submit" value="Preview email"/>
					</div>
				</form>
<?php
					break;
				}
				
				/**
				 * GENERATE EMAIL USE Smarty
				 */
				case 2 : 
				{
					$action = isset($action)?trim($action):"";
					$eid = isset($eid)?$eid:0;
		
					if ($action == "test_email")
					{
						$db->query("SELECT * FROM ".DB_PREFIX."emails_archive WHERE eid='".intval($eid)."'");
						if ($db->moveNext())
						{
							$test_email = isset($test_email)?trim($test_email):"";
							require_once("content/engine/engine_notifications.php");
		
							$content_text = trim($db->col["content_text"]);
							$content_html = trim($db->col["content_html"]);
							$from_email = trim($db->col["from_email"]);
							$from_name = trim($db->col["from_name"]);
							$subject = trim($db->col["subject"]);
		
							if ($content_text != "")
							{
								send_mail($test_email, $subject, $content_text, array('name' => $from_name, 'email' => $from_email), "text");
							}
							if ($content_html != "")
							{
								send_mail($test_email, $subject, $content_html, array('name' => $from_name, 'email' => $from_email), "html");
							}
						}
					}
					else
					{
						//save body templates
						if(
							(!writeTemplateFile("templates/emails/newsletter_body_html.html", $body_html) && strlen(trim($body_html)) > 0) ||
							(!writeTemplateFile("templates/emails/newsletter_body_text.html", $body_text) && strlen(trim($body_text)) > 0)
						)
						{
							pageNote(array(
								array(
									"class"=>"ic-cross", 
									"message"=>
										"<strong>Please Note: Changes are not saved! Please check files write permissions and click \"Back\"<br/>".
										"button in your browser! Unsaved files are:</strong><ul>".
										"<li>content/skins/".$skin_name."/templates/emails/newsletter_body_html.html</li>".
										"<li>content/skins/".$skin_name."/templates/emails/newsletter_body_text.html</li></ul>
								")
							));
						}
	
						require("content/admin/admin_init_smarty.php");
		
						view()->assign("EmailTitle", "Newsletter");
		
						//get email HTML & TEXTs
						if (strlen(trim($body_html)) > 0)
						{
							$email_html = view()->fetch("templates/emails/newsletter_html.html");
						}
		
						if (strlen(trim($body_text)) > 0)
						{
							$email_text = view()->fetch("templates/emails/newsletter_text.html");
						}
						$db->reset();
						$db->assignStr("sent", "No");
						$db->assignStr("type", "newsletter");
						$db->assignStr("subject", $subject);
						$db->assignStr("content_html", $email_html);
						$db->assignStr("content_text", $email_text);
						$db->assignStr("from_name", $from_name);
						$db->assignStr("from_email", $from_email);
						
						if ($mode == "update")
						{
							$db->update(DB_PREFIX."emails_archive", "WHERE eid='".$eid."'");
						}
						else
						{
							$eid = $db->insert(DB_PREFIX."emails_archive");
						}
					}
?>
					<div class="admin-form-header first"><span class="icon ic-icon ic-document"></span>HTML Email</div>
					<div class="formItemControl big">
						<iframe width="100%" height="230" src="admin.php?p=email_preview&eid=<?=$eid?>&mode=html&chart"></iframe>
					</div>
					
					<div class="admin-form-header"><span class="icon ic-icon ic-document"></span>Text Email</div>
					<div class="formItemControl big">
						<iframe width="100%" height="230" src="admin.php?p=email_preview&eid=<?=$eid?>&mode=text&chart"></iframe>
					</div>
					
					<form name="frmEmail" action="admin.php?p=email_newsletter&step=2&hidemenus=true" method="post">
						<input type="hidden" name="action" value="test_email">
						<input type="hidden" name="eid" value="<?=$eid?>">
						<div class="admin-form-header"><span class="icon ic-icon ic-envelope"></span>Send Test Email</div>
						<table cellpading="0" cellspacing="0" border="0" width="100%">
							<tr valign="top">
								<td class="formItemCaption" style="padding-top:10px;">Test Email Address</td>
								<td class="formItemControl">
									<div style="float:left;width:270px;padding-top:3px;"><input type="text" name="test_email" value="<?=htmlspecialchars(isset($test_email)?$test_email:$auth_admin_email)?>"/></div>
									<div style="float:left;width:120px;"><input type="submit" value="Test email"/></div>
								</td>
							</tr>
						</table>
					</form>
					
					<form name="frmEmail" action="admin.php?p=email_newsletter&step=3" method="post" onSubmit="return confirmSendEmailNewsletters()">
						<div class="admin-form-buttons">
							<input type="hidden" name="eid" value="<?=$eid?>"/>
							<input type="button" value="Edit email" onClick="document.location='admin.php?p=email_newsletter&step=1&mode=update&eid=<?=$eid?>'"/>
							<input type="submit" value="Send email"/>
						</div>
					</form>
<?php
					break;
				}
				
				/**
				 * Send email
				 */
				case 3 :
				{
					$sendok = true;
					
					$db->query("SELECT * FROM ".DB_PREFIX."emails_archive WHERE eid='".$eid."' AND sent='No'");
					
					if ($db->moveNext())
					{
						require_once("content/engine/engine_notifications.php");
		
						$content_text = trim($db->col["content_text"]);
						$content_html = trim($db->col["content_html"]);
						$from_email = trim($db->col["from_email"]);
						$from_name = trim($db->col["from_name"]);
						$subject = trim($db->col["subject"]);
		
						$uc = 0;
						$sc = 0;
						$db->query("
								SELECT email, email_mode, email_type FROM (
									SELECT email, email_mode, 'registered' as email_type
									FROM ".DB_PREFIX."users
									WHERE newsletters='Yes' AND removed='No'
		
									UNION ALL
		
									SELECT email, email_mode, 'subscriber' as email_type
									FROM ".DB_PREFIX."emails
									WHERE newsletters='Yes'
									AND dead='No'
								) as t
								GROUP BY t.email
						");
		
						if (!safe_mode()) set_time_limit(3000);
		
						//$content_text_users = str_replace($unsubscr_sample, $unsubscr_users_text, $content_text);
						//$content_html_users = str_replace($unsubscr_sample, $unsubscr_users_html, $content_html);
						if (!DEMO_LOCK)
						{
							//check if mailchimp is enabled on this cart,
							//if so, then use it
							$chimpenabled = $settings["mailchimp_enabled"];
							if ($chimpenabled)
							{
								$chimpkey = $settings["mailchimp_apikey"];
								$chimplist = $settings["mailchimp_newsletter_list"];
	
								if ($chimpkey && $chimplist)
								{
									$basepath = $settings["GlobalServerPath"];
									require_once("$basepath/content/vendors/mailchimp/MCAPI.class.php");
									$mc = new MCAPI($chimpkey);
									$cid = $mc->campaignCreate("regular", array("list_id"=>$chimplist,"subject"=>$subject,"from_email"=>$from_email,"from_name"=>$from_name,"ecomm360"=>true), array("html"=>$content_html,"text"=>$content_text));
									if ($cid)
									{
										if ($mc->campaignSendNow($cid))
										{
											pageNote(array(
												array("class"=>"ic-info", "text"=>"<b>Newsletter Email has been successfully sent</b>", "url"=>"", "visible"=>true)
											));
										}
										else
										{
											pageNote(array(
												array("class"=>"ic-info", "text"=>"<b>There was a Mailchimp error sending the email</b> " . $mc->errorMessage, "url"=>"", "visible"=>true)
											));
											$sendok = false;
										}
									}
									else
									{
										pageNote(array(
											array("class"=>"ic-info", "text"=>"<b>There was a Mailchimp error creating the campaign</b> " . $mc->errorMessage, "url"=>"", "visible"=>true)
										));
										$sendok = false;
									}
								}
							}
							else
							{
								while($db->moveNext())
								{
									if ($content_text != "")
									{
										if ($db->col["email_mode"] == "text")
										{
											send_mail($db->col["email"], $subject, $content_text, array('name' => $from_name, 'email' => $from_email), "text");
										}
										else
										{
											send_mail($db->col["email"], $subject, $content_html, array('name' => $from_name, 'email' => $from_email), "html");
										}
		
										if ($db->col['email_type'] == 'registered')
										{
											$uc++;
										}
										else
										{
											$sc++;
										}
									}
								}
								pageNote(array(
									array("class"=>"ic-info", "text"=>"<b>Newsletter Email has been successfully sent</b>", "url"=>"", "visible"=>true),
									array("class"=>"ic-info", "text"=>"You have sent your newsletter to ".$uc." registered user(s) and ".$sc." emails to unregistered subscriber(s)", "url"=>"", "visible"=>true)
								));
							}
						}
		
						if ($sendok)
						{
							$db->query("UPDATE ".DB_PREFIX."emails_archive SET sent='Yes', sent_at=NOW() WHERE eid='".$eid."'");
						}
						pageWhat(array(
							array("text"=>"Browse Emails Archive", "url"=>"admin.php?p=email_archive"),
							array("text"=>"Send Newsletter email again", "url"=>"admin.php?p=email_newsletter")
						));
					}
					else
					{
						pageNote(array(
							array("class"=>"ic-cross", "text"=>"<b>This email already sent</b>", "url"=>"", "visible"=>true)
						));
						pageWhat(array(
							array("text"=>"Browse Emails Archive", "url"=>"admin.php?p=email_archive"),
							array("text"=>"Send Newsletter Email again", "url"=>"admin.php?p=email_newsletter")
						));
					}
				}
			}
			if ($step < 3)
			{
?>
					
			</div>
		</div>
	</div>
<?php
			}
		}
	}
?>
