<?php

	$adminMenu = new Admin_Menu('side-menu', 'Menu', 'side-menu', 'side-menu');
	
	/**
	 * Build menu
	 */
	$adminMenu->add(
		/**
		 * Orders & Customers
		 */
		new Admin_MenuItem('mi-crm', PRIVILEGE_ALL + PRIVILEGE_ORDERS + PRIVILEGE_USERS,	'Orders & Customers', null, null, 'ic-invoice', null, null, array(
			new Admin_MenuItem('mi-crm-orders', PRIVILEGE_ALL + PRIVILEGE_ORDERS, 'Orders', 'admin.php?p=orders', array('?p=order','?p=order_process'), 'ic-list2'),
			new Admin_MenuItem('mi-crm-users', PRIVILEGE_ALL + PRIVILEGE_USERS, 'Customers', 'admin.php?p=users', array('?p=user','?p=user_process'), 'ic-group')
		)),
			
		/**
		 * Products and Categories
		 */
		new Admin_MenuItem('mi-catalog', PRIVILEGE_ALL + PRIVILEGE_CATEGORIES + PRIVILEGE_PRODUCTS, 'Products & Categories', null, array('?p=product&mode=update', '?p=product_process', '?p=category&mode=update', '?p=category_process'), 'ic-inventory', null, null, array(
			new Admin_MenuItem('mi-catalog-products-list', PRIVILEGE_ALL + PRIVILEGE_PRODUCTS, 'Browse Product', 'admin.php?p=products', null, 'ic-product-gear'),
			new Admin_MenuItem('mi-catalog-product-add', PRIVILEGE_ALL + PRIVILEGE_PRODUCTS, 'Add a New Product', 'admin.php?p=product&mode=insert', null, 'ic-product-add'),
			new Admin_MenuItem('mi-catalog-categories-list', PRIVILEGE_ALL + PRIVILEGE_CATEGORIES, 'Browse Categories', 'admin.php?p=categories', null, 'ic-folder-gear', 'block-start'),
			new Admin_MenuItem('mi-catalog-category-add', PRIVILEGE_ALL + PRIVILEGE_CATEGORIES, 'Add a New Category', 'admin.php?p=category&mode=insert', null, 'ic-folder-add'),
			new Admin_MenuItem('mi-catalog-loaders', PRIVILEGE_ALL + PRIVILEGE_PRODUCTS + PRIVILEGE_CATEGORIES, 'Bulk Loaders & Automation', null, null, 'ic-wizard', 'block-start', null, array(
				new Admin_MenuItem('mi-catalog-loader-categories', PRIVILEGE_ALL + PRIVILEGE_CATEGORIES, 'Bulk Category Loader', 'admin.php?p=bulk_categories', null, 'ic-upload'),
				new Admin_MenuItem('mi-catalog-loader-products', PRIVILEGE_ALL + PRIVILEGE_PRODUCTS, 'Bulk Product Loader', 'admin.php?p=bulk_products', null, 'ic-upload'),
				new Admin_MenuItem('mi-catalog-loader-manufacturers', PRIVILEGE_ALL + PRIVILEGE_PRODUCTS, 'Bulk Manufacturer Loader', 'admin.php?p=bulk_manufacturers', null, 'ic-upload'),
				new Admin_MenuItem('mi-catalog-loader-images', PRIVILEGE_ALL + PRIVILEGE_PRODUCTS, 'Bulk Images Loader', 'admin.php?p=bulk_images', null, 'ic-file-format-jpg', 'block-start'),
				new Admin_MenuItem('mi-catalog-loader-thumbs', PRIVILEGE_ALL + PRIVILEGE_PRODUCTS, 'Thumbnail Generator', 'admin.php?p=thumbs_generator', null, 'ic-file-format-jpg')
			)),
			new Admin_MenuItem('mi-catalog-other', PRIVILEGE_ALL + PRIVILEGE_PRODUCTS, 'Properties & Features', null, null, 'ic-list-checkmark', null, null, array(
				new Admin_MenuItem('mi-catalog-other-manufacturers', PRIVILEGE_ALL + PRIVILEGE_PRODUCTS, 'Manufacturers', 'admin.php?p=manufacturers', null, 'ic-factory'),
				new Admin_MenuItem('mi-catalog-other-product-groups', PRIVILEGE_ALL + PRIVILEGE_PRODUCTS, 'Product Groups', 'admin.php?p=products_groups', array('?p=products_group&mode=edit'), 'ic-osi-model2'),
				new Admin_MenuItem('mi-catalog-other-product-reviews', PRIVILEGE_ALL + PRIVILEGE_PRODUCTS, 'Product Reviews', 'admin.php?p=products_reviews', null, 'ic-pencil'),
				new Admin_MenuItem('mi-catalog-other-global-attributes', PRIVILEGE_ALL + PRIVILEGE_PRODUCTS, 'Global Attributes', 'admin.php?p=products_attributes', null, 'ic-checkmark', 'block-start'),
				new Admin_MenuItem('mi-catalog-other-global-attribute-add', PRIVILEGE_ALL + PRIVILEGE_PRODUCTS, 'Add a New Global Attributes', 'admin.php?p=products_attribute&mode=insert', null, 'ic-checkmark-add'),
				new Admin_MenuItem('mi-catalog-other-recommended-products', PRIVILEGE_ALL + PRIVILEGE_PRODUCTS, 'Recommended Products', 'admin.php?p=products_families', array('?p=products_family&mode=update'), 'ic-chat-exclamation', 'block-start'),
				new Admin_MenuItem('mi-catalog-other-recommended-product-add', PRIVILEGE_ALL + PRIVILEGE_PRODUCTS, 'Add Recommended Product Family', 'admin.php?p=products_family&mode=insert', null, 'ic-chat-exclamation-add'),
			))
		)),
		
		/**
		 * Settings
		 */
		new Admin_MenuItem('mi-settings', PRIVILEGE_ALL + PRIVILEGE_ADMIN + PRIVILEGE_GLOBAL + PRIVILEGE_CCS + PRIVILEGE_BUSINESS + PRIVILEGE_CONTENT + PRIVILEGE_DATABASE, 'Cart Settings', null, null, 'ic-gear', null, null, array(			
			$miSettingsGlobal = new Admin_MenuItem('mi-settings-global', PRIVILEGE_ALL + PRIVILEGE_GLOBAL, 'Global Cart Settings'),
			new Admin_MenuItem('mi-settings-business', PRIVILEGE_ALL + PRIVILEGE_BUSINESS, 'Payment, Shipping & Taxes', null, null, 'ic-cashbox', null, null, array(
				new Admin_MenuItem('mi-settings-business-payment', PRIVILEGE_ALL + PRIVILEGE_BUSINESS, 'Payment Methods', 'admin.php?p=payment_methods', array('?p=payment_method&mode=insert', '?p=payment_method&mode=update', '?p=payment_method_process', '?p=payment_cardinal', '?p=payment_method_custom&mode=insert', '?p=payment_method_custom&mode=update'), 'ic-payment'),
				new Admin_MenuItem('mi-settings-business-shipping', PRIVILEGE_ALL + PRIVILEGE_BUSINESS, 'Shipping Management', 'admin.php?p=shipping', array('?p=shipping_custom_rates'), 'ic-truck'),
				new Admin_MenuItem('mi-settings-business-taxes', PRIVILEGE_ALL + PRIVILEGE_BUSINESS, 'Edit Taxes', 'admin.php?p=taxes', array('?p=taxes_zone', '?p=taxes_class', '?p=taxes_rate', '?p=taxes_rate&mode=add', '?p=taxes_rate&mode=edit'), 'ic-tax'),
				new Admin_MenuItem('mi-settings-business-dicsounts', PRIVILEGE_ALL + PRIVILEGE_BUSINESS, 'Discounts & Promo', 'admin.php?p=discounts', null, 'ic-cutter'),
			)),
			new Admin_MenuItem('mi-settings-security', PRIVILEGE_ALL + PRIVILEGE_GLOBAL + PRIVILEGE_CCS, 'Security & Protection Settings', null, null, 'ic-key', null, null, array(
				new Admin_MenuItem('mi-settings-security-security', PRIVILEGE_ALL + PRIVILEGE_GLOBAL, 'Security Settings', 'admin.php?p=settings&group=7', null, 'ic-security'),
				new Admin_MenuItem('mi-settings-security-captcha', PRIVILEGE_ALL + PRIVILEGE_GLOBAL, 'Captcha', 'admin.php?p=settings&group=27', null, 'ic-eye-open'),
				new Admin_MenuItem('mi-settings-security-ccs', PRIVILEGE_ALL + PRIVILEGE_CCS, 'CCS Settings', 'admin.php?p=settings_ccs', null, 'ic-safety-box'),
				new Admin_MenuItem('mi-settings-security-pci-dss', PRIVILEGE_ALL + PRIVILEGE_GLOBAL, 'PCI-DSS/PA-DSS compliance', 'admin.php?p=compliance', null, 'ic-pci-dss'),
			)),
			new Admin_MenuItem('mi-settings-appearance', PRIVILEGE_ALL + PRIVILEGE_CONTENT, 'Appearance & Content', null, array('?p=custom_field_process'), 'ic-monitor', null, null, array(
				new Admin_MenuItem('mi-settings-appearance-design', PRIVILEGE_ALL + PRIVILEGE_CONTENT, 'Change Site Theme', 'admin.php?p=design_settings', null, 'ic-color'),
				new Admin_MenuItem('mi-settings-appearance-designer', PRIVILEGE_ALL + PRIVILEGE_CONTENT, 'Activate Cart Designer', 'admin.php?chart=true&p=design_settings&design_mode_flag=On&printing=true', null, 'ic-palette'),
				new Admin_MenuItem('mi-settings-appearance-catalog', PRIVILEGE_ALL + PRIVILEGE_CONTENT, 'Catalog Settings', 'admin.php?p=design_catalog', null, 'ic-align-vertical-left'),
				new Admin_MenuItem('mi-settings-appearance-home-page', PRIVILEGE_ALL + PRIVILEGE_CONTENT, 'Site Home Page', 'admin.php?p=site_home', null, 'ic-home'),
				new Admin_MenuItem('mi-settings-appearance-text-pages', PRIVILEGE_ALL + PRIVILEGE_CONTENT, 'Edit Text Pages', 'admin.php?p=pages', array('?p=page&mode=update', '?p=page_process'), 'ic-document', 'block-start'),
				new Admin_MenuItem('mi-settings-appearance-add-text-page', PRIVILEGE_ALL + PRIVILEGE_CONTENT, 'Add a New Page', 'admin.php?p=page&mode=insert', null, 'ic-document-add'),
				new Admin_MenuItem('mi-settings-appearance-forms', PRIVILEGE_ALL + PRIVILEGE_CONTENT, 'Forms & Fields', 'admin.php?p=forms_control', array('admin.php?p=custom_field_process', 'admin.php?p=custom_field&mode=update', 'admin?p=custom_field_process&mode=delete'), 'ic-password', 'block-start'),
				new Admin_MenuItem('mi-settings-appearance-add-field', PRIVILEGE_ALL + PRIVILEGE_CONTENT, 'Add a New Fields', 'admin.php?p=custom_field&mode=insert', array('admin.php?p=custom_field'), 'ic-password-add'),
				new Admin_MenuItem('mi-settings-appearance-file-manager', PRIVILEGE_ALL + PRIVILEGE_CONTENT, 'File Manager', 'admin.php?p=filemanager', null, 'ic-file', 'block-start')
			)),
			$miSettingsAdmins = new Admin_MenuItem('mi-settings-admins', PRIVILEGE_ALL + PRIVILEGE_ADMIN + PRIVILEGE_ANY + PRIVILEGE_GLOBAL, 'Manage Administrators', null, array('?p=admin_process', '?p=profile_process', '?p=admin&mode=update'), 'ic-administrator'),
			new Admin_MenuItem('mi-settings-email', PRIVILEGE_ALL + PRIVILEGE_EMAIL, 'Email Settings & Tools', null, null, 'ic-envelope', null, null, array(
				new Admin_MenuItem('mi-settings-email-top-bottom', PRIVILEGE_ALL + PRIVILEGE_EMAIL, 'Email Top & Bottom', 'admin.php?p=email_top_bottom', null, 'ic-envelope-pencil'),
				new Admin_MenuItem('mi-settings-email-notifications', PRIVILEGE_ALL + PRIVILEGE_EMAIL, 'Notification Emails', 'admin.php?p=email_notifications', array('?p=email_notification'), 'ic-envelope-star'),
				new Admin_MenuItem('mi-settings-email-pop-smtp', PRIVILEGE_ALL + PRIVILEGE_GLOBAL, 'POP3 and SMTP Email Settings', 'admin.php?p=settings_email', null, 'ic-envelope-gear'),
				new Admin_MenuItem('mi-settings-email-bounced', PRIVILEGE_ALL + PRIVILEGE_EMAIL, 'Check Bounced Email Addresses', 'admin.php?p=email_check', null, 'ic-envelope-checkmark')
			)),
			new Admin_MenuItem('mi-settings-db', PRIVILEGE_ALL + PRIVILEGE_DATABASE, 'Database & Backup', 'admin.php?p=backup_restore', null, 'ic-backup-server'),
			new Admin_MenuItem('mi-settings-info', PRIVILEGE_ALL + PRIVILEGE_GLOBAL, 'Cart Information', 'admin.php?p=info', null, 'ic-info')
		)),
			
		/**
		 * Marketing
		 */
		new Admin_MenuItem('mi-marketing', PRIVILEGE_ALL + PRIVILEGE_EMAIL + PRIVILEGE_MARKETING + PRIVILEGE_GLOBAL, 'Marketing', null, null, 'ic-world', null, null, array(
			new Admin_MenuItem('mi-marketing-social-networks', PRIVILEGE_ALL + PRIVILEGE_GLOBAL, 'Social Sharing', 'admin.php?p=settings_social', null, 'ic-smiley'),
			new Admin_MenuItem('mi-marketing-google-tools', PRIVILEGE_ALL + PRIVILEGE_MARKETING, 'Google Tools', 'admin.php?p=google_marketing', null, 'ic-google'),
			new Admin_MenuItem('mi-marketing-offsite', PRIVILEGE_ALL + PRIVILEGE_MARKETING, 'Off-Site Commerce', null, null, 'ic-gateway', null, null, array(
				new Admin_MenuItem('mi-marketing-qr-settings', PRIVILEGE_ALL + PRIVILEGE_MARKETING, 'QR Codes', 'admin.php?p=settings_qr', null, 'ic-raster-gear'),
				new Admin_MenuItem('mi-marketing-widgets-settings', PRIVILEGE_ALL + PRIVILEGE_MARKETING, 'Widgets', 'admin.php?p=settings_widgets', null, 'ic-window-gear', 'block-start')
			)),
			new Admin_MenuItem('mi-marketing-email', PRIVILEGE_ALL + PRIVILEGE_EMAIL, 'Newsletters & Emails', null, null, 'ic-envelope2', null, null, array(
				new Admin_MenuItem('mi-marketing-email-newsletter', PRIVILEGE_ALL + PRIVILEGE_EMAIL, 'Newsletter Wizard', 'admin.php?p=email_newsletter', null, 'ic-wizard'),
				new Admin_MenuItem('mi-marketing-email-updates', PRIVILEGE_ALL + PRIVILEGE_EMAIL, 'Product Update Wizard', 'admin.php?p=email_updates', null, 'ic-wizard'),
				new Admin_MenuItem('mi-marketing-email-archive', PRIVILEGE_ALL + PRIVILEGE_EMAIL, 'Sent Email Archive', 'admin.php?p=email_archive', array('?p=email_archive_preview'), 'ic-envelope2-clock'),
				new Admin_MenuItem('mi-marketing-email-list', PRIVILEGE_ALL + PRIVILEGE_EMAIL, 'Subscriber Email Addresses', 'admin.php?p=email_list', null, 'ic-envelope2-right', 'block-start'),
				new Admin_MenuItem('mi-marketing-email-users', PRIVILEGE_ALL + PRIVILEGE_EMAIL, 'Export User Email Addresses', 'admin.php?p=users_emails&mode=users', null, 'ic-envelope2-right'),
				new Admin_MenuItem('mi-marketing-email-subscribers', PRIVILEGE_ALL + PRIVILEGE_EMAIL, 'Export Subscriber Email Addresses', 'admin.php?p=users_emails&mode=subscribers', null, 'ic-envelope2-right'),
				new Admin_MenuItem('mi-marketing-email-import', PRIVILEGE_ALL + PRIVILEGE_EMAIL, 'Import Email Addresses', 'admin.php?p=emails_import', null, 'ic-envelope2-left', 'block-start')
			)),
			new Admin_MenuItem('mi-marketing-sale-pricing', PRIVILEGE_ALL + PRIVILEGE_MARKETING, 'Global Sale Pricing', 'admin.php?p=sale_prices', null, 'ic-salary'),
			new Admin_MenuItem('mi-marketing-drift', PRIVILEGE_ALL + PRIVILEGE_MARKETING, 'Drift Marketing Campaigns', 'admin.php?p=drift_marketing', null, 'ic-swimming'),
			new Admin_MenuItem('mi-marketing-testimonials', PRIVILEGE_ALL + PRIVILEGE_MARKETING, 'Testimonials', 'admin.php?p=plugin&plugin_id=testimonials', null, 'ic-smiley-in-love'),
			new Admin_MenuItem('mi-catalog-other-gift-certificate', PRIVILEGE_ALL + PRIVILEGE_MARKETING, 'Gift Certificates', 'admin.php?p=plugin&plugin_id=gift_cert', null, 'ic-gift'),
		)),

		/**
		 * Apps
		 */
		$miApps = new Admin_MenuItem('mi-apps', PRIVILEGE_ALL + PRIVILEGE_GLOBAL + PRIVILEGE_MARKETING, 'Apps', null, null, 'ic-list2', null, null, array(
			$miAppsBusiness = new Admin_MenuItem('mi-apps-business', PRIVILEGE_ALL + PRIVILEGE_MARKETING, 'Business', null, null, 'ic-agent', null, null, array(
				new Admin_MenuItem('mi-apps-business-stone-edge', PRIVILEGE_ALL + PRIVILEGE_MARKETING, 'Stone Edge Order Manager', 'admin.php?p=plugin&plugin_id=stone_edge_order_manager', null, 'ic-stone-edge'),
				new Admin_MenuItem('mi-apps-business-webgility', PRIVILEGE_ALL + PRIVILEGE_MARKETING, 'Webgility eCommerce Connector', 'admin.php?p=plugin&plugin_id=webgility', null, 'ic-webgility'),
				new Admin_MenuItem('mi-apps-business-bongo', PRIVILEGE_ALL + PRIVILEGE_BUSINESS, 'Bongo Checkout', 'admin.php?p=bongo', null, 'ic-gear'),
			)),
			new Admin_MenuItem('mi-apps-stock', PRIVILEGE_ALL + PRIVILEGE_PRODUCTS + PRIVILEGE_MARKETING, 'Products Import / Export', null, null, 'ic-asymmetric-network', null, null, array(
				new Admin_MenuItem('mi-apps-stock-doba', PRIVILEGE_ALL + PRIVILEGE_PRODUCTS, 'Doba Products Import', 'admin.php?p=doba', null, 'ic-record'),
				new Admin_MenuItem('mi-apps-stock-dd', PRIVILEGE_ALL + PRIVILEGE_PRODUCTS, 'DollarDays Import', 'admin.php?p=plugin&plugin_id=dollar_days_import', null, 'ic-currency-sign-dollar2'),
				new Admin_MenuItem('mi-apps-stock-feeds', PRIVILEGE_ALL + PRIVILEGE_MARKETING, 'Datafeeds (Amazon, Ebay, Yahoo)', 'admin.php?p=plugin&plugin_id=productdownload', null, 'ic-organizational-chart'),
				new Admin_MenuItem('mi-apps-stock-shopzilla', PRIVILEGE_ALL + PRIVILEGE_MARKETING, 'Shopzilla Integration', 'admin.php?p=export_shopzilla', null, 'ic-shopping-cart'),
				new Admin_MenuItem('mi-apps-stock-wholesalecentral', PRIVILEGE_ALL + PRIVILEGE_MARKETING, 'WholesaleCentral Integration', 'admin.php?p=export_wholesalecentral', null, 'ic-shopping-cart')
			)),
			new Admin_MenuItem('mi-apps-social', PRIVILEGE_ALL + PRIVILEGE_MARKETING + PRIVILEGE_GLOBAL, 'Marketing & Social', null, null, 'ic-network', null, null, array(
				new Admin_MenuItem('mi-apps-social-affiliate', PRIVILEGE_ALL + PRIVILEGE_MARKETING, 'Affiliate Integration', 'admin.php?p=affiliate', null, 'ic-fast-forward'),
				new Admin_MenuItem('mi-apps-social-mailchimp', PRIVILEGE_ALL + PRIVILEGE_MARKETING, 'Mailchimp Integration', 'admin.php?p=mailchimp', null, 'ic-envelope-open')
			)),
			new Admin_MenuItem('mi-apps-plugins', PRIVILEGE_ALL + PRIVILEGE_MARKETING, 'Plugins', null, null, 'ic-plugin', null, null, array(
				new Admin_MenuItem('mi-apps-plugins-export', PRIVILEGE_ALL + PRIVILEGE_MARKETING, 'Data Export', 'admin.php?p=plugins&group_id=export', null, 'ic-plugin'),
				new Admin_MenuItem('mi-apps-plugins-datafeed', PRIVILEGE_ALL + PRIVILEGE_MARKETING, 'Product Feeds', 'admin.php?p=plugins&group_id=datafeed', null, 'ic-plugin'),
				new Admin_MenuItem('mi-apps-plugins-misc', PRIVILEGE_ALL + PRIVILEGE_MARKETING, 'Miscellaneous Plugins', 'admin.php?p=plugins&group_id=misc', null, 'ic-plugin'),
			)),
			$miAppsEndicia = new Admin_MenuItem('mi-apps-endicia', PRIVILEGE_ALL, 'Endicia USPS Postage', null, null, 'ic-plugin', null, null, array(
				new Admin_MenuItem('mi-apps-endicia-manage', PRIVILEGE_ALL + PRIVILEGE_BUSINESS, 'Manage Endicia', 'admin.php?p=settings_endicia', null, 'ic-barcode'),
				new Admin_MenuItem('mi-apps-endicia-about', PRIVILEGE_ALL + PRIVILEGE_BUSINESS, 'About Endicia', 'admin.php?p=settings_endicia&last_active_tab=about', null, 'ic-barcode'),
			)),
		

		)),
			
		/**
		 * Statistics
		 */
		new Admin_MenuItem('mi-stats', PRIVILEGE_ALL + PRIVILEGE_STATS, 'Statistics & Reports', null, null, 'ic-stats-line-chart', null, null, array(
			new Admin_MenuItem('mi-stats-charts-all', PRIVILEGE_ALL + PRIVILEGE_STATS, 'Charts', 'admin.php?p=stats_charts', null, 'ic-stats-bar-chart'),
			new Admin_MenuItem('mi-stats-reports-all', PRIVILEGE_ALL + PRIVILEGE_STATS, 'All Reports', 'admin.php?p=reports', null, 'ic-list'),
			$miStatsReports = new Admin_MenuItem('mi-stats-reports', PRIVILEGE_ALL + PRIVILEGE_STATS, 'Reports By Type', null, null, 'ic-list')
		))
	);
	
	if ($settings['EndiciaShippingLabelsActive'] == 'Yes'){
		$miAppsEndicia->add(
		new Admin_MenuItem('mi-apps-endicia-postage', PRIVILEGE_ALL + PRIVILEGE_BUSINESS, 'Purchase Postage', 'admin.php?p=settings_endicia&last_active_tab=postage', null, 'ic-barcode')
	);
	}


	if (md5($label_app_name) == 'aac9a3612c49dc1c1d5d4b756d07d789')
	{

		$adminMenu->add(
			new Admin_MenuItem('mi-support', PRIVILEGE_ANY, 'Support', 'http://www.'.getp().'.com/support/', null, 'ic-user-info', 'target-blank'),
			new Admin_MenuItem('mi-kb', PRIVILEGE_ANY, 'Knowledge Base', 'http://www.'.getp().'.com/kb/', null, 'ic-help', 'target-blank')
		);
		
		$miApps->add(
			new Admin_MenuItem('mi-apps-compatible', PRIVILEGE_ANY, 'Compatible Applications', 'http://www.'.getp().'.com/shopping-cart-compatiable-applications.htm', null, 'ic-gear', 'target-blank')
		);

		if ((defined('IS_INTUIT_FEDERATED') && IS_INTUIT_FEDERATED) || _ACCESS_INTUIT_ANYWHERE)
		{
			$miAppsBusiness->add(
				new Admin_MenuItem('mi-apps-business-quickbooks', PRIVILEGE_ALL + PRIVILEGE_BUSINESS, 'Connect to QuickBooks', 'admin.php?p=settings_intuit', null, 'ic-qb')
			);
		}
			/**<div>
					<div class="admin-left-button admin-icon-tweet"><a target="_new" href="http://www.twitter.com/<?php echo getp();?>">Follow us on Twitter</a></div>
					<div class="admin-left-button admin-icon-blog"><a target="_new" href="http://blog.<?php echo getp();?>.com">We're blogging</a></div>
					<div class="admin-left-button admin-icon-support"><a target="_new" href="https://account.<?php echo getp();?>.com">Support Center</a></div>
					<div class="admin-left-button admin-icon-kb"><a id="kb-link" href="http://www.<?php echo getp();?>.com/kb/">Knowledge Base</a></div>
					<div class="admin-left-button admin-icon-compatible"><a target="_new" href="http://www.<?php echo getp();?>.com/shopping-cart-compatiable-applications.htm">Compatible Applications</a></div>
				</div>
<?php **/
	}
	else
	{
		$adminMenu->add(
			new Admin_MenuItem('mi-support', PRIVILEGE_ANY, 'Support', $label_support_area, null, 'ic-user-info', 'target-blank'),
			new Admin_MenuItem('mi-kb', PRIVILEGE_ANY, 'User Manual', $label_user_manual, null, 'ic-help', 'target-blank'),
			new Admin_MenuItem('mi-home', PRIVILEGE_ANY, $label_app_name, $label_home_site, null, 'ic-home', 'target-blank')
		);
	}

	/**
	 * Settings
	 */
	$miSettingsGlobal->add(
		new Admin_MenuItem('mi-settings-global-company', PRIVILEGE_ALL + PRIVILEGE_GLOBAL, 'Company Information', 'admin.php?p=settings&group=1', null, 'ic-company'),
		new Admin_MenuItem('mi-settings-global-site', PRIVILEGE_ALL + PRIVILEGE_GLOBAL, 'Global Site Settings', 'admin.php?p=settings&group=3', null, 'ic-audio-equalizer'),
		new Admin_MenuItem('mi-settings-global-order-cart', PRIVILEGE_ALL + PRIVILEGE_GLOBAL, 'Order/Cart Settings', 'admin.php?p=settings&group=4', null, 'ic-shopping-cart'),
		new Admin_MenuItem('mi-settings-global-seo', PRIVILEGE_ALL + PRIVILEGE_GLOBAL, 'Search Engine Optimization', 'admin.php?p=settings_search', null, 'ic-zoom'),
		new Admin_MenuItem('mi-settings-global-proxy', PRIVILEGE_ALL + PRIVILEGE_GLOBAL, 'Proxy Settings', 'admin.php?p=settings&group=13', null, 'ic-proxy-server'),
		new Admin_MenuItem('mi-settings-global-digital', PRIVILEGE_ALL + PRIVILEGE_GLOBAL, 'Digital Products', 'admin.php?p=settings&group=20', null, 'ic-bit'),
		new Admin_MenuItem('mi-settings-global-bestsellers', PRIVILEGE_ALL + PRIVILEGE_GLOBAL, 'Bestsellers Settings', 'admin.php?p=settings&group=12', null, 'ic-trophy'),
		new Admin_MenuItem('mi-settings-global-gift', PRIVILEGE_ALL + PRIVILEGE_GLOBAL, 'Gift Message', 'admin.php?p=settings&group=14', null, 'ic-gift'),
		new Admin_MenuItem('mi-settings-global-print', PRIVILEGE_ALL + PRIVILEGE_GLOBAL, 'Printable Invoice Settings', 'admin.php?p=settings&group=21', null, 'ic-printer'),
		new Admin_MenuItem('mi-settings-global-mobile', PRIVILEGE_ALL + PRIVILEGE_GLOBAL, 'Mobile Site Settings', 'admin.php?p=settings&group=101', null, 'ic-mobile'),
		new Admin_MenuItem('mi-settings-global-locations', PRIVILEGE_ALL + PRIVILEGE_GLOBAL, 'Products Locations Settings', 'admin.php?p=products_locations', array('?p=products_location&mode=new'), 'ic-location'),
		new Admin_MenuItem('mi-settings-global-wholesale', PRIVILEGE_ALL + PRIVILEGE_GLOBAL, 'Wholesale Settings', 'admin.php?p=settings_wholesale', null, 'ic-osi-model'),
		new Admin_MenuItem('mi-settings-global-country', PRIVILEGE_ALL + PRIVILEGE_GLOBAL, 'Country List', 'admin.php?p=countries', array('?p=states'), 'ic-world'),
		new Admin_MenuItem('mi-settings-global-localization', PRIVILEGE_ALL + PRIVILEGE_GLOBAL, 'Localization, Languages & Currencies', 'admin.php?p=localization', array('?p=language&mode=insert', '?p=language&mode=update', '?p=language_process'), 'ic-currency-sign-yen'),
		new Admin_MenuItem('mi-settings-global-openapi', PRIVILEGE_ALL + PRIVILEGE_GLOBAL, 'Shopping Cart Unified API', 'admin.php?p=plugin&plugin_id=openapi', null, 'ic-protocol1')
	);
	
	if (!defined('IS_INTUIT_FEDERATED'))
	{
		$miSettingsAdmins->add(
			new Admin_MenuItem('mi-settings-admins-browse', PRIVILEGE_ALL + PRIVILEGE_ADMIN, 'Browse Administrators', 'admin.php?p=admins', null, 'ic-administrator-gear'),
			new Admin_MenuItem('mi-settings-admins-add', PRIVILEGE_ALL + PRIVILEGE_ADMIN, 'Create a New Account', 'admin.php?p=admin&mode=insert', null, 'ic-administrator-add')
		);
	}
	$miSettingsAdmins->add(
		new Admin_MenuItem('mi-settings-admins-profile', PRIVILEGE_ALL + PRIVILEGE_ANY, 'Update Your Profile', 'admin.php?p=profile', null, 'ic-id'),
		new Admin_MenuItem('mi-settings-admins-log', PRIVILEGE_ALL + PRIVILEGE_ADMIN, 'Activity Log', 'admin.php?p=admins_log', null, 'ic-log')
	);
	
	/**
	 * Init Reports
	 */
	$miStatsReports->add(
		new Admin_MenuItem('mi-stats-reports-top_products', PRIVILEGE_ALL + PRIVILEGE_STATS, 'Top Viewed Products', 'admin.php?p=reports&report_type=top_products', null, 'ic-list'),
		new Admin_MenuItem('mi-stats-reports-top_categories', PRIVILEGE_ALL + PRIVILEGE_STATS, 'Top Viewed Categories', 'admin.php?p=reports&report_type=top_categories', null, 'ic-list'),
		new Admin_MenuItem('mi-stats-reports-products', PRIVILEGE_ALL + PRIVILEGE_STATS, 'Orders by Products', 'admin.php?p=reports&report_type=products', null, 'ic-list'),
		new Admin_MenuItem('mi-stats-reports-users_activity', PRIVILEGE_ALL + PRIVILEGE_STATS, 'Users Activity Report', 'admin.php?p=reports&report_type=users_activity', null, 'ic-list'),
		new Admin_MenuItem('mi-stats-reports-referrers', PRIVILEGE_ALL + PRIVILEGE_STATS, 'Top Referring Sites', 'admin.php?p=reports&report_type=referrers', null, 'ic-list'),
		new Admin_MenuItem('mi-stats-reports-customers', PRIVILEGE_ALL + PRIVILEGE_STATS, 'Sales by Customer', 'admin.php?p=reports&report_type=customers', null, 'ic-list'),
		new Admin_MenuItem('mi-stats-reports-payment', PRIVILEGE_ALL + PRIVILEGE_STATS, 'Payment Types', 'admin.php?p=reports&report_type=payment', null, 'ic-list'),
		new Admin_MenuItem('mi-stats-reports-dates', PRIVILEGE_ALL + PRIVILEGE_STATS, 'Consolidated Orders by Date', 'admin.php?p=reports&report_type=dates', null, 'ic-list'),
		new Admin_MenuItem('mi-stats-reports-orders', PRIVILEGE_ALL + PRIVILEGE_STATS, 'Individual Orders by Date', 'admin.php?p=reports&report_type=orders', null, 'ic-list'),
		new Admin_MenuItem('mi-stats-reports-tax', PRIVILEGE_ALL + PRIVILEGE_STATS, 'Total Tax', 'admin.php?p=reports&report_type=tax', null, 'ic-list'),
		new Admin_MenuItem('mi-stats-reports-profit', PRIVILEGE_ALL + PRIVILEGE_STATS, 'Total Profit', 'admin.php?p=reports&report_type=profit', null, 'ic-list'),
		new Admin_MenuItem('mi-stats-reports-qr_campaigns', PRIVILEGE_ALL + PRIVILEGE_STATS, 'QR Campaigns', 'admin.php?p=reports&report_type=qr_campaigns', null, 'ic-list'),
		new Admin_MenuItem('mi-stats-reports-widgets_campaigns', PRIVILEGE_ALL + PRIVILEGE_STATS, 'Widgets Campaigns', 'admin.php?p=reports&report_type=widgets_campaigns', null, 'ic-list')
	);
	
	// Get menu preferences
	$adminMenuPreferences = new Admin_ModelPreferencesMenu($db, $admin_auth_id);
	
	// Get current item
	$currentMenuItem = $adminMenu->getItemByUrl(currentPageURL());
	
	// Handle menu history
	$adminMenuHistory = new Admin_MenuHistory();
	
	// Put current menu item into history
	if ($currentMenuItem != null)
	{
		$adminMenuHistory->remember($currentMenuItem);
	}
	
	$adminPrivileges = getAdminPrivileges($auth_rights);//PRIVILEGE_ANY + PRIVILEGE_ALL;
	
	// Recall last X menu items from a history
	$adminMenuHistoryItems = $adminMenuHistory->recall($adminMenu, $adminMenuPreferences);
	
	// Save current history menu state into db
	if ($adminMenuHistoryItems != null)
	{
		$adminMenuPreferences->setHistoryItems($adminMenuHistoryItems);
	}
	
	//TODO: get admin real privileges
	$adminMenuGenerator = new Admin_MenuGenerator();
	
	$generatedMenu = $adminMenuGenerator->generate($adminMenu, $currentMenuItem, $adminMenuHistoryItems, $adminPrivileges);

	$adminView = Ddm_AdminView::getInstance();
	
	
	$adminView->assign("labelAppNameMd5", md5($label_app_name));
	$adminView->assign("pc", getp());
	$adminView->assign("adminMenu", $generatedMenu);
	$adminView->render('layouts/zones/menu');
	