<?php
	if (!defined("ENV")) exit();
	require_once("content/classes/class.manufacturers.php");
	$mans = new Manufacturers($db, $settings);

	loadJS("cf_manufacturers.js");
	pageHeader("Manufacturers", "", "icb-factory");
	
	$action = isset($action)?trim($action):"";
	
	if (!DEMO_LOCK)
	{
		if ($action != "")
		{
		
			switch($action)
			{
				case "manufacturer_add" :
				{
					$mans->insertManufacturer($_REQUEST);
					break;
				}
				case "manufacturer_delete" :
				{
					$mans->deleteManufacturer($_REQUEST["manufacturer_id"]);
					break;
				}
				case "manufacturer_delete_image" :
				{
					$mans->deleteManufacturerImage($_REQUEST["manufacturer_id"]);
					break;
				}
				case "manufacturers_update" :
				{
					$mans->updateManufacturers($_REQUEST);
					break;
				}
			}
			
			//render URL
			updateSeoURLs($db, $settings, false, false, false, true);
		}
	}

	pageNote(array(
		array("class"=>"ic-info", "text"=>"On this page you'll manage your Product Manufacturers.", "url"=>"", "visible"=>true),
		array("class"=>"ic-info", "text"=>"<b>New manufacturer has been added.</b>", "url"=>"", "visible"=>$action == "manufacturer_add"),
		array("class"=>"ic-info", "text"=>"<b>Manufacturer's data has been saved.</b>", "url"=>"", "visible"=>$action == "manufacturers_update"),
		array("class"=>"ic-cross", "text"=>"<span style=\"color:#990000\"><b>Newly added manufacturer has been saved with a randomly-generated ID<br>because the one you entered already exists in the database.</b></span>", "url"=>"", "visible"=>in_array(ERR_MANUFACTURER_CODE_EXISTS, $mans->error_code)),
		array("class"=>"ic-cross", "text"=>"<span style=\"color:#990000\"><b>Note: manufacturer logo was not uploaded.<br/>Please check image file type, free space and permissions.</b></span>", "url"=>"", "visible"=>in_array(ERR_MANUFACTURER_IMAGE_UPLOAD, $mans->error_code))
	));
?>
<div class="admin-tabs admin-tabs-framed" id="tabs-manufacturer">
<?php 
	pageTabs(array(
		array("title"=>"Manufacturers", "id"=>"main"),
		array("title"=>"New Manufacturer", "id"=>"new"),
	), "tabs-manufacturer", false);
	
	//calc page breaks
	$ccc = 10;
	$items_count = $mans->getManufacturersCount();
	$pages_count = floor($items_count / $ccc) +  ((($items_count % $ccc) > 0 )?1:0);
	$pg = isset($pg)?($pg*1):1;
	$pg = (($pg<1)||($pg>$pages_count))?1:$pg;
	$pages_line = format_pages_line(
		$pg, // current pare
		$pages_count, // total pages
		7,
		"admin.php?p=manufacturers"
	);

	$man_list = $mans->getManufacturersPaginated($pg, $ccc);
?>
	<div id="admin-tab-sheet-main" class="admin-tab-sheet">
		<div class="admin-tab-sheet-wrap">
			<form name="frmManufacturers" action="admin.php?p=manufacturers" enctype="multipart/form-data" method="POST" onsubmit="return checkUpdateManufacturers(this);">
				<input type="hidden" name="action" value="manufacturers_update"/>
				<input type="hidden" name="pg" value="<?php echo $pg;?>"/>
				<div class="admin-form-header first"><span class="icon ic-icon ic-factory"></span>Manage manufacturers</div>
				<div class="listHeaderCaption" style="float:right;font-weight:normal;">
					Manufacturers : <?=$items_count?> |
					Page(s) : <?=trim($pages_line) == ""?0:$pages_line?>
				</div>
				<table width="100%" cellpadding="0" cellspacing="0" border="0" class="admin-list-table">
					<thead>
						<tr>
							<th class="icon"></th>
							<th>Name</th>
							<th style="width:150px;">Manufacturer's ID</th>
							<th style="width:190px;">Default URL</th>
							<th style="width:190px;">Custom URL</th>
							<th style="width:285px;">Logo Image (JPG, GIF or PNG)</th>
							<th style="width:100px;">Available</th>
							<th>&nbsp;</th>
						</tr>
					</thead>
<?php
	if ($man_list)
	{
?>
					<tbody>
<?php 
		for ($i=0; $i<count($man_list); $i++)
		{
			$man = $man_list[$i];?>

						<tr>
							<td>&nbsp;</td>
							<td><input type="text" name="manufacturer_name[<?=$man["manufacturer_id"]?>]" value="<?=htmlspecialchars($man["manufacturer_name"])?>" style="width:99%;"/></td>
							<td><input type="text" name="manufacturer_code[<?=$man["manufacturer_id"]?>]" value="<?=htmlspecialchars($man["manufacturer_code"])?>" style="width:98%;"/></td>
							<td><?=htmlspecialchars($man["url_default"])?></td>
							<td><input type="text" name="manufacturer_url[<?=$man["manufacturer_id"]?>]" value="<?=htmlspecialchars($man["url_custom"])?>" style="width:98%;"/></td>
							<td>
								<input type="file" name="manufacturer_logo_<?=$man["manufacturer_id"]?>"  style="width:180px;"/>
<?php				if ($man["image"])
					{
?>
								<br />
								<a href="javascript:showPopupImage('<?=$man["image"]["file"]?>?ts=<?php echo filemtime($man["image"]['file']); ?>','<?=$man["image"]["info"][0]?>','<?=$man["image"]["info"][1]?>')">Current Logo</a> |
								<a href="javascript:confirmDeleteManufacturerImage('<?=$man["manufacturer_id"]?>')">Delete Logo</a>
<?php
					}
?>
							</td>
							<td><input type="checkbox" name="is_visible[<?=$man["manufacturer_id"]?>]" <?=$man["is_visible"]?"checked":""?>/></td>
							<td>
								<a href="javascript:confirmDeleteManufacturer('<?=$man["manufacturer_id"]?>')" title="Delete Manufacturer"><span class="icon ic-icon ic-trash-can"></span></a>
							</td>
						</tr>
<?php
		}
?>
					</tbody>
					<tfoot>
						<tr>
							<td colspan="8">
								<div class="admin-form-buttons">
									<input type="submit" value="Save changes"/>
									<input type="reset" value="Reset form"/>
								</div>
							</td>
						</tr>
					</tfoot>
<?php
	}
	else
	{
?>
					<tr>
						<td class="icon">&nbsp;</td>
						<td colspan="5">There are no manufacturers</td>
					</tr>
<?php
	}
?>
				</table>
			</form>
		</div>
	</div>
	<div id="admin-tab-sheet-new" class="admin-tab-sheet hidden">
		<form name="frmManufacturer" action="admin.php?p=manufacturers#list" enctype="multipart/form-data" method="POST" onsubmit="return checkAddManufacturer(this);">
		<input type="hidden" name="action" value="manufacturer_add">
		<div class="admin-tab-sheet-wrap">
			<div class="admin-form-header first"><span class="icon ic-icon ic-add"></span>Add a new manufacturer</div>
			<table width="100%" cellpadding="0" cellspacing="0" border="0">
				<tr valign="top">
					<td class="formItemCaption required">Manufacturer's Name</td>
					<td class="formItemControl">
						<input type="text" name="manufacturer_name" maxlength="255"/>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption required">Manufacturer's ID</td>
					<td class="formItemControl">
						<input type="text" name="manufacturer_code" maxlength="255"/>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Manufacturer's Page URL</td>
					<td class="formItemControl">
						<input type="text" name="manufacturer_url" maxlength="255"/>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Logo Image</td>
					<td class="formItemControl">
						<input type="file" name="manufacturer_logo"/>
						<div class="formItemComment">
							Supported file types are JPG, GIF and PNG.
						</div>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Available</td>
					<td class="formItemControl">
						<input type="checkbox" name="is_visible" checked="checked"/>
						<div class=" formItemComment">
							Checking this box will allow customers to search for products by this manufacturer.
						</div>
					</td>
				</tr>
			</table>
		</div>
		<div class="admin-form-buttons">
			<input type="submit" value="Save changes"/>
			<input type="reset" value="Reset form"/>
		</div>
		</form>
	</div>
</div>
