<?php
	if (!defined("ENV")) exit();
	///////////////////////////////////////////
	// inherit basic niode & override drawNode
	class OPTION_PARAM{
		var $parent_id;
		var $level;
		function OPTION_PARAM($parent_id, $level){
			$this->parent_id = $parent_id;
			$this->level = $level;
			return $this;
		}
	}

	class OPTION_NODE extends DB_TREE_NODE
	{
		function drawNode($param)
		{
			echo '<option value="'.$this->id.'" '.($this->id == $param->parent_id?"selected":"").' '.($this->is_visible=="No"?'style="color:gray;"':'').'>';
			for ($i=0; $i<$param->level*4; $i++)
			{
				echo "&nbsp;";
			}
			echo gs($this->caption).'</option>';
			if (count($this->nodes)>0)
			{
				reset($this->nodes);
				foreach ($this->nodes as $id => $node)
				{
					$node->drawNode(
						new OPTION_PARAM($param->parent_id, $param->level+1)
					);
				}
			}
		}
	}

	$tree = new DB_TREE();
	$tree->collection[TREE_ROOT] = (new OPTION_NODE(TREE_ROOT, -1, 0, "Yes", "Any"));

	$db->query("SELECT * FROM ".DB_PREFIX."catalog ORDER BY level, priority, name");
	$cats_count = $db->numRows();
	if ($cats_count > 0)
	{
		while ($db->moveNext())
		{
			$tree->addNode(
				new OPTION_NODE(
					$db->col["cid"],
					$db->col["parent"],
					$db->col["level"],
					$db->col["is_visible"],
					$db->col["name"]
				)
			);
		}
	}

	loadJS("cd_product.js");
	pageHeader("Products List", "", "icb-product");

	pageNote(array(
		array("class"=>"ic-add", "text"=>"<b><a href=\"admin.php?p=product&mode=insert\">Click to Add a New Product</a></b>", "url"=>"", "visible"=>true),
		array("class"=>"ic-info", "text"=>"<b>Please enter your search criteria.</b><br>You need to enter at least one search criteria for search results to appear.", "url"=>"", "visible"=>true),
		array("class"=>"ic-info", "text"=>"<span style=\"color:#990000\"><b>Please note: There are currently no product categories in database.</b><br>Please add product categories first</span>", "url"=>"", "visible"=>$cats_count < 1)
	));

	$action = isset($action)?trim($action):"";
	$product_id = isset($product_id)?trim($product_id):"";
	$title = isset($title)?trim($title):"";
	$status = isset($status)?trim($status):"";
	$status = in_array($status, array("Yes", "No", "OutOfStock", "StockWarning"))?$status:"";
	$cid = isset($cid)?$cid*1:TREE_ROOT;
	$where = "";
	$sort_products_by = isset($sort_products_by)?$sort_products_by:"title";
	$sort_products_by = in_array($sort_products_by, array("title", "price_minmax", "price_maxmin", "product_id", "priority", "stock"))?$sort_products_by:"title";

	if (isset($_GET['action']) && $_GET['action'] == "search")
	{
		$_SESSION["admin_search_product_url"] = $_SERVER["QUERY_STRING"];
		switch($sort_products_by){
			case "price_minmax" : 
			{
				$order_sql = "ORDER BY ".DB_PREFIX."products.call_for_price, ".DB_PREFIX."products.price, ".DB_PREFIX."products.title ";
				break;
			}
			case "price_maxmin" : 
			{
				$order_sql = "ORDER BY ".DB_PREFIX."products.call_for_price, ".DB_PREFIX."products.price DESC, ".DB_PREFIX."products.title ";
				break;
			}
			case "product_id" : 
			{
				$order_sql = "ORDER BY ".DB_PREFIX."products.product_id ";
				break;
			}
			case "priority" : 
			{
				$order_sql = "ORDER BY ".DB_PREFIX."products.priority DESC, ".DB_PREFIX."products.title ";
				break;
			}
			case "stock" : 
			{
				$order_sql = "ORDER BY ".DB_PREFIX."products.inventory_control, ".DB_PREFIX."products.stock, ".DB_PREFIX."products.title ";
				break;
			}
			default :
			case "title" : 
			{
				$order_sql = "ORDER BY ".DB_PREFIX."products.title ";
			}
		}

		if ($product_id != "")
		{
			$where .= ($where==""?"WHERE ":" AND ")." product_id LIKE '%".$db->escape($product_id)."%' ";
		}
		if ($title != "")
		{
			$where .= ($where==""?"WHERE ":" AND ")." title LIKE '%".$db->escape($title)."%' ";
		}
		if ($status != "")
		{
			switch ($status)
			{
				case "Yes" :
				case "No" : 
				{
					$where .= ($where==""?"WHERE ":" AND ")." ".DB_PREFIX."products.is_visible = '".$status."' ";
					break;
				}
				case "OutOfStock" : 
				{
					$where .= ($where==""?"WHERE ":" AND ")." ".DB_PREFIX."products.inventory_control != 'No' AND ".DB_PREFIX."products.stock = 0 ";
					break;
				}
				case "StockWarning" : 
				{
					$where .= ($where==""?"WHERE ":" AND ")." ".DB_PREFIX."products.inventory_control != 'No' AND ".DB_PREFIX."products.stock <= stock_warning ";
					break;
				}
			}
		}
		
		if ($cid != "")
		{
			$where .= ($where==""?"WHERE ":" AND ")." ".DB_PREFIX."products.cid = '".$cid."'"; 
		}

		//store last search product statement
		$_SESSION["products-search-where"] = $where;
		//preselect
		$db->query("SELECT COUNT(*) AS c FROM ".DB_PREFIX."products ".$where);//." GROUP BY ".DB_PREFIX."products.pid");
		$db->moveNext();
		//calc page breaks
		$ccc = 20;
		$items_count = $db->col["c"];
		$pages_count = floor($items_count / $ccc) +  ((($items_count % $ccc) > 0 )?1:0);
		$pg = isset($pg)?($pg*1):1;
		$pg = (($pg<1)||($pg>$pages_count))?1:$pg;
		$pages_line = format_pages_line(
			$pg, // current pare
			$pages_count, // total pages
			7,
			"admin.php?p=products".
				"&action=search".
				"&cid=".urlencode($cid).
				"&product_id=".urlencode($product_id).
				"&title=".urlencode($title).
				"&status=".$status.
				"&sort_products_by=".$sort_products_by
		);

		//select
		$db->query("
			SELECT pid, is_doba, product_id, title, is_visible, price, call_for_price, inventory_control, stock FROM ".DB_PREFIX."products
			".$where."
			".$order_sql."
			LIMIT ".(($pg-1)* $ccc).", ".$ccc
		);
	}
	else
	{
		$reset_search = isset($_REQUEST["reset_search"])?true:false;

		if ($reset_search && isset($_SESSION["admin_search_product_url"]))
		{
			unset($_SESSION["admin_search_product_url"]);
		}
		elseif(isset($_SESSION["admin_search_product_url"]) && trim($_SESSION["admin_search_product_url"]) != "")
		{
			header("Location: admin.php?".$_SESSION["admin_search_product_url"]);
		}
	}
?>
<form action="admin.php?p=products" method="GET">
	<input type="hidden" name="p" value="products">
	<input type="hidden" name="action" value="search">

<div class="admin-search-form">
	<div class="admin-search-form-header">Search Products</div>
	<div class="admin-search-form-wrap clearfix">
		<div class="admin-search-form-item">
			<label>Product ID</label>
			<input type="text" name="product_id" value="<?=htmlspecialchars($product_id)?>"/>
		</div>
		<div class="admin-search-form-item">
			<label>Product Name</label>
			<input type="text" name="title" value="<?=htmlspecialchars($title)?>"/>
		</div>
		<div class="admin-search-form-item">
			<label>Category</label>
			<select name="cid">
<?php
	$tree->collection[TREE_ROOT]->drawNode(
		new OPTION_PARAM($cid, 0)
	);
?>
			</select>
		</div>
		<div class="admin-search-form-item">
			<label>Status</label>
			<select name="status">
				<option value="any">Any</option>
				<option value="Yes" <?=$status=="Yes"?"selected":""?>>Available</option>
				<option value="No" <?=$status=="No"?"selected":""?>>Unavailable</option>
				<option value="OutOfStock" <?=$status=="OutOfStock"?"selected":""?>>Out of stock</option>
				<option value="StockWarning" <?=$status=="StockWarning"?"selected":""?>>Stock warning</option>
			</select>
		</div>
		<div class="admin-search-form-item">
			<label>Sort by</label>
			<select name="sort_products_by">
				<option value="title">Product name</option>
				<option value="price_minmax" <?=$sort_products_by=="price_minmax"?"selected":""?>>Unit price (min-max)</option>
				<option value="price_maxmin" <?=$sort_products_by=="price_maxmin"?"selected":""?>>Unit price (max-min)</option>
				<option value="product_id" <?=$sort_products_by=="id"?"selected":""?>>Product ID</option>
				<option value="priority" <?=$sort_products_by=="priority"?"selected":""?>>Priority</option>
				<option value="stock" <?=$sort_products_by=="stock"?"selected":""?>>Stock</option>
			</select>
		</div>
	</div>
	<div class="admin-form-buttons admin-search-form-buttons">
		<input type="submit" value="Search" />
		<input type="reset" value="Reset Search" />
	</div>
</div>
</form>

<?php
	if ($action == "search")
	{
?>
<div class="listHeader">
	<div class="listHeaderIcon"><img src="images/icons/a/zoom.png"/></div>
	<div class="listHeaderCaption">
		Product Search Results
	</div>
<?php
		if ($db->numRows() > 0)
		{
?>
	<div class="listHeaderCaption" style="float:right;font-weight:normal;">
		Products found : <?=$items_count?> |
		Page(s) : <?=trim($pages_line) == ""?0:$pages_line?>
	</div>
<?php	
		}
?>
</div>
<?php
		if ($db->numRows() > 0)
		{
?>
<script type="text/javascript">
$(document).ready(function(){
	$("#product-export-dialog").dialog({
		title: 'Export to CSV',
		modal: true,
		width: 1000,
		height: 700,
		autoOpen: false,
		resizable: false,
		open: function(){
			$(this)
				.width(950)
				.height(500);
			var t = ($(window).height() - parseInt($(this).parent().height())) / 2;
			if (t < 0) t = 0;
			$(this).parent().css('top', parseInt($(window).scrollTop()) + parseInt(t) + 'px');
		},
		buttons:{
			Close : function (){
				$("#product-export-dialog").dialog("close");
			},
			Export : function (){
				$("#product-export-form").submit();
			}
		}
	});
	
	$("#export-to-csv").click(function(){
		$("#product-export-dialog").dialog("open");
	});

	$("#export-all-check").click(function(){
		$("#product-export-form input[type='checkbox']").attr("checked", true);
		return false;
	});

	$("#export-all-uncheck").click(function(){
		$("#product-export-form input[type='checkbox']").removeAttr("checked");
		return false;
	});
});
$(document).ready(function(){
	$("#delete-products").click(function()
	{
		DeleteProducts();
	});
	$("#selectAll").change(function()
	{
		if ($("#selectAll").attr('checked'))
		{
			$("input[name='prodDelete']").attr('checked', 'true');
		}
		else
		{
			$("input[name='prodDelete']").removeAttr('checked');
		}
	});
});
</script>
<table cellpadding="0" cellspacing="0" border="0" width="100%" class="admin-list-table">
	<thead>
		<tr>
			<th class="icon"></th>
			<th class="icon"></th>
			<th style="width:200px;">Product ID</th>
			<th>Product Name</th>
			<th style="width:70px;">Available</th>
			<th style="width:100px;" class="text-align-right">Price</th>
			<th style="width:70px;" class="text-align-right">Stock</th>
			<th style="width:100px;">&nbsp;</th>
		</tr>
    </thead>
	<tbody>
<?php
			while ($db->moveNext())
			{
?>
		<tr>
			<td class="icon"><input type="checkbox" name="prodDelete" value="<?= $db->col["pid"]?>"/></td>
			<td class="icon"><img src="images/icons/a/<?=$db->col["is_doba"] == "Yes"?"record":"product"?>.png"/></td>
			<td><a href="admin.php?p=product&mode=update&pid=<?=$db->col["pid"]?>"><?=htmlspecialchars($db->col["product_id"])?></a></td>
			<td><a href="admin.php?p=product&mode=update&pid=<?=$db->col["pid"]?>"><?=htmlspecialchars($db->col["title"])?></a></td>
			<td><?=$db->col["is_visible"]?></td>
			<td class="text-align-right"><?=$db->col["call_for_price"]=="Yes"?"Call for price":getAdminPrice($db->col["price"])?></td>
			<td class="text-align-right"><?=$db->col["inventory_control"]=="Yes"?$db->col["stock"]:"-"?></td>
			<td class="text-align-right">
				<a href="admin.php?p=product&mode=update&pid=<?=$db->col["pid"]?>"><img src="images/icons/a/pencil.png" border="0" title="Edit Product"></a>
				<a href="admin.php?p=product&mode=insert&pid=<?=$db->col["pid"]?>"><img src="images/icons/a/add.png" border="0" title="Use as a Template"></a>
				<a href="javascript:ConfirmDeleteProduct(<?=$db->col["pid"]?>)"><img src="images/icons/a/delete.png" border="0" title="Delete Product"></a>
			</td>
		</tr>
<?php
			}
?>
	</tbody>
	<tfoot>
		<tr>
			<td><input type="checkbox" id="selectAll"/></td>
			<td colspan="7"><label for="selectAll">Select All</label></td>
		</tr>
		<tr>
			<td colspan="8">
				<input type="button" value="Delete Products" id="delete-products" class="warning"/> &nbsp;
				<input type="button" value="Export to CSV" id="export-to-csv"/>
				<form action="admin.php?no-acceleration=true&p=backup_restore&action=export&mode=csv&chart=true&noheaders=true&from=products-search" method="POST" target="_blank" style="display:inline;margin-left:8px;">
					<input type="hidden" name="export_what" value="inventory">
					<input type="hidden" name="separator" value=",">
					<input type="hidden" name="decimal_separator" value=".">
					<input type="submit" value="Export Inventory" id="export-inventory"/>
				</form>
			</td>
		</tr>
	</tfoot>
</table>
<input type="hidden" id="nonce-product-delete" value="<?php echo create_nonce('product_delete'); ?>"/>
<input type="hidden" id="nonce-product-bulk-delete" value="<?php echo create_nonce('product_bulkDelete'); ?>"/>
&nbsp;
<div class="listFooter">
	<div class="listFooterCaption" style="float:right;font-weight:normal;">
		Products found : <?=$items_count?> |
		Page(s) : <?=trim($pages_line) == ""?0:$pages_line?>
	</div>
</div>
<div id="product-export-dialog">
	<div style="clear:both;width:930px;height:450px;display:block;" class="clearfix">
		<div style="padding-bottom:10px;margin-bottom:10px;border-bottom:1px solid #b0b0b0">
			Please select fields you would like to include in exported CSV file. By default Product ID, Name and Price will be exported.
			<a id="export-all-check" href="#">Check all fields</a> / <a id="export-all-uncheck" href="#">Uncheck all fields</a>
		</div>
		<form id="product-export-form" action="admin.php?no-acceleration=true&p=backup_restore&action=export&mode=csv&chart=true&from=products-search", method="POST" target="_blank">
			<input type="hidden" name="export_what" value="products">
			<input type="hidden" name="separator" value=",">
			<input type="hidden" name="decimal_separator" value=".">
<?php		
		include "content/admin/admin_products_export_fields.php";
		$product_fields = $product_export_fields;
		foreach ($product_fields as $field_key => $field_title)
		{
?>
				<div class="formItemComment" style="width:230px;height:25px;padding:0px;float:left;clear:none;font-size:0.85em;">
					<input type="checkbox" name="ch[<?php echo $field_key;?>]" value="1" id="ch_<?php echo $field_key;?>"><label for="ch_<?php echo $field_key;?>"> <?php echo $field_title;?></label>
				</div>
<?php
		}
?>
		</form>
	</div>
</div>
<?php
		}
		else
		{
?>
<div class="listEmpty">
	Your search did not produce any results. Please try again with a different search criteria.<br/>
	<a href="admin.php?p=products&reset_search=true">Reset Search</a>
</div>
<?php
		}
	}


