<?php
	if (!defined("ENV")) exit();

	loadJS("cd_product_family.js");
	pageHeader("Recommended Products Families", "", "icb-chat-exclamation");

	if (AccessManager::checkAccess('RECOMMENDED'))
	{
		pageNote(
			array(
				array("class"=>"ic-info","url"=>"","text"=>"Use this section to set up Product Families for Recommended Products. Once a Product Family is set up, you can add a family to a product on the Add/Edit Product Page.", "visible"=>true),
				array("class"=>"ic-add","url"=>"admin.php?p=products_family&mode=insert","text"=>"<b>Create a New Product Family</b>", "visible"=>true)
			)
		);

		$db->query("SELECT * FROM ".DB_PREFIX."products_families ORDER BY name");
		if ($db->numRows() > 0)
		{
?>
<table cellpadding="0" cellspacing="0" border="0" width="100%" class="admin-list-table">
	<thead>
		<tr>
			<th class="icon"></th>
			<th colspan="2">Recommended Product Family</th>
		</tr>
	</thead>
	<tbody>
<?php
			while ($db->moveNext())
			{
?>
		<tr>
			<td class="icon"><img src="images/icons/a/chat_exclamation.png"/></td>
			<td><a href="admin.php?p=products_family&mode=update&pf_id=<?=$db->col["pf_id"]?>"><?=htmlspecialchars($db->col["name"])?></a></td>
			<td class="text-align-right">
				<a href="admin.php?p=products_family&mode=update&pf_id=<?=$db->col["pf_id"]?>"><img src="images/icons/a/pencil.png" border="0" title="Click to Edit Products Family"></a>
				<a href="javascript:ConfirmDeleteProductFamily('<?=$db->col["pf_id"]?>')"><img src="images/icons/a/delete.png" border="0" title="Delete Products Family"></a>
			</div>
		</tr>
<?php
			}
?>
	</tbody>
</table>
<?php
		}
		else
		{
			pageNote(array(
				array("class"=>"ic-info", "text"=>"No product families have been entered yet.", "url"=>"", "visible"=>true)
			));
		}
	}
	else
	{
		AccessManager::notAllowed();
	}
