<?php

	require_once("content/classes/class.products_locations.php");

	$productsLocations = new ProductsLocations($db);

	$lastTab = isset($_REQUEST["lastTab"]) ? gs($_REQUEST["lastTab"]) : "Locations";
	$action = isset($_REQUEST["action"]) ? $_REQUEST["action"] : "";
	$nonce = isset($_REQUEST['nonce']) ? $_REQUEST['nonce'] : '';
	$message = "";
	
	
	if ($action == "delete" && !DEMO_LOCK)
	{
		$productsLocationId = isset($_REQUEST["products_location_id"]) ? intval($_REQUEST["products_location_id"]) : 0;
		
		if (!verify_nonce($nonce, 'products_location_delete_'.$productsLocationId))
		{
			invalid_nonce_message();
			exit;
		}
		
		$productsLocations->delete($productsLocationId);
		$message = "Selected product locatoin has been removed";
	}

	if ($action == "updateSettings" && !DEMO_LOCK)
	{
		
		if (!verify_nonce($nonce, 'products_locations_updateSettings'))
		{
			invalid_nonce_message();
			exit;
		}
		
		
		$ProductsLocationsSendOption = isset($_POST["ProductsLocationsSendOption"]) ? $_POST["ProductsLocationsSendOption"] : "admin";
		$db->query("UPDATE ".DB_PREFIX."settings SET value='".$db->escape($ProductsLocationsSendOption)."' WHERE name='ProductsLocationsSendOption'");
		$settings["ProductsLocationsSendOption"] = $ProductsLocationsSendOption;
		$message = "Products locations settings are updated";
	}

	pageHeader("Products Locations", '', 'icb-location');

	pageNote(
		array(
			array("class"=>"ic-add","url"=>"admin.php?p=products_location&mode=new","text"=>"Create new product location", "visible"=>true),
			array("class"=>"ic-info","url"=>"","text"=>"<b>".$message."</b>", "visible"=>$message!="")
		)
	);

	$locations = $productsLocations->getAll();
?>
<div class="admin-tabs admin-tabs-framed" id="tabs-locations">
<?php 
	pageTabs(array(
		array("title"=>"Locations", "id"=>"locations"),
		array("title"=>"Settings", "id"=>"settings")
	), "tabs-locations", $lastTab);
	
	loadJS('products_locations.js');
?>
	<div id="admin-tab-sheet-locations" class="admin-tab-sheet">
		<div class="admin-tab-sheet-wrap">
			<div class="admin-form-header first"><span class="icon ic-icon ic-location"></span>Product Locations</div>
			<table width="100%" cellpadding="0" cellspacing="0" border="0" class="admin-list-table">
				<thead>
					<tr>
						<th class="icon">&nbsp;</th>
						<th>Location Name</th>
						<th style="width:100px;">Type</th>
						<th style="width:110px;">Status</th>
						<th style="width:200px;">Contact Person</th>
						<th style="width:50px;">&nbsp;</th>
					</tr>
				</thead>
				<tbody>
<?php
	if ($locations && count($locations) > 0)
	{
		foreach ($locations as $location)
		{
?>
				<tr>
					<td class="icon">&nbsp;</td>
					<td><a href="admin.php?p=products_location&mode=update&products_location_id=<?=$location["products_location_id"]?>"><?=htmlspecialchars($location["name"])?></a></td>
					<td><?=ucfirst(htmlspecialchars($location["location_type"]))?></td>
					<td><?=ucfirst(htmlspecialchars($location["is_active"] ? "Active" : "Disabled"))?></td>
					<td><a href="mailto:<?=$location["contact_email"]?>"><?=htmlspecialchars($location["contact_name"])?></a></td>
					<td>
						<a href="admin.php?p=products_location&mode=update&products_location_id=<?=$location["products_location_id"]?>"><img src="images/icons/a/pencil.png" border="0" title="Edit Page"></a>
						<input type="hidden" id="products-location-delete-<?=$location["products_location_id"]?>" value="<?=create_nonce('products_location_delete_'.$location['products_location_id'])?>" />
						<a href="javascript:ConfirmDeleteProductsLocation(<?=$location["products_location_id"]?>)"><img src="images/icons/a/delete.png" border="0" title="Delete Location"></a>
					</td>
				</tr>	
<?php
		}
	}
	else
	{
?>
				<tr>
					<td class="icon">&nbsp;</td>
					<td colspan="5">No product locations have been entered yet</td>
				</tr>
<?php
	}
?>
				</tbody>
			</table>
		</div>
	</div>
	<div id="admin-tab-sheet-settings" class="admin-tab-sheet">
		<div class="admin-tab-sheet-wrap">
			<form action="admin.php?p=products_locations" method="post">
				<input type="hidden" name="action" value="updateSettings"/>
				<input type="hidden" name="nonce" value="<?=create_nonce('products_locations_updateSettings')?>" />
				<input type="hidden" name="lastTab" value="Settings"/>
				<div class="admin-form-header first"><span class="icon ic-icon"></span>Settings</div>
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr valign="top">
						<td class="formItemCaption">
							When do you want to send notifications?
							<div class="formItemComment">
								To edit notification email template <a href="admin.php?p=email_notification&id=products_location_notification">please click here</a>.
							</div>
						</td>
						<td class="formItemControl">
							<input type="radio" name="ProductsLocationsSendOption" id="ProductsLocationsSendOptionAdmin" value="admin" <?=$settings["ProductsLocationsSendOption"]=="admin"?"checked":""?>/><label for="ProductsLocationsSendOptionAdmin">When administrator confirms order and set status to "Completed"</label><br/>
							<input type="radio" name="ProductsLocationsSendOption" id="ProductsLocationsSendOptionUser" value="user" <?=$settings["ProductsLocationsSendOption"]=="user"?"checked":""?>/><label for="ProductsLocationsSendOptionUser">When payment is received from user or when administrator set payment status to "Received"</label><br/>
							<input type="radio" name="ProductsLocationsSendOption" id="ProductsLocationsSendOptionOff" value="off" <?=$settings["ProductsLocationsSendOption"]=="off"?"checked":""?>/><label for="ProductsLocationsSendOptionOff">Turn off this feature</label><br/>
						</td>
					</tr>
				</table>
				<div class="admin-form-buttons">
					<input type="submit" value="Save changes"/>
					<input type="reset" value="Reset form"/>
				</div>
			</form>
		</div>
	</div>
</div>

