<?php
	if (!defined("ENV")) exit();
?>
<link rel="stylesheet" type="text/css" href="content/vendors/jquery/rater/rater.css" />
<script language="javascript" type="text/javascript" src="content/vendors/jquery/rater/jquery.rater-custom.js"></script>
<?php
	loadJS("product_reviews.js");
	pageHeader("Manage Product Reviews", "", "icb-pencil");
	pageNote(array(
		array("class"=>"ic-info", "text"=>"<b>Please enter in your search criteria.</b><br>You need to enter at least one search criteria for search to be effective", "url"=>"", "visible"=>true)
	));
	
	$mode = isset($_REQUEST["mode"]) ? $_REQUEST["mode"] : false;
	if ($mode)
	{
		switch ($mode)
		{
			case 'update':
				$valid_fields = array(
					'ReviewsEnable',
					'ReviewsShowSummary',
					'ReviewsAutoApprove',
					'ReviewsAutoApproveRating',
					'ReviewsAutoApprovePurchased',
					'ReviewsCustomImage'
				);

				if (!DEMO_LOCK)
				{
					foreach ($valid_fields as $fieldname)
					{
						if (!isset($_POST[$fieldname])) $_POST[$fieldname] = 0;
						$db->reset();
						$db->assignStr("value", $_POST[$fieldname]);
						$db->update(DB_PREFIX."settings", "WHERE name='".$fieldname."'");
						$settings[$fieldname] = $_POST[$fieldname];
					}
				}
				break;
		}
	}

	$action = isset($action)?trim($action):"";
	$product_id = isset($product_id)?trim($product_id):"";
	$title = isset($title)?trim($title):"";
	$keywords = isset($keywords)?trim($keywords):"";
	$reviewer = isset($reviewer)?trim($reviewer):"";
	$approval_status = isset($approval_status)?trim($approval_status):"";
	$where = "";
	$sort_products_by = isset($sort_products_by)?$sort_products_by:"title";
	$sort_products_by = in_array($sort_products_by, array("title", "rating", "approval_status", "product_id", "reviewer"))?$sort_products_by:"title";

	if ($action == "search")
	{
		$_SESSION["admin_search_product_reviews_url"] = $_SERVER["QUERY_STRING"];
		switch ($sort_products_by)
		{
			case "rating" :
			{
				$order_sql = "ORDER BY pr.rating DESC ";
				break;
			}
			case "product_id" :
			{
				$order_sql = "ORDER BY product_id ";
				break;
			}
			case "approval_status" :
			{
				$order_sql = "ORDER BY approved DESC ";
				break;
			}
			case "reviewer" :
			{
				$order_sql = "ORDER BY email, title ";
				break;
			}
			default :
			{
				$order_sql = "ORDER BY title ";
			}
		}

		if ($product_id != "")
		{
			$where .= ($where==""?"WHERE ":" AND ")." pr.pid LIKE '%".$db->escape($product_id)."%'";
		}
		if ($title != "")
		{
			$where .= ($where==""?"WHERE ":" AND ")." p.title LIKE '%".$db->escape($title)."%' ";
		}
		if ($keywords != '')
		{
			$where .= ($where==''?'WHERE ':' AND ')." pr.review_text LIKE '%".$db->escape($keywords)."%' ";
		}
		if ($reviewer != '')
		{
			$where .= ($where==''?'WHERE ':' AND ')." u.email LIKE '%".$db->escape($reviewer)."%' ";
		}
		if ($approval_status != "")
		{
			switch($approval_status)
			{
				case "0" :
				case "1" :
				{
					$where .= ($where==""?"WHERE ":" AND ")." approved = '".$approval_status."' ";
					break;
				}
			}
		}

		//preselect
		$db->query("
			SELECT SQL_CALC_FOUND_ROWS * FROM ".DB_PREFIX."products_reviews AS pr
			JOIN ".DB_PREFIX."products AS p ON p.pid = pr.pid
			JOIN ".DB_PREFIX."users AS u ON u.uid = pr.user_id
			".$where."
		");

		//calc page breaks
		$ccc = 20;
		$items_count = $db->numRows();
		$pages_count = floor($items_count / $ccc) +  ((($items_count % $ccc) > 0 )?1:0);
		$pg = isset($pg)?($pg*1):1;
		$pg = (($pg<1)||($pg>$pages_count))?1:$pg;
		$pages_line = format_pages_line(
			$pg, // current pare
			$pages_count, // total pages
			7,
			"admin.php?p=products_reviews".
				"&action=search".
				"&product_id=".urlencode($product_id).
				"&title=".urlencode($title).
				"&status=".$approval_status.
				"&keywords=".$keywords.
				"&sort_products_by=".$sort_products_by
		);
		//select
		$db->query("
			SELECT SQL_CALC_FOUND_ROWS
				pr.id AS review_id, pr.pid, p.product_id, pr.user_id, pr.review_title, pr.review_text, pr.rating, pr.is_visible, pr.date_created, pr.approved, p.title, u.email
			FROM ".DB_PREFIX."products_reviews AS pr
			JOIN ".DB_PREFIX."products AS p ON p.pid = pr.pid
			JOIN ".DB_PREFIX."users AS u ON u.uid = pr.user_id
			".$where."
			".$order_sql."
			LIMIT ".(($pg-1)* $ccc).", ".$ccc
		);
	}
	else
	{
		$reset_search = isset($_REQUEST["reset_search"])?true:false;

		if($reset_search && isset($_SESSION["admin_search_product_reviews_url"])){
			unset($_SESSION["admin_search_product_reviews_url"]);
		}
		elseif(isset($_SESSION["admin_search_product_reviews_url"]) && trim($_SESSION["admin_search_product_reviews_url"]) != ""){
			header("Location: admin.php?".$_SESSION["admin_search_product_reviews_url"]);
		}
	}

	$last_active_tab = isset($last_active_tab)?trim($last_active_tab):"idTabReviews";
?>
<div class="admin-tabs admin-tabs-framed" id="tabs-reviews">
<?php 
	pageTabs(array(
		array("title"=>"Reviews", "id"=>"main"),
		array("title"=>"Settings", "id"=>"settings"),
	), "tabs-reviews", false);
?>
	<div id="admin-tab-sheet-main" class="admin-tab-sheet">
		<div class="admin-tab-sheet-wrap">
			<form action="admin.php?p=products_reviews" method="GET">
				<input type="hidden" name="p" value="products_reviews"/>
				<input type="hidden" name="action" value="search"/>
				
				<div class="admin-search-form">
					<div class="admin-search-form-header">Search Product Review</div>
					<div class="admin-search-form-wrap clearfix">
						<div class="admin-search-form-item">
							<label>Product ID:</label>
							<input type="text" name="product_id" value="<?=htmlspecialchars($product_id)?>"/>
						</div>
						<div class="admin-search-form-item">
							<label>Product Name:</label>
							<input type="text" name="title" value="<?=htmlspecialchars($title)?>"/>
						</div>
						<div class="admin-search-form-item">
							<label>Keyword:</label>
							<input type="text" name="keywords" value="<?=htmlspecialchars($keywords)?>"/>
						</div>
						<div class="admin-search-form-item">
							<label>Reviewer:</label>
							<input type="text" name="reviewer" value="<?=htmlspecialchars($reviewer)?>"/>
						</div>
						<div class="admin-search-form-item">
							<label>Approval Status:</label>
							<select name="approval_status" >
								<option value="any">Any</option>
								<option value="1" <?=$approval_status=="1"?"selected":""?>>Approved</option>
								<option value="0" <?=$approval_status=="0"?"selected":""?>>Waiting Approval</option>
							</select>
						</div>
						<div class="admin-search-form-item">
							<label>Sort by:</label>
							<select name="sort_products_by">
								<option value="title">Product name</option>
								<option value="product_id" <?=$sort_products_by=="product_id"?"selected":""?>>Product ID</option>
								<option value="rating" <?=$sort_products_by=="rating"?"selected":""?>>Rating</option>
								<option value="approval_status" <?=$sort_products_by=="approval_status"?"selected":""?>>Approval status</option>
								<option value="reviewer" <?=$sort_products_by=="reviewer"?"selected":""?>>Reviewer</option>
							</select>
						</div>
					</div>
					<div class="admin-form-buttons admin-search-form-buttons">
						<input type="submit" value="Search"/>
						<a href="admin.php?p=products_reviews&reset_search=true">Reset Search</a>
					</div>
				</div>
			</form>
			<div style="clear:both;"></div>
	
<?php
	 if($action == "search")
	 {
?>
			<div class="listHeader">
				<div class="listHeaderIcon"><img src="images/icons/a/zoom.png"/></div>
				<div class="listHeaderCaption">
					Product Review Search Results
				</div>
<?php
		if ($db->numRows() > 0)
		{
?>
				<div class="listHeaderCaption" style="float:right;font-weight:normal;">
					Reviews found : <?=$items_count?> |
					Page(s) : <?=trim($pages_line) == ""?0:$pages_line?>
				</div>
<?php
		} // end if $db->numRows() > 0
?>
			</div>
<?php
		if ($db->numRows() > 0)
		{
?>
			<form action="admin.php?p=products_reviews_process" method="POST">
			<input type="hidden" name="action" value="search">
			<div class="listHeader">
				<div class="listHeaderIcon">&nbsp;</div>
				<div class="listHeaderCaption" style="width:250px;">Product Name</div>
				<div class="listHeaderCaption" style="width:100px;">Product ID</div>
				<div class="listHeaderCaption" style="width:100px;">Rating</div>
				<div class="listHeaderCaption" style="width:100px;">Approved</div>
				<div class="listHeaderCaption" style="width:200px;">Reviewer</div>
				<div class="listHeaderCaption" style="width:75px;">Is visible</div>
			</div>
<?php
			while ($db->moveNext())
			{
?>
			<div class="listItem" title="<?=$db->col['review_id']?>">
				<div class="listItemIcon"><input class="review" type="checkbox" name="reviews[]" value="<?=$db->col["review_id"]?>" /></div>
				<div class="listItemText" style="width:250px;">
					<!--<a href="admin.php?p=products_info&printing=true&height=600&width=800&pid=<?=$db->col["pid"]?>" class="thickbox"> -->
					<?=htmlspecialchars($db->col["title"])?>
					<!-- </a> -->
					<div style="padding:5px;">
						<?=((strlen($db->col['review_text']) < 40) ? htmlspecialchars($db->col['review_text']) : htmlspecialchars(substr($db->col['review_text'], 0, 40).'...'))?><br/>
						<a href="admin.php?p=products_reviews_info&printing=true&chart=true&rid=<?=$db->col["review_id"]?>" title="<?=$db->col["email"]?>" class="read-review">(Read Review)</a>
					</div>
				</div>
				<div class="listItemText" style="width:100px;">
					<!--<a href="admin.php?p=products_info&printing=true&height=600&width=800&pid=<?=$db->col["pid"]?>" class="thickbox"> -->
					<a href="admin.php?p=product&mode=update&pid=<?=$db->col["pid"]?>"><?=htmlspecialchars($db->col["product_id"])?></a>
					<!--</a>-->
				</div>
				<div class="listItemText" style="width:100px;">
					<div class="rating" title="<?=$db->col["rating"]?>"></div>
					<p style="padding-left: 14px; color: #999;"><?=$db->col["rating"]?> / 5</p>
				</div>
				<div class="listItemText reviewApproved" style="width:100px;"><?=$db->col["approved"]=="1"?'<img src="images/admin/check_16x16.png" />':''?></div>
				<div class="listItemText" style="width:200px;">
					<!--<a href="admin.php?p=user_profile&printing=true&height=500&width=750&uid=<?=$db->col["user_id"]?>" class="thickbox" title="<?=$db->col["email"]?>"> -->
					<a href="admin.php?p=user&uid=<?=$db->col["user_id"]?>"><?=$db->col["email"]?></a>
					<!--</a> -->
				</div>
				<div class="listItemText reviewVisible" style="width:100px;"><?=$db->col["is_visible"]=="1"?'<img src="images/admin/check_16x16.png" />':''?></div>
			</div>
<?php
			} // end while
?>
	
			<div class="listItem">
				<div class="listItemIcon" style="padding-left:3px;padding-top:3px;">
					<img src="images/icons/a/arrow_up.png"/>
				</div>
				<div class="listItemText">
					<a id="check_all" href="#">check all</a> | <a id="uncheck_all" href="#">uncheck all</a>
				</div>
			</div>
			<div class="listFooter">
				<div class="listFooterCaption" style="float:right;font-weight:normal;">
					Reviews found : <?=$items_count?> | Page(s) : <?=trim($pages_line) == ""?0:$pages_line?>
				</div>
			</div>
			<div class="clearfix">
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr valign="top">
						<td class="formItemCaption">Set visibility</td>
						<td class="formItemControl">
							<select name="set_is_visible" class="short">
								<option value="">Keep current</option>
								<option value="1">Display</option>
								<option value="0">Hide</option>
							</select>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Set approval status</td>
						<td class="formItemControl">
							<select name="set_approved" class="short">
								<option value="">Keep current</option>
								<option value="1">Approved</option>
								<option value="0">Waiting Approval</option>
							</select>
						</td>
				</table>
				<div class="admin-form-buttons">
					<input id="apply_changes" name="apply_changes" type="submit" value="Apply changes">
					<input id="delete_reviews" name="delete_reviews" type="submit" value="Delete checked">
				</div>
			</div>
			</form>
	
<?php
		}
		else
		{
?>
			<div class="listEmpty">
				Your search did not produce any results. Please try again with a different search criteria.<br/>
				<a href="admin.php?p=products_reviews&reset_search=true">Reset Search</a>
			</div>
<?php
		} // end if
	} // end search if
?>
		</div>
	</div>
<?php

	$selected = array(
			'ReviewsAutoApproveRating' => array(
				'0' => '',
				'1' => '',
				'2' => '',
				'3' => '',
				'4' => '',
				'5' => ''
			),
			'ReviewsAutoApprovePurchased' => array(
				'0' => '',
				'1' => ''
			)
		);

	foreach (array('ReviewsAutoApprove', 'ReviewsAutoApproveRating', 'ReviewsAutoApprovePurchased', 'ReviewsEnable', 'ReviewsShowSummary', 'ReviewsCustomImage') as $key)
	{
		$checked[$key] = ($settings[$key]) ? 'checked="checked"' : '';
		$selected[$key][$settings[$key]] = 'selected="selected"';
	}
?>
	<div id="admin-tab-sheet-settings" class="admin-tab-sheet hidden">
		<div class="admin-tab-sheet-wrap">
			<form name="frmSettings" id="frmSettings" action="admin.php?p=products_reviews&mode=update" method="post">
				<input type="hidden" name="action" value="enable"/>
				<input type="hidden" name="last_active_tab" value="idTabSettings"/>
				<div class="admin-form-header first"><span class="icon ic-icon ic-pencil"></span>Product Reviews Settings</div>
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr valign="top">
						<td class="formItemCaption">Activate Product Reviews</td>
						<td class="formItemControl">
							<input type="checkbox" name="ReviewsEnable" value="1" <?=$checked['ReviewsEnable']?> />
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Show review summary on Category Page</td>
						<td class="formItemControl">
							<input type="checkbox" name="ReviewsShowSummary" value="1" <?=$checked['ReviewsShowSummary']?> />
						</td>
					</tr>
				</table>
				
				<div class="admin-form-header"><span class="icon ic-icon ic-gear"></span>Auto-Approve</div>
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr valign="top">
						<td class="formItemCaption">Activate Auto-Approve</td>
						<td class="formItemControl">
							<input type="checkbox" name="ReviewsAutoApprove" value="1" <?=$checked['ReviewsAutoApprove']?> />
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">
							Auto-approve any review where the rating is above:
						</td>
						<td class="formItemControl">
							<select name="ReviewsAutoApproveRating" class="tiny">
								<option <?=$selected['ReviewsAutoApproveRating']['0']?> value="0">0</option>
								<option <?=$selected['ReviewsAutoApproveRating']['1']?> value="1">1</option>
								<option <?=$selected['ReviewsAutoApproveRating']['2']?> value="2">2</option>
								<option <?=$selected['ReviewsAutoApproveRating']['3']?> value="3">3</option>
								<option <?=$selected['ReviewsAutoApproveRating']['4']?> value="4">4</option>
								<option <?=$selected['ReviewsAutoApproveRating']['5']?> value="5">5</option>
							</select>
							<select name="ReviewsAutoApprovePurchased">
								<option <?=$selected['ReviewsAutoApprovePurchased']['1']?> value="1">and has purchased the product</option>
								<option <?=$selected['ReviewsAutoApprovePurchased']['0']?> value="0">and has not purchased the product</option>
							</select>
						</td>
					</tr>
				</table>
				<div class="admin-form-buttons">
					<input type="submit" value="Save changes" />
					<input type="reset" value="Reset form" />
				</div>
			</form>
		</div>
	</div>
</div>

<div id="dialog-read-review" style="display: none;">
	<h2><span class="reviewer_name"></span> wrote:</h2>
	<blockquote class="review_text"></blockquote>
</div>