<?php
	if (!defined("ENV")) exit();
	
	$action = isset($action)?$action:"";
	
	if ($action != '')
	{
		$nonce = isset($nonce) ? $nonce : '';
		$nonce_valid = verify_nonce($nonce, 'settings_email_update');
		if (!$nonce_valid)
		{
			invalid_nonce_message();
			exit;
		}
	}
	
	if($action == "update" && !DEMO_LOCK){
		$form = isset($form)?$form:array();
		foreach($form as $name=>$value){
			$db->query("UPDATE ".DB_PREFIX."settings SET value='".$db->escape($value)."' WHERE name='".$db->escape($name)."'");
			$settings[$name] = $value;
		}
	}
	
	pageHeader("POP3 and SMTP Email Settings", "", "icb-envelope-gear");
	pageNote(array(
		array("class"=>"ic-info", 
			"text"=>"Use this page to set up your POP3 email account and to manage bounced and bad email addresses.", "url"=>"", "visible"=>true)
	));
	
	loadJS("cf_settings_pop3.js");
?>
<form name="frmSettings" action="admin.php?p=settings_email" method="post" onsubmit="return CheckSettingForm(this)">
	<input type="hidden" name="action" value="update">
	<input type="hidden" name="nonce" value="<?=create_nonce('settings_email_update')?>" />
	<input type="hidden" name="p" value="settings_email">
	<div class="admin-tabs admin-tabs-framed" id="tabs-email">
<?php 	
	pageTabs(array(
		array("title"=>"POP3 and SMTP Email Settings", "id"=>"main")
	), "tabs-email", false);
?>
		<div id="admin-tab-sheet-main" class="admin-tab-sheet">
			<div class="admin-tab-sheet-wrap">
				<div class="admin-form-header first"><span class="icon ic-icon ic-envelope-gear"></span>Sendmail Settings</div>
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr valign="top">
						<td class="formItemCaption">Sendmail Engine</td>
						<td class="formItemControl">
							<select name="form[EmailSendmailEngine]">
								<option value="mail">Use PHP mail Function (simple)</option>
								<option value="phpmailer" <?=$settings["EmailSendmailEngine"]=="phpmailer"?'selected="selected"':''?>>Use SMTP Server (advanced)</option>
							</select>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Sendmail EOL Character</td>
						<td class="formItemControl">
							<select name="form[EmailSendmailEolCharacter]">
								<option value="\r\n" <?=$settings["EmailSendmailEolCharacter"]=='\r\n'?'selected="selected"':''?>>\r\n (Recommended)</option>
								<option value="\r" <?=$settings["EmailSendmailEolCharacter"]=='\r'?'selected="selected"':''?>>\r</option>
								<option value="\n" <?=$settings["EmailSendmailEolCharacter"]=='\n'?'selected="selected"':''?>>\n</option>
							</select>
						</td>
					</tr>
				</table>
				<div class="admin-form-header"><span class="icon ic-icon ic-server"></span>SMTP Server Settings</div>
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr valign="top">
						<td class="formItemCaption">Security Settings</td>
						<td class="formItemControl">
							<select name="form[EmailSMTPSecure]">
								<option value="">None</option>
								<option value="ssl" <?=$settings["EmailSMTPSecure"]=="ssl"?'selected="selected"':''?>>SSL</option>
								<option value="tls" <?=$settings["EmailSMTPSecure"]=="tls"?'selected="selected"':''?>>TLS</option>
							</select>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">SMTP Server Name</td>
						<td class="formItemControl"><input type="text" name="form[EmailSMTPServer]" value="<?=gs($settings["EmailSMTPServer"])?>"></td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">SMTP Server Port</td>
						<td class="formItemControl"><input type="text" name="form[EmailSMTPPort]" class="short" value="<?=gs($settings["EmailSMTPPort"])?>"></td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">SMTP Server Username</td>
						<td class="formItemControl"><input type="text" name="form[EmailSMTPLogin]" class="short" value="<?=gs($settings["EmailSMTPLogin"])?>"></td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">SMTP Server Password</td>
						<td class="formItemControl"><input type="text" name="form[EmailSMTPPassword]" class="short" value="<?=gs($settings["EmailSMTPPassword"])?>"></td>
					</tr>
				</table>
				
				<div class="admin-form-header"><span class="icon ic-icon ic-gear"></span>POP3 Protocol Settings</div>
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr valign="top">
						<td class="formItemCaption">POP3 Server Name</td>
						<td class="formItemControl"><input type="text" name="form[EmailPop3Server]" value="<?=gs($settings["EmailPop3Server"])?>"></td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">POP3 Server Port</td>
						<td class="formItemControl"><input type="text" name="form[EmailPop3Port]" class="short" value="<?=gs($settings["EmailPop3Port"])?>"></td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">POP3 Server Username</td>
						<td class="formItemControl"><input type="text" name="form[EmailPop3Login]" class="short" value="<?=gs($settings["EmailPop3Login"])?>"></td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">POP3 Server Password</td>
						<td class="formItemControl"><input type="text" name="form[EmailPop3Password]" class="short" value="<?=gs($settings["EmailPop3Password"])?>"></td>
					</tr>
				</table>
				
				<div class="admin-form-header"><span class="icon ic-icon ic-gear"></span>Undeliverable Email Settings</div>
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr valign="top">
						<td class="formItemCaption">How many attempts on email delivery?</td>
						<td class="formItemControl"><input type="text" name="form[EmailPop3Fault]" class="short" value="<?=gs($settings["EmailPop3Fault"])?>"></td>
					</tr>
				</table>
			</div>
		</div>
	</div>
	<div class="admin-form-buttons">
		<input type="submit" value="Save changes"/>
		<input type="reset" value="Reset form"/>
	</div>
</form>	
