<?php
	if (!defined("ENV")) exit();

	pageHeader("Wholesale Settings", "", "icb-osi-model");
	pageNote(array(
		array("class"=>"ic-info", "text"=>"Use the settings below if you are selling wholesale.<br/>Information here can be viewed on the \"Add a Product\" page as well as appearing to wholesale buyers on the front end of the website after they are logged in.", "url"=>"", "visible"=>true)
	));
	
	$action = isset($action)?$action:"";
	
	if ($action != '')
	{
		$nonce = isset($nonce) ? $nonce : '';
		$nonce_valid = verify_nonce($nonce, 'wholesale_update');
		if (!$nonce_valid)
		{
			invalid_nonce_message();
			exit;
		}
	}
	
	if($action == "update" && !DEMO_LOCK){
		$form = isset($form)?$form:array();
		foreach($form as $name=>$value){
			$db->query("UPDATE ".DB_PREFIX."settings SET value='".$db->escape($value)."' WHERE name='".$name."'");
			$settings[$name] = $value;
		}
	}
?>
<form name="frmSettings" action="admin.php?p=settings_wholesale" method="post">
	<input type="hidden" name="action" value="update">
	<input type="hidden" name="nonce" value="<?=create_nonce('wholesale_update')?>" />
	<div class="admin-tabs admin-tabs-framed" id="tabs-wholesale">
<?php 
	pageTabs(array(
		array("title"=>"Wholesale Settings", "id"=>"main")
	), "tabs-wholesale", false);
?>
		<div id="admin-tab-sheet-main" class="admin-tab-sheet">
			<div class="admin-tab-sheet-wrap">
				<div class="admin-form-header first"><span class="icon ic-icon ic-gear"></span>Wholesale Settings</div>
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr valign="top">
						<td class="formItemCaption">Activate wholesaler discounts at</td>
						<td class="formItemControl">
							<select name="form[WholesaleDiscountType]">
								<option value="NO">I don't have wholesalers</option>
								<option value="PRODUCT" <?=$settings["WholesaleDiscountType"]=="PRODUCT"?"selected":""?>>Add discounts at product level</option>
								<option value="GLOBAL" <?=$settings["WholesaleDiscountType"]=="GLOBAL"?"selected":""?>>Calculate discounts globally</option>
							</select>
							<div class="formItemComment">
								If "product level" is selected, you will need to enter in wholesale prices for each product. 
								If "globally" is selected, cart will automatically adjust wholesale prices based on the percentage discount you outline below.
							</div>
						</td>
					</tr>
				</table>
				
				<div class="admin-form-header"><span class="icon ic-icon ic-gear"></span>Wholesale Global Discounts</div>
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr valign="top">
						<td class="formItemCaption">How many wholesale levels do you have?</td>
						<td class="formItemControl">
							<select name="form[WholesaleMaxLevels]" class="short" onChange="document.forms['frmSettings'].submit();">
								<option value="1">1</option>
								<option value="2" <?=$settings["WholesaleMaxLevels"]=="2"?"selected":""?>>2</option>
								<option value="3" <?=$settings["WholesaleMaxLevels"]=="3"?"selected":""?>>3</option>
							</select>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Discount percentage level 1, %</td>
						<td class="formItemControl"><input type="text" name="form[WholesaleDiscount1]" class="short" value="<?=gs($settings["WholesaleDiscount1"])?>"></td>
					</tr>
<?php
	if ($settings["WholesaleMaxLevels"] != "1")
	{
?>
					<tr valign="top">
						<td class="formItemCaption">Discount percentage level 2, %</td>
						<td class="formItemControl"><input type="text" name="form[WholesaleDiscount2]" class="short" value="<?=gs($settings["WholesaleDiscount2"])?>"></td>
					</tr>
<?php
		if ($settings["WholesaleMaxLevels"] != "2")
		{
?>	
					<tr valign="top">
						<td class="formItemCaption">Discount percentage level 3, %</td>
						<td class="formItemControl"><input type="text" name="form[WholesaleDiscount3]" class="short" value="<?=gs($settings["WholesaleDiscount3"])?>"></td>
					</tr>
<?php
		}
	}
?>
				</table>
				<div class="admin-form-header"><span class="icon ic-icon ic-gear"></span>Case Pack / Inter Pack Settings</div>
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr valign="top">
						<td class="formItemCaption">Allow wholesale case pack?</td>
						<td class="formItemControl">
							<select name="form[WholesaleCasePack]" class="short">
								<option value="YES">Yes</option>
								<option value="NO" <?=$settings["WholesaleCasePack"]=="NO"?"selected":""?>>No</option>
							</select>
						</td>
					</tr>
					<tr valign="top">
						<td class="formItemCaption">Allow wholesale inter pack?</td>
						<td class="formItemControl">
							<select name="form[WholesaleInterPack]" class="short">
								<option value="YES">Yes</option>
								<option value="NO" <?=$settings["WholesaleInterPack"]=="NO"?"selected":""?>>No</option>
							</select>
						</td>
					</tr>
				</table>
			</div>
		</div>
	</div>
	<div class="admin-form-buttons">
		<input type="submit" value="Save changes"/>
		<input type="reset" value="Reset form"/>
	</div>
</form>