<?php
	if (!defined("ENV")) exit();

	require_once("content/classes/class.products.php");
	require_once("content/classes/class.taxes.php");
	require_once("content/classes/class.catalog.php");

	$class_id = isset($_REQUEST["class_id"])?intval($_REQUEST["class_id"]):0;
	$selected_cid = isset($_REQUEST["selected_cid"])?intval($_REQUEST["selected_cid"]):0;
	
	$taxes = new Taxes($db);
	$taxes->demo = defined('DEMO_LOCK') && DEMO_LOCK;
	
	$tax_class = $taxes->getTaxClassById($class_id);
	
	$mode = isset($_GET["mode"]) ? $_GET["mode"] : "";
	
	switch ($mode)
	{
		case "getProducts" :
		{
			$categories = isset($_GET["categories"]) ? $_GET["categories"] : "0";
			$categories = trim($categories) == "" ? "0" : $categories;
			$catagories = preg_match("/^([0-9\,])+$/", $categories) ? $categories : "0";
		
			if ($categories == "0")
			{
				$q = "SELECT pid, tax_class_id, title FROM ".DB_PREFIX."products ORDER BY title";
			}
			else
			{
				$q = "SELECT pid, tax_class_id, title FROM ".DB_PREFIX."products WHERE cid IN (".$categories.") ORDER BY title";
			}
			$db->query($q);
			echo json_encode(array("count"=>$db->numRows(), "products"=>$db->getRecords()));
			exit;
		}
		
		case "assignProducts" :
		{
			if ($tax_class)
			{
				$categories = isset($_GET["categories"]) ? $_GET["categories"] : "0";
				$categories = trim($categories) == "" ? "0" : $categories;
				$catagories = preg_match("/^([0-9\,])+$/", $categories) ? $categories : "0";

				$products = isset($_GET["products"]) ? $_GET["products"] : "0";
				$products = trim($products) == "" ? "0" : $products;
				$products = preg_match("/^([0-9\,])+$/", $products) ? $products : "0";
				
				/**
				 * Unassign old associations with current class
				 */
				if ($categories == "0")
				{
					$q = "UPDATE ".DB_PREFIX."products SET tax_class_id = 0 WHERE tax_class_id='".$class_id."'";
				}
				else
				{
					$q = "UPDATE ".DB_PREFIX."products SET tax_class_id = 0 WHERE tax_class_id='".$class_id."' AND cid IN (".$categories.")";
				}
				
				$db->query($q);
				
				/**
				 * Assign new products
				 */
				$db->query($q = "UPDATE ".DB_PREFIX."products SET is_taxable='Yes', tax_class_id = '".$class_id."', tax_rate='-1.00000' WHERE pid IN (".$products.")");
				echo json_encode(array("result"=>1));
				exit;
			}
		}
	}
	
	
	if ($tax_class)
	{
	
		/**
		 * Select categories
		 */
		$tree = array(0=>array("cid" => 0, "level" => 0, "is_visible" => "Yes", "key_name" => "", "name" => "All categories"));
		$db->query("SELECT * FROM ".DB_PREFIX."catalog ORDER BY level, priority, name");
		while($node = $db->moveNext())
		{
			$node["children"] = array();
			$tree[$node["cid"]] = $node;
			$tree[$node["parent"]]["children"][$node["cid"]] = &$tree[$node["cid"]];
		}
		
		/**
		 * Draw tree
		 */
		function drawTree(&$tree, $level)
		{
			foreach ($tree as $node)
			{
				if (!isset($node["level"]))
				{
					//print_r($node);
				}
				if ($node["level"] == $level)
				{ 
					echo '<option value="'.$node["cid"].'">'.str_repeat("&nbsp;", $node["level"] * 4).htmlspecialchars($node["name"]).'</option>'."\n";
					if (count($node["children"]) > 0)
					{
						drawTree($node["children"], $level + 1);
					}
				}
			}
		}
		
		/**
		 * Show page
		 */
		pageHeader("Bulk Assign Tax Class - ".htmlspecialchars($tax_class["class_name"]), "", "icb-tax");
		pageNote(array(
			array("class"=>"ic-world", "text"=>"Back to Taxes Classes", "url"=>"admin.php?p=taxes&amp;last_active_tab=classes&amp;tax_mode=advanced", "visible"=>true)
		));
?>
<div class="admin-tabs admin-tabs-framed" id="tabs-class">
<?php 
		pageTabs(array(
			array("title"=>"Tax Class Products", "id"=>"main"),
		), "tabs-class", false);
?>
	<div id="admin-tab-sheet-main" class="admin-tab-sheet">
		<div class="admin-tab-sheet-wrap">
			<form id="formTaxClassProducts" name="formTaxClassProducts">
				<input type="hidden" id="tax_class_id" value="<?=$class_id?>"/>
				<div class="admin-form-header first"><span class="icon ic-icon"></span>Tax Class - <?=htmlspecialchars($tax_class["class_name"])?></div>
				<table width="100%" cellpadding="0" cellspacing="0" border="0">
					<tr>
						<td height="360" width="50%" align="center">
							<div style="padding-left:30px;padding-right:10px;">
								<div align="left">Categories :</div>
								<select size="24" style="width:100%" id="selectCategories" name="categories" multiple="multiple">
									<option value="0" selected="selected">All Categories</option>
<?php
	drawTree($tree, 1); 
?>							
								</select>
							</div>
						</td>
						<td height="360" width="50%" align="center">
							<div style="padding-right:30px;padding-left:10px;">
								<div align="left" id="divProductsTitle">Products :</div>
								<select size="24" style="width:100%" id="selectProducts" name="products" multiple="multiple">
								</select>
							</div>
						</td>
					</tr>
				</table>
				<div class="admin-form-buttons">
					<input type="button" value="Save changes" id="buttonSaveChanges"/>
				</div>
			</form>
		</div>
	</div>
</div>
		
		<script type="text/javascript" src="content/admin/javascript/taxes_class.js"></script>
<?php
	}
?>
