<?php
	if (!defined("ENV")) exit();

	$regions = new Regions($db);
	$regions->demo = defined('DEMO_LOCK') && DEMO_LOCK;
	
	$countries_states = $regions->getCountriesStates(false);
	$taxes_classes = $taxes->getTaxClassesList();
	loadJS("regions.js");
	
	switch ($action)
	{
		case "deleteRate" :
		{
			$rate_id = isset($_REQUEST["rate_id"])?intval($_REQUEST["rate_id"]):0;
			$taxes->deleteRate($rate_id);
			break;
		}
		case "addRate" :
		{
			$country_data = $taxes->getCountryById($_REQUEST["coid"]);
			$state_data = $taxes->getStateById($_REQUEST["stid"]);
			$zone_name = ($country_data?$country_data["name"]:"All Countries")." - ".($state_data?$state_data["name"]:"All States");
			$zone_data = array(
				"zone_name" => $zone_name,
				"zone_description" => "Zone for ".$zone_name
			);
			
			$_REQUEST["zone_id"] = $added_zone_id = $taxes->addZone($zone_data);
			
			$taxes->addZoneRegion($added_zone_id, $_REQUEST["coid"], $_REQUEST["stid"]);
			
			$rate_id = $taxes->addRate($_REQUEST);
			
			$_REQUEST["rate_id"] = $rate_id;
			break;
		}
	}
	
	$taxes_rates = $taxes->getTaxRatesList();
	
	pageTabs(array(
		array("title"=>"Tax Rates", "id"=>"main"),
		array("title"=>"Add a New Tax Rate", "id"=>"new")
	), "tabs-taxes", false);
?>
<script language="javascript" type="text/javascript"><!--
	function addSimpleTaxRate(){
		d = document.getElementById("divNewSimpleTaxRate");
		d.style.display = d.style.display == "none" ? "block" : "none";
	}
	function setSimpleTaxRateStates(){
		c = document.getElementById('selectSimpleTaxRateCountry');
		s = document.getElementById('selectSimpleTaxRateState');
		s.options.length = 1;
		s.options[0] = new Option('All States / Provinces', '0');
<?		foreach($countries_states as $coid=>$country){
			if(is_array($country["states"])){
?>		if(c.value == '<?=$coid?>'){<?
			$i = 1;
			foreach($country["states"] as $stid=>$state){?>
				s.options[<?=$i?>] = new Option('<?=gs($state)?>', '<?=intval($stid)?>');
<?				$i++;
			}
?>		}
<?			}
		}
?>
	}
--></script>
<div id="admin-tab-sheet-main" class="admin-tab-sheet">
	<div class="admin-tab-sheet-wrap">
		<div class="admin-form-header first"><span class="icon ic-icon"></span>Current Tax Rates</div>
		<table cellpadding="0" cellspacing="0" border="0" class="admin-list-table" width="100%">
			<thead>
				<tr>
					<th class="icon">&nbsp;</th>
					<th style="width:150px;">Tax Rate Name</th>
					<th style="width:100px;">Tax Rate</th>
					<th style="width:90px;">Priority</th>
					<th style="width:150px;">Class Name</th>
					<th style="width:150px;">Class Key</th>
					<th style="width:150px;">Zone Name</th>
					<th>&nbsp;</th>
				</tr>
			</thead>
			<tbody>
<?php
		if ($taxes_rates)
		{
			for ($i=0; $i<count($taxes_rates); $i++)
			{
				$tax_rate = $taxes_rates[$i];
?>
				<tr>
					<td class="icon">&nbsp;</td>
					<td style="width:150px;"><?=htmlspecialchars($tax_rate["rate_description"])?></td>
					<td style="width:100px;"><?=myNum($tax_rate["tax_rate"])?>%</td>
					<td style="width:90px;"><?=htmlspecialchars($tax_rate["rate_priority"])?></td>
					<td style="width:150px;"><?=htmlspecialchars($tax_rate["class_name"])?></td>
					<td style="width:150px;"><?=htmlspecialchars($tax_rate["key_name"])?></td>
					<td style="width:150px;"><?=htmlspecialchars($tax_rate["zone_name"])?></td>
					<td style="text-align:right;">
						<a href="admin.php?p=taxes_rate&mode=edit&rate_id=<?=$tax_rate["rate_id"]?>"><img border="0" src="images/icons/a/pencil.png" alt="Click to edit rate" title="Click to edit rate"/></a>
						<input type="hidden" id="tax-delete-rate-<?=$tax_rate["rate_id"]?>" name="tax-delete-rate-<?=$tax_rate["rate_id"]?>" value="<?=create_nonce('tax_deleteRate')?>" />
						<a href="javascript:confirmDeleteRateSimple('<?=$tax_rate["rate_id"]?>')"><img src="images/icons/a/delete.png" alt="Click to delete tax rate" title="Click to delete tax rate" border="0"/></a>
					</td>
				</tr>
<?php
		}
	}
	else
	{
?>
				<tr>
					<td class="icon">&nbsp;</td>
					<td colspan="6">You do not have any tax rates setup</td>
				</tr>
<?php
	}
?>
				
			</tbody>
		</table>
	</div>
</div>

<div id="admin-tab-sheet-new" class="admin-tab-sheet hidden">
	<div class="admin-tab-sheet-wrap">
		<form action="admin.php?p=taxes&tax_mode=simple" method="POST" style="margin:0px;padding:0px;" onsubmit="return checkAddTaxRate(this)">
			<input type="hidden" name="action" value="addRate"/>
			<input type="hidden" name="nonce" value="<?=create_nonce('tax_addRate')?>" />
			<div class="admin-form-header first"><span class="icon ic-icon"></span>Add a New Tax Rate</div>
			<table width="100%" cellpadding="0" cellspacing="0" border="0">
				<tr valign="top">
					<td class="formItemCaption required">Tax Rate Name</td>
					<td class="formItemControl">
						<input type="text" name="rate_description" maxlength="255" value=""/>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Define a New Tax Zone</td>
					<td class="formItemControl">
						<select id="selectSimpleTaxRateCountry" name="coid" onchange="setSimpleTaxRateStates()">
							<option value="0">All Countries</option>
<?php	
	foreach ($countries_states as $coid=>$country)
	{
		echo '<option value="'.$coid.'">'.htmlspecialchars($country["country_name"]).'</option>';
	}
?>
						</select>
						<div style="padding-top:7px;">
							<select id="selectSimpleTaxRateState" name="stid">
								<option value="0">All States / Provinces</option>
							</select>
						</div>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Select a Tax Class</td>
					<td class="formItemControl">
						<select name="class_id">
<?php		
	for ($i=0; $i<count($taxes_classes); $i++)
	{
?>
					<option value="<?=$taxes_classes[$i]["class_id"]?>"><?=htmlspecialchars($taxes_classes[$i]["class_name"])?></option>
<?php
	}
?>
						</select>
						<br/>
						<a href="admin.php?p=taxes&tax_mode=advanced&last_active_tab=classes">Click here to manage classes</a>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Rate Priority</td>
					<td class="formItemControl">
						<select name="rate_priority" class="short">
<?php	
	for ($i=1; $i<=20; $i++)
	{
?>
							<option value="<?=$i?>"><?=$i?></option>
<?php
	}
?>
						</select>
						<div class="formItemComment">
							Rates at the same priority are added, others are compounded
						</div>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption required">Tax Rate, %</td>
					<td class="formItemControl">
						<input type="text" name="tax_rate" class="short" value=""/>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Apply To</td>
					<td class="formItemControl">
						<input type="checkbox" id="ul0" name="user_level[0]" value="0" checked="checked"/> <label for="ul0">Simple Users</label><br/>
						<input type="checkbox" id="ul1" name="user_level[1]" value="1" checked="checked"/> <label for="ul1">Wholesalers Level 1</label><br/>
						<input type="checkbox" id="ul2" name="user_level[2]" value="2" checked="checked"/> <label for="ul2">Wholesalers Level 2</label><br/>
						<input type="checkbox" id="ul3" name="user_level[3]" value="3" checked="checked"/> <label for="ul3">Wholesalers Level 3</label>
					</td>
				</tr>
			</table>
			<div class="admin-form-buttons">
				<input type="submit" value="Save changes" />
				<input type="reset" value="Reset form" />
			</div>
		</form>
	</div>
</div>