<?php
	if (!defined("ENV")) exit();

	pageHeader("Thumbnail Generator", "", "icb-file-format-jpg");
	
	$pathImages = "images/products/";
	$pathImagesThumbs = "images/products/thumbs/";
	$pathImagesProductPage = "images/products/preview/";
	$pathImagesSecondary = "images/products/secondary/";
	$pathImagesSecondaryThumbs = "images/products/secondary/thumbs/";
	
	$writable_directories = array(
		$pathImagesThumbs => is_writable($pathImagesThumbs),
		$pathImagesProductPage => is_writable($pathImagesProductPage),
		$pathImagesSecondary => is_writable($pathImagesSecondary),
		$pathImagesSecondaryThumbs => is_writable($pathImagesSecondaryThumbs)
	);
	
?>
<style type="text/css"><!--
.divSpacer{padding:20px 20px 0px 48px;float:left;}
.divHidden{display:none;}
.load_spinner{background-position:0px 3px;padding-left:22px;}
.not_writable { color: red; }
div.option { padding: 3px; }
div.option.disabled { background-color: #ffcccc; border: 1px solid red; margin: 0 0 2px 0; }
--></style>
<div id="divOptions" class="divStep">
<?php

	// 
	$folder_errors = array();
	if (in_array(false, $writable_directories))
	{
		foreach ($writable_directories as $directory_name => $permission)
		{
			if (!$permission)
			{
				$folder_errors[] = $directory_name;
			}
		}
	}
	
	pageNote(array(
		array(
			"class" => "ic-info",
			"text" =>
				"For the thumbnail generator to work correctly, the image filename must exactly match the Product ID for ".$label_app_name." to associate the image with the product.<br>".
				"You must use either FTP access or File Manager for your images. Send images to \"images/products/\" folder. After the images are moved, click the \"Scan Images\" button to start the process.",
			"visible" => true,
			"url" => ""
		),
		//array("class"=>"ic-info", "text"=>"Please note: The GIF file type is no longer supported by GDLib. The cart uses GDLib to generate thumbnails so you must use JPEG or PNG file types. GIF images will be accepted but will not appear resized.", "url"=>"", "visible"=>true),
		array("class"=>"ic-info", "text"=>"You can change generated images size and type on <a href=\"admin.php?p=design_catalog&last_active_tab=idTabImages\">Images Settings Page</a>.", "url"=>"", "visible"=>true),
		array("class"=>"ic-info", "text"=>"<a id=\"sync-secondary-images\" href=\"#\">Synchronize secondary images</a>", "url"=>"", "visible"=>true),
	));
	
	// generate available options
	$available_options = '';
	
	// check if all folders are writable
	$available_options .= '<div class="option '.(!empty($folder_errors) ? 'disabled' : '').'"><input type="radio" name="generateType" checked="checked" value="all" id="typeAll" /> <label for="typeAll" class="typeAll">Generate product page images, thumbnail images, and secondary images</label></div>';
	
	// product images only
	$available_options .= '<div class="option '.(!$writable_directories[$pathImagesProductPage] ? 'disabled' : '').'"><input type="radio" name="generateType" value="products" id="typeProducts"  /> <label for="typeProducts">Generate product page images only</label></div>';
	
	// thumbnails folder check
	$available_options .= '<div class="option '.(!$writable_directories[$pathImagesThumbs] ? 'disabled' : '').'"><input type="radio" name="generateType" value="thumbs" id="typeThumbs" /> <label for="typeThumbs">Generate thumbnail images only</label></div>';
	
	$available_options .= '<div class="option '.((!$writable_directories[$pathImagesSecondaryThumbs] || !$writable_directories[$pathImagesSecondary]) ? 'disabled' : '').'"><input type="radio" name="generateType" value="secondary" id="typeSecondary" /> <label for="typeSecondary">Generate secondary thumbnail images only</label></div>';
	
	if (!empty($folder_errors))
	{
		print '<div class="option disabled" style="margin: 25px; padding: 5px;">Designates folder permissions are incorrect and the cart cannot complete the outlined functions. Please change the permissions of the folders below and try again. <ul><li>'.implode('</li><li>', $folder_errors).'</li></ul></div>';
	}
	
?>
	<div class="divSpacer divTopLine divStartOptions">
		<form action="admin.php?p=thumbs_generator&step=2" method="POST">
			<?php echo $available_options; ?>
	        <br/><br/>

    	    <div class="option"><input type="radio" name="generateTarget" value="new" id="targetNew" checked="checked"> <label for="targetNew">Generate only new images</label></div>
        	<div class="option"><input type="radio" name="generateTarget" value="all" id="targetAll"> <label for="targetAll">Regenerate all images</label></div><br/><br/>

			<input type="button" value="Scan Images" id="buttonScan"/>
		</form>
	</div>
</div>
<div id="divScanImages" class="divHidden divStep">
<?php
	pageNote(array(
		array(
			"class" => "ic-info",
			"text" => "Depending on images count, scanning may take from few seconds to few minutes",
			"visible" => true,
			"url" => ""
		)
	));
?>
	<div class="divSpacer divTopLine"></div>
</div>
<div id="divProgress" class="divHidden divStep">
<?php
	pageNote(array(
		array(
			"class"=>"ic-info",
			"text"=>"Please wait while ".$label_app_name." generates thumbs.<br>Amount of time depends on your images count and size.",
			"visible"=>true, "url"=>""
		)
	));
?>
	<div id="divProgressBar" class="divSpacer" style="clear:both;"></div>
	<div id="divProgressText" class="divSpacer"  style="clear:both;"></div>
</div>
<div id="divDone" class="divHidden divStep">
<?php
	pageNote(array(
		array(
			"class" => "ic-info",
			"text" => "Operation done. Thumbnails have been generated.",
			"visible" => true,
			"url" => ""
		),
		array(
			"class" => "",
			"text" => "Click here to start over",
			"visible" => true,
			"url" => "admin.php?p=thumbs_generator"
		),
	));
?>
</div>
<script type="text/javascript" src="content/admin/javascript/thumbs_generator.js"></script>