<?php
        if (!defined("ENV")) exit();
        
        pageHeader($label_app_name." Update", "", "ic_updates.gif");
        
        require_once("content/classes/class.update-client.php");
        $xmlParser = new XMLParser();
        $updateClient = new updateClient($db, $xmlParser);
        
        $step = isset($step)?intval($step):1;
        
        switch ($step)
        {
                default :
                case 1 :
                {
                        $fixes= $updateClient->checkForUpdates($update_script_url, LICENSE_NUMBER, $settings["AppVer"], $settings["AppEncoder"]);
                        pageNote(array(
                                array(
                                        "icon"=>"ic_hint.gif",
                                        "text"=>"<b>Your Cart Information</b>",
                                        "url"=>"",
                                        "visible"=>true
                                ),
                                array(
                                        "icon"=>"",
                                        "text"=>"<ul><li>Current Version : ".$settings["AppVer"]."</li><li>Used Encoder : ".ucfirst($settings["AppEncoder"])."</li></ul>",
                                        "url"=>"",
                                        "visible"=>true
                                ),
 
                                array(
                                        "icon"=>"ic_hint.gif",
                                        "text"=>"<b>Before updating, we strongly recommend backing up your cart by <a href=\"admin.php?p=backup_restore\">clicking here</a> and then clicking the backup/restore tab. </b>",
                                        "url"=>"",
                                        "visible"=>true
                                ),
                        ));
                        
                        $new_updates = false;
                        if ($fixes)
                        {
?>
<form action="admin.php?p=update&step=2" method="POST">
        <div class="admin-tabs admin-tabs-framed" id="tabs-update">
<?php
                                pageTabs(array(
                                        array("title"=>"Updates Information", "id"=>"main"),
                                ), "tabs-update", false);
?>
 
                <div id="admin-tab-sheet-main" class="admin-tab-sheet">
                        <div class="admin-tab-sheet-wrap">
                                <div class="admin-form-header">Available Updates</div>
                                
                                <table cellpadding="0" cellspacing="0" border="0" class="admin-list-table" width="100%">
                                        <thead>
                                                <tr>
                                                        <th class="icon">&nbsp;</th>
                                                        <th>Code</th>
                                                        <th>Description</th>
                                                        <th>Size</th>
                                                        <th>Action</th>
                                                </tr>
                                        </thead>
                                        <tbody>
        
<?php
                                foreach($fixes as $fix_id=>$fix)
                                {
                                        if (!$fix["installed"])
                                        {
                                                $new_updates = true;
                                        }
?>
                                        <tr valign="top">
                                                <td align="center">
                                                        <input type="checkbox" name="fix[<?=$fix["id"]?>]" value="1" id="fix_<?=$fix["id"]?>" <?=$fix["installed"]?"disabled":""?>/>
                                                </td>
                                                <td>
                                                        <label for="fix_<?=$fix["id"]?>"><?=sprintf("%08s", $fix["id"])?></label>
                                                        <?=$fix["installed"]?"<br><u>Already Installed</u>":""?>
                                                </td>
                                                <td><b><?=$fix["name"]?></b><br><?=$fix["description"]?></td>
                                                <td><?=number_format($fix["size"]/1024, 2)?> Kb</td>
                                                <td>
                                                        <!--<img src="images/icons/ic_update.gif" alt="Update">-->
                                                        <a href="<?=$fix["download_url"]?>" target="_new"><img src="images/icons/a/download.png" alt="Download" border="0"></a>
                                                </td>
                                        </tr>
        
<?php
                                }
?>
                                        </tbody>
                                </table>
                        </div>
                </div>
        </div>
<?php
                                if ($new_updates)
                                {
?>
        <div class="admin-form-buttons">
                <input type="submit" value="Update">
        </div>
<?php
                                }
?>
</form>
 
                        
<?php
                        }
                        
                        if (!$new_updates)
                        {
                                pageNote(array(
                                        array("icon"=>"ic_hint.gif", "text"=>"<b>There are no new updates available</b><br>All available at this moment updates are already installed in your cart.", "url"=>"", "visible"=>true)
                                ));
                        }
                        
                        break;
                }
                case 2 :
                {
                        $fixes = $updateClient->getFixesFromSession();
                        $fix = isset($_REQUEST["fix"])?(is_array($_REQUEST["fix"])?$_REQUEST["fix"]:array()):array();
 
                        if (count($fix) > 0)
                        {
                                $messages = array();
                                foreach ($fix as $fix_id=>$value)
                                {
                                        if ($updateClient->setupFix($fix_id))
                                        {
                                                $updateClient->runCode();
                                                $messages[] = array("icon"=>"ic_hint.gif", "text"=>"<b>".$fixes[$fix_id]["name"]." has been installed</b>", "url"=>"", "visible"=>"true");
                                        }
                                        else
                                        {
                                                $messages[] = array("icon"=>"ic_error.gif", "text"=>"<b>Error installing ".$fixes[$fix_id]["name"]." patch. ".$updateClient->error."</b>", "url"=>"", "visible"=>"true");
                                        }
                                }
                                $messages[] = array("icon"=>"", "text"=>"Back to previous page", "url"=>"admin.php?p=update", "visible"=>true);
                                $messages[] = array("icon"=>"", "text"=>"Click here to go to admin area home page", "url"=>"admin.php?p=home", "visible"=>true);
                                pageNote($messages);
                        }
                        else
                        {
                                pageNote(array(
                                        array("icon"=>"ic_warning.gif", "text"=>"<b>Please select at least 1 fix to update</b>", "url"=>"", "visible"=>true),
                                        array("icon"=>"", "text"=>"Back to previous page", "url"=>"admin.php?p=update", "visible"=>true)
                                ));
                        }
                        break;
                }
        }       
        