<?php
	if (!defined("ENV")) exit();

	$uid = isset($uid) ? $uid*1 : 0;
	$action = isset($action) ? trim($action) : "";
	if ($action == "lock")
	{
		$db->query("UPDATE ".DB_PREFIX."users SET block_date=DATE_ADD(NOW(), INTERVAL ".(strtolower($blocked)=="yes"?"":"-").$settings["SecurityAccountBlockingHours"]." HOUR) WHERE uid='".$uid."'");
	}
	
	$db->query("SELECT *, DATE_FORMAT(session_date, '".$settings["LocalizationDateTimeFormat"]."') AS la, IF(NOW()<block_date, 'Yes', 'No') AS blocked FROM ".DB_PREFIX."users WHERE uid='".$uid."' AND removed='No'");
	
	if ($db->moveNext())
	{
		$user = $db->col;

		$fname = $db->col["fname"];
		$lname = $db->col["lname"];
		$company = $db->col["company"];
		$login = $db->col["login"];
		$session_date = $db->col["la"];
		$email_mode = $db->col["email_mode"];
		$level = $db->col["level"];
		$newsletters = $db->col["newsletters"];
		$updates = $db->col["updates"];
		$phone = $db->col["phone"];
		$email = $db->col["email"];
		$address1 = $db->col["address1"];
		$address2 = $db->col["address2"];
		$city = $db->col["city"];
		$state = $db->col["state"];
		$zip = $db->col["zip"];
		$province = $db->col["province"];
		$country = $db->col["country"];
		$blocked = $db->col["blocked"];
		
		loadJS("cf_user.js");
		loadJS("cd_user.js");
		pageHeader("User Profile", "update", "icb-user");

		if ($user["facebook_user"])
		{
			echo '<img src="https://graph.facebook.com/'.$user["facebook_id"].'/picture" align="right" vspace="15" hspace="15">';
		}

		pageNote(array(
			array("class"=>"ic-info", "text"=>"<b>Please note: required fields are bold</b>", "url"=>"", "visible"=>true),
			array("class"=>"ic-trash-can", "text"=>"Delete this user account", "url"=>"javascript:ConfirmDeleteUser(".$uid.")", "visible"=>true),
		));
		
		$customFields = new CustomFields($db);
		
		$cf_billing = $customFields->getCustomFieldsValues("billing", $uid, 0, 0);
		$cf_account = $customFields->getCustomFieldsValues("account", $uid, 0, 0);
		$cf_signup = $customFields->getCustomFieldsValues("signup", $uid, 0, 0);
		
		//country / state data
		require_once("content/classes/class.regions.php");
		$regions = new Regions($db);
		$regions->demo = defined('DEMO_LOCK') && DEMO_LOCK;
		
		$countries_states = $regions->getCountriesStates(false);
		
		
		$adminView = Ddm_AdminView::getInstance();
		$formBuilder = new core_Form_FormBuilder('edit-user');
		$formBuilder->add('uid', 'hidden', array('value' => $uid))
			->add('mode', 'hidden', array('value' => 'update'));
		
		
		// Contact information group
		$contactInfoGroup = new core_Form_FormBuilder('contact-info', array('label' => 'Contact Information', 'first'=>true));
		$contactInfoGroup->add('fname', 'text', array('label' => 'First Name', 'value' => $fname))
			->add('lname', 'text', array('label' => 'Last Name', 'value' => $lname))
			->add('company', 'text', array('label' => 'Company', 'value' => $company))
			->add('phone', 'text', array('label' => 'Phone', 'value' => $phone))
			->add('email', 'text', array('label' => 'Email', 'value' => $email));
		$formBuilder->add($contactInfoGroup);
		
		// Account information group
		$accountInfoGroup = new core_Form_FormBuilder('account-info', array('label' => 'Account Information', 'icon' => 'images/icons/a/gear.png'));
		if ($settings['WholesaleDiscountType'] != 'NO')
		{
			$wholesaleLevelOptions = array(
				'0' => 'Standard User',
				'1' => 'Wholesaler Level 1'
			);
			
			if ($settings['WholesaleMaxLevels'] != '1')
			{
				$max = intval($settings['WholesaleMaxLevels']);
				for ($i = 2; $i <= $max; $i++)
				{
					$wholesaleLevelOptions[strval($i)] = 'Wholesaler Level '.$i;
				}
			}
			
			$accountInfoGroup->add('level', 'choice', array('label' => 'User Access', 'options' => $wholesaleLevelOptions, 'value' => $level));
		}
		
		$accountInfoGroup->add('username', 'static', array('label' => 'Username (login)', 'value' => $login))
			->add('last_action', 'static', array('label' => 'Last Action', 'value' => $session_date));
			
		if ($settings["SecurityAccountBlocking"] == "YES")
		{
			// FIXME: Set the correct value for Current account status
			$accountInfoGroup->add('current_status', 'static', array('label' => 'Current Account Status', 'value' => ($blocked=='Yes'?'Blocked':'Active')))
				->add('set_status', 'static', array(
					'label' => 'Set New Account Status',
					'value' => '[ <a href="admin.php?p=user&uid='.$uid.'&action=lock&blocked='.($blocked=='Yes'?'no':'yes').'">Click here to '.($blocked=='Yes'?'Unlock Account':'Lock Account for a '.$settings['SecurityAccountBlockingHours'].' hours').'</a> ]'
				));
		}
		else
		{
			$accountInfoGroup->add('current_status', 'static', array('label' => 'Current Account Status', 'value' => 'Active'))
				->add('set_status', 'static', array(
					'label' => 'Set New Account Status',
					'value' => '<u>Account Blocking Feature is Disabled</u>',
					'note' => 'To enable blocking feature please go to Cart Settings &gt; Global Cart Settings &gt; Security Settings page'
				));
		}
		
		$accountInfoGroup->add('email_mode', 'choice', array('label' => 'Email Mode', 'value' => $email_mode, 'options' => array(
				'html' => 'HTML',
				'text' => 'Text'
			)))
			->add('newsletters', 'choice', array('label' => 'Email Newsletters', 'value' => $newsletters, 'options' => array(
				'Yes' => 'Yes',
				'No' => 'No'
			)))
			->add('updates', 'choice', array('label' => 'Email Product Update', 'value' => $updates, 'options' => array(
				'Yes' => 'Yes',
				'No' => 'No'
			)));
		
		if ($cf_account && !empty($cf_account))
		{
			foreach ($cf_account as $field)
			{
				$accountInfoGroup->add($field['field_name'], 'static', array('label' => $field['field_name'], 'value' => $field['value_translated']));
			}
		}
		$formBuilder->add($accountInfoGroup);
		
		
		// Billing information group
		$country_list = array();
		foreach ($countries_states as $coid=>$country_data)
		{
			$country_list[$coid] = gs($country_data['country_name']);
		}
		
		$billingInfoGroup = new core_Form_FormBuilder('billing-info', array('label' => 'Billing Information', 'icon' => 'images/icons/a/gear.png'));
		$billingInfoGroup->add('address1', 'text', array('label' => 'Address Line 1', 'value' => $address1))
			->add('address2', 'text', array('label' => 'Address Line 2', 'value' => $address2))
			->add('city', 'text', array('label' => 'City', 'value' => $city))
			->add('country', 'choice', array('label' => 'Country', 'options' => $country_list, 'value' => $country))
			->add('state', 'choice', array('label' => 'State/Province', 'value' => $state))
			->add('province', 'text', array('label' => 'OR Custom State/Province', 'value' => $province))
			->add('zip', 'text', array('label' => 'ZIP / Postal Code', 'value' => $zip));
		
		if ($cf_billing && !empty($cf_billing))
		{
			foreach ($cf_billing as $field)
			{
				$accountInfoGroup->add($field['field_name'], 'static', array('label' => $field['field_name'], 'value' => $field['value_translated']));
			}
		}
		
		$formBuilder->add($billingInfoGroup);
		
		
		
		// Custom fields - signup information if applicable
		if ($cf_signup && !empty($cf_signup))
		{
			$signupInfoGroup = new core_Form_FormBuilder('signup-info', array('label' => 'Custom Signup Information', 'icon' => 'images/icons/a/gear.png'));
			
			foreach ($cf_signup as $field)
			{
				$signupInfoGroup->add($field['field_name'], 'static', array('label' => $field['field_name'], 'value' => $field['value_translated']));
			}
			
			$formBuilder->add($signupInfoGroup);
		}
		
		
		
		foreach ($countries_states as $coid => $country_data)
		{
			if ($country_data['states'])
			{
				$adminView->assign('', '');
			}
		}
		
		
		$adminView->assign('user_info_form', $formBuilder->getForm());
		
		
		// Retrieve shipping addresses
		$userShippingAddresses = DataAccess_Repository::get('UserRepository')->getAllUserShippingAddresses($uid);
		
		foreach ($userShippingAddresses as $address)
		{
			$address['custom_fields'] = $customFields->GetCustomFieldsValues('shipping', $uid, 0, $address['usid']);
		}
		
		$adminView->assign('userShippingAddresses', $userShippingAddresses);
		
?>
<script language="javascript" type="text/javascript"><!--
$(document).ready(function(){
	$('#field-country').change(setUserState);
});

function setUserState(){
	c = document.getElementById('field-country');
	s = document.getElementById('field-state');
	s.options.length = 1;
	s.options[0] = new Option("Select state or province...", '0');
<?	foreach($countries_states as $coid=>$country_data){
		if($country_data["states"]){?>
			if(c.value == '<?=$coid?>'){
<?				$i = 1;
				foreach($country_data["states"] as $stid => $state_data){?>
					s.options[<?=$i?>] = new Option('<?=addslashes($state_data)?>', '<?=$stid?>');
<?					$i = $i + 1;
				}?>	
			}
<?		}
	}
?>
	sd = document.getElementById('field-state');
	pd = document.getElementById('field-province');
	if(s.options.length == 1)
	{
		sd.disabled = true;
		pd.disabled = false;
	}
	else
	{
		pd.disabled = true;
		sd.disabled = false;
		if(c.value=='<?=$country?>') s.value='<?=$state?>';
	}
}
--></script>
<form name="frmUser" action="admin.php?p=user_process" method="post" onsubmit="return CheckUserForm(this)">
	<input type="hidden" name="uid" value="<?=$uid?>">
	<input type="hidden" name="mode" value="update" />
<div class="admin-tabs admin-tabs-framed" id="tabs-user">
<?
	pageTabs(array(
		array("title"=>"User Properties", "id"=>"main"),
		array("title"=>"Address Book", "id"=>"book"),
	), "tabs-user", false);
?>

<?php $adminView->render('pages/user/user-edit'); ?>

</div>
<div class="admin-form-buttons">
	<input type="submit" value="Save changes">
	<input type="reset" value="Reset form">
</div>

</form>

<script language="javascript" type="text/javascript"><!--
	setUserState();
--></script>
<?
	}
?>