var kbLastResponse = null;
var kbLastIndex = 0;
var kbResultPerQuery = 10;

$(document).ready(function(){
	$("#kb-search-form").submit(function(){
		kbDoSearch(0);
		return false;
	});

	$("#kb-search-more").live("click", function(){
		$("#kb-search-more-div").remove();
		kbDoSearch(kbLastIndex + kbResultPerQuery);
		return false;
	});

	$("#kb-search-result a.show-answer").live("click", function(){
		$("#kb-search-answer-dialog").dialog("open");
		$("#kb-search-answer-dialog-inner").html(
			base64_decode($(this).parent("li").find('.answer').html()) +
			($(this).parent("li").find('.attachments').length > 0 ? '<div class="attachments">' + $(this).parent("li").find('.attachments').html() + '</div>' : '')
		);
		$("#kb-search-answer-dialog").dialog("option", "title", $(this).html());

		$("#kb-search-answer-dialog img").each(function(i, img){
			if ($(img).width() > 740) $(img).width(700);
		});
		return false;
	});

	$("#kb-search-answer-dialog").dialog({
		autoOpen: false,
		modal: true,
		width: 800,
		resizable: false,
		open: function(){
			$(this).height(500);
			correctDialogPosition(this);
		}
	});
	
	$("#kb-search-dialog").dialog({
		autoOpen: false,
		modal: true,
		width: 800,
		resizable: false,
		title: "Knowledge Base",
		open: function(){
			$(this).height(500);
			correctDialogPosition(this);
		}
	});

	$("#kb-link").click(function(){
		$("#kb-search-dialog #kb-search-input").val($("#page-header").html());
		$("#kb-search-dialog").dialog("open");
		
		if ($.trim($("#kb-search-dialog #kb-search-input").val()) != "")
		{
			$("#kb-search-form").submit();
		}
		return false;
	});

	$("#kb-search-answer-dialog-close").click(function(){
		$("#kb-search-answer-dialog").dialog("close");
	});
});

function kbDoSearch(start)
{
	if ($.trim($("#kb-search-input").val()) == "")
	{
		return false;
	}

	if (start == 0)
	{
		$("#kb-search-result").html('<div id="kb-search-loading">Please wait, loading...</div>');
	}
	else
	{
		$("#kb-search-result").append('<div id="kb-search-loading">Please wait, loading...</div>');
	}
	lastIndex = start;

	jQuery.ajax({

		url: 'https://www.' + getp() + '.com/kb/jsonsearch.php',
		dataType: 'jsonp',
		data: {
			'type': 'ars',
			'q': $("#kb-search-input").val(),
			'start': start,
			'results': kbResultPerQuery
		},
		success: function(data)
		{
			$("#kb-search-loading").remove();

			kbLastResponse = data;
			var articles = '';
			var c = 0;
			if (data)
			{
					jQuery.each(data, function(index, article){
					c++;
					articles +=
						'<li>' +
							'<a class="show-answer" href="' + article["href"] + '">' + article["title"] + '</a>' +
							'<div class="summary">' + article.summary + '</div>' +
							'<div class="answer">' +  (article["answer"]) + '</div>';
					if (article["attachments"])
					{
						articles +=
							'<div class="attachments"><strong>Attachments:</strong><ul>';
						$.each(article["attachments"], function(i, attachment){
							articles +=
								'<li><a target="_blank" href="https://www.' + getp() + '.com/kb/getattachment.php?data=' + attachment["Data"] + '">' + attachment["Filename"] + '</a> (' + attachment["Filesize"] + ' bytes)</li>';
						});

						articles +=
							'</ul></div>';
					}
					articles +=
						'</li>';
				});
			}

			if (start == 0)
			{
				$("#kb-search-result").html('<ul id="kb-search-results-' + start + '">' + articles + '</ul>');
			}
			else
			{
				$("#kb-search-result").append('<ul id="kb-search-results-' + start + '">' + articles + '</ul>');
			}

			if (c == kbResultPerQuery)
			{
				$("#kb-search-result").append('<div id="kb-search-more-div"><a href="#" id="kb-search-more">View more results</a></div>');
			}
			else
			{
				$("#kb-search-result").append('<div id="kb-search-no-results">There no' + ($("#kb-search-results-0 li").length > 0 ? ' more':'')  + ' results</div>');
				$("#kb-search-other-options").show();
			}
		}
	});
}
