<?php
require_once("content/classes/class.gift_certificates.php");

//plugin class
class plugin_gift_cert extends cartPlugin
{
	//protected
	var $plugin_id = "gift_cert";
	var $plugin_group = "misc"; /* Group Name */
	var $plugin_caption = "Gift Certificates";
	var $plugin_description = "This plugin is used for gift certificates admin area.";

	//constructor
	function plugin_gift_cert()
	{
		$this->interface = array();
		$this->interface["title"] = $this->plugin_caption;
		$this->interface["url"] = 'admin.php?p=plugin&plugin_id='.$this->plugin_id;
		$this->interface["class"] = "ic-shopping-cart";
		$this->interface["group"] = "products";

		return $this;
	}

	function runPlugin(&$db, &$settings, &$request)
	{
		parent::runPlugin($db, $settings, $request);
		extract($request);

		$gift_cert = new GiftCertificates($db);

		$action = isset($action)?trim($action):"";
		if (!DEMO_LOCK)
		{
			switch($action)
			{
				case "gift_cert_update" :
				{
					if ($gift_cert->UpdateGiftCertificate($_REQUEST))
					{
						$mode = '';
					}
					break;
				}
				
				case "gift_cert_delete" : 
				{
					if ($gift_cert->DeleteGiftCertificate($_REQUEST))
					{
						$mode = '';
					}
					break;
				}
				
				case "update_email" :
				{
					if (writeTemplateFile("templates/emails/gift_cert_html.html", stripslashes($_REQUEST['email_gift_cert'])))
					{
						$mode = '';
					}
					break;
				}
			}
		}

		pageHeader("Gift Certificates", '', 'icb-gift');
		pageNote(array(
			array("class"=>"ic-info", "text"=>"Manage gift certificates, update settings and change gift certificate email.", "visible"=>true),
		));
		echo '<div class="admin-tabs admin-tabs-framed" id="tabs-gift">';
		
		$last_active_tab = isset($last_active_tab) ? $last_active_tab : "certificates";
		
		pageTabs(array(
			array("title"=>"Gift Certificates", "id"=>"certificates"),
			array("title"=>"Gift Certificates Settings", "id"=>"settings"),
			array("title"=>"Gift Certificates Email", "id"=>"email")
		), "tabs-gift", $last_active_tab);

		$mode = isset($mode) ? $mode : '';

		if ($gift_cert->is_error)
		{
			print "<font color=red><b>Errors:<br><br>";
			for ($i=0; $i < count($gift_cert->errors); $i++) 
			{
				print $gift_cert->errors[$i].'<br>';
			}
			print "</b></font>";
		}

		if (($mode == 'enable_module' || $mode == 'disable_module') && !DEMO_LOCK)
		{
			if ($mode == 'enable_module')
			{
				$set = 'Yes';
				$db->reset();
				$db->assign("parent", 0);
				$db->assign("level", 1);
				$db->assign("priority", 5);
				$db->assignStr("is_visible", 'No');
				$db->assignStr("key_name", 'gift_cert');
				$db->assignStr("name", 'gift_cert');
				$cid = $db->insert(DB_PREFIX."catalog");
				$db->reset();
				$db->assign("cid", $cid);
				$db->assign("added", 'now()');
				$db->assignStr("product_id", 'gift_certificate');
				$db->assignStr("title", 'Gift Certificate');
				$pid = $db->insert(DB_PREFIX."products");
			}
			else
			{
				$set = 'No';
				$db->query("DELETE FROM ".DB_PREFIX."catalog WHERE key_name='gift_cert' AND name='gift_cert'");
				$db->query("DELETE FROM ".DB_PREFIX."products WHERE product_id='gift_certificate' AND title='Gift Certificate'");
			}
			$settings['enable_gift_cert'] = $set;
			$db->reset();
			$db->assignStr('value', $set);
			$db->update(DB_PREFIX."settings", "WHERE name='enable_gift_cert'");
			$mode = '';
		}
?>
		<div id="admin-tab-sheet-certificates" class="admin-tab-sheet">
			<div class="admin-tab-sheet-wrap">
				<div class="admin-form-header first"><span class="icon ic-icon"></span>Gift Certificates</div>
<?php 				
		if (!isset($_REQUEST['show_balance']))
		{
			$_REQUEST['show_balance'] = '0';
		}
?>
<script type="text/javascript">
	function ConfirmDeleteGiftCert(ocid) 
	{
		if (!confirm('Are you sure you want to delete this gift certificate?'))	return false;
		document.location.href='admin.php?p=plugin&plugin_id=<?=$this->plugin_id?>&action=gift_cert_delete&ocid='+ocid;
	}
</script>
		
				<form name="frmGCSetting" action="admin.php?p=plugin&plugin_id=<?=$this->plugin_id?>" method="post" id="frmGCSetting">
					<table width="100%" cellpadding="0" cellspacing="0" border="0" class="admin-list-table">
						<thead>
							<tr>
								<th class="icon">&nbsp;</th>
								<th style="width:125px;">Client's Name</th>
								<th style="width:125px;">Voucher Number</th>
								<th style="width:125px;">Balance</th>
								<th style="width:175px;">Gift Message</th>
								<th style="width:175px;">Recipient Email</th>
								<th style="width:125px;">Date Ordered</th>
								<th style="text-align:right">
									<select name="show_balance" onchange="document.getElementById('frmGCSetting').submit();">
										<option value="0" <?=($_REQUEST['show_balance']=='0'?'selected':'')?>>Show All Gift Certificates</option>
										<option value="1" <?=($_REQUEST['show_balance']=='1'?'selected':'')?>>Show Balance Zero</option>
										<option value="2" <?=($_REQUEST['show_balance']=='2'?'selected':'')?>>Show Valid Gift Certificates</option>
									</select>
								</th>
							</tr>
						</thead>
						<tbody>
		
<?php
			if ($_REQUEST['show_balance'] == '1') 
			{
				$where = 'WHERE balance = 0';
			}
			else if ($_REQUEST['show_balance'] == '2') 
			{
				$where = 'WHERE balance > 0';
			}
			else 
			{
				$where = '';
			}

			$gift_cert_list = $gift_cert->GetGiftCertificates($where);

			if (is_array($gift_cert_list) && count($gift_cert_list) > 0)
			{
				for ($i=0; $i<count($gift_cert_list); $i++) 
				{
?>
							<tr>
								<td class="icon">&nbsp;</td>
								<td><?=$gift_cert_list[$i]['first_name']." ".$gift_cert_list[$i]['last_name']?></td>
								<td><?=$gift_cert_list[$i]['voucher']?></td>
								<td><?='$ '.number_format($gift_cert_list[$i]['balance'], 2, '.', '')?></td>
								<td><?=$gift_cert_list[$i]['message']?></td>
								<td><?=$gift_cert_list[$i]['email']?></td>
								<td><?=$gift_cert_list[$i]['date_ordered']?></td>
								<td style="text-align:right;">
									<a href="admin.php?p=plugin&plugin_id=<?=$this->plugin_id?>&last_active_tab=settings&mode=update&ocid=<?=$gift_cert_list[$i]['ocid']?>"><img src="images/icons/a/pencil.png" border="0" title="Edit Gift Certificate"></a>
									<a href="javascript:ConfirmDeleteGiftCert(<?=$gift_cert_list[$i]['ocid']?>); void(0);"><img src="images/icons/a/delete.png" border="0" title="Delete Gift Certificate"></a>
								</td>
							</tr>
<?php			}
			}
			else
			{
?>						
							<tr>
								<td class="icon">&nbsp;</td>
								<td colspan="7">No gift certificates found</td>
							</tr>
<?php
			}
?>						
						</tbody>
					</table>
				</form>
			</div>
		</div>
		<div id="admin-tab-sheet-settings" class="admin-tab-sheet hidden">
			<div class="admin-tab-sheet-wrap">
<?php
		if ($mode == 'update')
		{
?>			
				<form name="frmGiftCert" action="admin.php?p=plugin&plugin_id=<?=$this->plugin_id?>" method="post">
					<input type="hidden" name="ocid" value="<?=$ocid?>">
					<input type="hidden" name="mode" value="<?=gs($mode)?>">
<?php
			if (!$gift_cert->is_error)
			{
				$gift_data = $gift_cert->GetOrderedGiftCertById($ocid);
				$first_name = $gift_data['first_name'];
				$last_name = $gift_data['last_name'];
				$balance = $gift_data['balance'];
				$voucher = $gift_data['voucher'];
			}
?>
					<input type="hidden" name="action" value="gift_cert_update">
					<div class="admin-form-header first"><span class="icon ic-icon"></span>Gift Certificate Update</div>
					<div style="clear:both;">
						<table width="100%" cellpadding="0" cellspacing="0" border="0">
							<tr valign="top">
								<td class="formItemCaption required">First Name</td>
								<td class="formItemInput">
									<input type="text" name="first_name" value="<?=htmlspecialchars($first_name)?>">
								</td>
							</tr>
							<tr valign="top">
								<td class="formItemCaption required">Last Name</td>
								<td class="formItemInput">
									<input type="text" name="last_name" value="<?=htmlspecialchars($last_name)?>">
								</td>
							</tr>
							<tr valign="top">
								<td class="formItemCaption required">Balance</td>
								<td class="formItemInput">
									<input type="text" name="balance" value="<?=myNum($balance)?>" class="short">
								</td>
							</tr>
							<tr valign="top">
								<td class="formItemCaption required">Voucher</td>
								<td class="formItemInput">
									<input type="text" name="voucher" value="<?=htmlspecialchars($voucher)?>">
								</td>
							</tr>
						</table>
						<div class="admin-form-buttons">
							<input type="submit" value="Save changes" />
							<input type="reset" value="Reset Form" />
						</div>
					</div>
				</form>
<?php
		}
		else
		{
?>
				<form name="frmGiftCertED" action="admin.php?p=plugin&plugin_id=<?=$this->plugin_id?>" method="post">
					<div class="admin-form-header first"><span class="icon ic-icon"></span>Gift Certificate Module</div>
					<table width="100%" cellpadding="0" cellspacing="0" border="0">
						<tr valign="top">
							<td class="formItemCaption">Current Status</td>
							<td class="formItemControl">
								<? if ($settings['enable_gift_cert'] == 'Yes') { ?>
								<input type="hidden" name="mode" value="disable_module" />
								<b>Enabled</b>
								<? } else { ?>
								<input type="hidden" name="mode" value="enable_module" />
								<b>Disabled</b><? } ?>
							</td>
						</tr>
						<tr valign="top">
							<td class="formItemCaption">Change Status</td>
							<td class="formItemControl">
								<? if ($settings['enable_gift_cert'] == 'Yes') { ?> <input type="submit" value="Disable Module" /> <? } else { ?><input type="submit" value="Enable Module" /><? } ?>
							</td>
						</tr>
					</table>
				</form>
<?php
		}
?>
			</div>
		</div>
<?php
		$email_gift_cert = readTemplateFile("templates/emails/gift_cert_html.html");
?>
		<div id="admin-tab-sheet-email" class="admin-tab-sheet hidden">
			<div class="admin-tab-sheet-wrap">
				<form name="frmGiftCert" action="admin.php?p=plugin&plugin_id=<?=$this->plugin_id?>" method="post">
					<input type="hidden" name="action" value="update_email" />
					<div class="admin-form-header first editor-manager"><span class="icon ic-icon"></span>Gift Certificate HTML Emai</div>
					<div class="formItemControl big">
						<textarea wrap="off" class="no-mce editor-area" id="email_gift_cert" name="email_gift_cert"><?=htmlentities(stripslashes($email_gift_cert))?></textarea>
					</div>
					<div class="admin-form-buttons">
						<input type="submit" value="Save changes"/>
						<input type="reset" value="Reset form"/>
					</div>
				</form>
			</div>
		</div>
<?php
		echo '</div>';
		
	}
}
