<?php

/**
* 
*/
class DataAccess_ChartDataRepository extends DataAccess_Repository
{
	public function getUsageHostsByMonth($month, $year, $cache = true)
	{
		return $this->getData('
			SELECT 
				COUNT(DISTINCT hid) AS day_hosts,
				DAYOFMONTH(visit_date) AS day,
				visit_date
			FROM '.DB_PREFIX.'statistics
			WHERE
				YEAR(visit_date) = "'.self::$db->escape($year).'"
				AND MONTH(visit_date) = "'.self::$db->escape($month).'"
			GROUP BY day
			ORDER BY day
		', $cache);
	}
	
	public function getUsageHitsByMonth($month, $year, $cache = true)
	{
		return $this->getData('
			SELECT 
				COUNT(*) AS day_hits,
				DAYOFMONTH(visit_date) AS day,
				visit_date
			FROM '.DB_PREFIX.'statistics
			WHERE
				YEAR(visit_date) = "'.self::$db->escape($year).'"
				AND MONTH(visit_date) = "'.self::$db->escape($month).'"
			GROUP BY day
			ORDER BY day
		', $cache);
	}
	
	public function getSalesByMonth($month, $year, $cache = true)
	{
		return $this->getData('
			SELECT 
				MAX('.DB_PREFIX.'orders.placed_date) as placed_date,
				SUM('.DB_PREFIX.'orders.total_amount) AS total_sum,
				DAYOFMONTH(placed_date) AS day
			FROM '.DB_PREFIX.'orders 
			WHERE 
				removed="No" AND
				status="Completed" AND 
				payment_status="Received" AND
				YEAR(placed_date) = "'.self::$db->escape($year).'" AND 
				MONTH(placed_date) = "'.self::$db->escape($month).'"
			GROUP BY day
			ORDER BY day
		', $cache);
	}
}
