<?php
/**
 * 
 */
class DataAccess_StatRepository extends DataAccess_Repository
{
	/**
	 * Basic statistics per day
	 * @param mixed $y
	 * @param mixed $m
	 * @param mixed $d 
	 * @return array
	 */
	public function getBasicDayData($statsYear=null, $statsMonth=null, $statsDay=null)
	{
		if (is_null($statsYear) || is_null($statsMonth) || is_null($statsDay) || !(checkdate($statsMonth, $statsDay, $statsYear)))
		{
			$statsYear = date("Y");
			$statsMonth = date("n");
			$statsDay = date("j");
		}
		
		$mysqlFrom =  $statsYear."-".$statsMonth."-".$statsDay." 00:00:00";
		$mysqlTo =  $statsYear."-".$statsMonth."-".$statsDay." 23:59:59";
	
		$todayStat = array();
		
		//orders placed per day
		$d = $this->getData("SELECT COUNT(*) AS c FROM ".DB_PREFIX."orders WHERE removed <> 'Yes' AND status IN ('Process', 'Backorder', 'Completed') AND placed_date >= '".$mysqlFrom."' AND placed_date <= '".$mysqlTo."'");
		$todayStat['ordersCount'] = $d[0]['c'];

		//total sales placed per day
		$d = $this->getData("SELECT SUM(total_amount) AS s FROM ".DB_PREFIX."orders WHERE removed <> 'Yes' AND status IN ('Process', 'Backorder', 'Completed') AND placed_date >= '".$mysqlFrom."' AND placed_date <= '".$mysqlTo."'");
		$todayStat['ordersTotal'] = $d[0]['s'];
		
		//orders to fullfill per day
		$d = $this->getData("SELECT COUNT(0) AS c FROM ".DB_PREFIX."orders WHERE removed <> 'Yes' AND status IN ('Process', 'Backorder') AND placed_date >= '".$mysqlFrom."' AND placed_date <= '".$mysqlTo."'");
		$todayStat['ordersToFulfill'] = $d[0]['c'];
		
		return $todayStat;
	}
	
	/**
	 * Basic statistics per month
	 * @param mixed $statsYear
	 * @param mixed $statsMonth
	 * @return array 
	 */
	public function getBasicMonthData($statsYear=null, $statsMonth=null)
	{
		if (is_null($statsYear) || is_null($statsMonth) || !(checkdate($statsMonth, 1, $statsYear)))
		{
			$statsYear = date("Y");
			$statsMonth = date("n");
		}
	
		$mysqlFrom =  $statsYear."-".$statsMonth."-01 00:00:00";
		$mysqlTo =  ($statsMonth == 12 ? $statsYear + 1 : $statsYear)."-".($statsMonth == 12 ? 1 : $statsMonth + 1)."-01 00:00:00";
	
		$monthStat = array();
		
		//orders placed per month
		$d = $this->getData("SELECT COUNT(*) AS c FROM ".DB_PREFIX."orders WHERE removed <> 'Yes' AND status IN ('Process', 'Backorder', 'Completed') AND placed_date >= '".$mysqlFrom."' AND placed_date < '".$mysqlTo."'");
		$monthStat["ordersCount"] = $d[0]['c'];
	
		//orders total per month
		$d = $this->getData("SELECT SUM(total_amount) AS c FROM ".DB_PREFIX."orders WHERE removed <> 'Yes' AND status IN ('Process', 'Backorder', 'Completed') AND placed_date >= '".$mysqlFrom."' AND placed_date < '".$mysqlTo."'");
		$monthStat["ordersTotal"] = $d[0]['c'];
	
		//users per month
		$d = $this->getData("SELECT COUNT(*) AS c FROM ".DB_PREFIX."users WHERE created_date >= '".$mysqlFrom."' AND created_date < '".$mysqlTo."' AND login <> 'ExpressCheckoutUser'");
		$monthStat["usersRegistered"] = $d[0]['c'];
		
		return $monthStat;
	}
}
