<?php

//TODO: Refactor Ddm_View and Ddm_AdminView to utilize a base class
class Ddm_AdminView
{
	protected $vars = array();
	protected $_settings;
	protected $_view;

	private $_permDir = 0777;
	private $_permFile = 0666;
	private $_cache_map = array();

	protected $_skinName = 'default';

	/**
	 * Class constructor
	 */
	public function __construct()
	{
		$this->_settings = settings();

		require_once("content/vendors/smarty/Smarty.class.php");
		$this->_view = new Smarty();

		$this->setTemplateDir("content/admin/skins/".$this->_skinName."/");
		$this->setCompileDir("content/cache/smarty/skins/_admin/".$this->_skinName."/");

		require_once("content/smarty_plugins/function.product_image.php");
		require_once("content/smarty_plugins/function.product_minmax_order.php");
		require_once("content/smarty_plugins/function.product_pack_title.php");
		require_once("content/smarty_plugins/function.product_pack_value.php");
		require_once("content/smarty_plugins/function.lang.php");
		require_once("content/smarty_plugins/function.custom_field.php");
		require_once("content/smarty_plugins/function.script.php");
		require_once("content/smarty_plugins/function.link.php");
		require_once("content/smarty_plugins/function.meta.php");
		require_once("content/smarty_plugins/function.fill_cells.php");
		require_once("content/smarty_plugins/function.class.php");
		require_once("content/smarty_plugins/function.form.php");
		require_once("content/smarty_plugins/function.field.php");
		require_once("content/smarty_plugins/function.button.php");
		require_once("content/smarty_plugins/function.getp.php");
		require_once("content/smarty_plugins/function.getpp.php");
		require_once('content/smarty_plugins/modifier.mynum.php');
		
		$this->_view->register_function("product_image", "smarty_function_product_image");
		$this->_view->register_function("product_minmax_order", "smarty_function_product_minmax_order");
		$this->_view->register_function("product_pack_title", "smarty_function_product_pack_title");
		$this->_view->register_function("product_pack_value", "smarty_function_product_pack_value");
		$this->_view->register_function("lang", "smarty_function_lang");
		$this->_view->register_function("cfield", "smarty_function_custom_field");
		$this->_view->register_function("script", "smarty_function_script");
		$this->_view->register_function("link", "smarty_function_link");
		$this->_view->register_function("meta", "smarty_function_meta");
		$this->_view->register_function("fill_cells", "smarty_function_fill_cells");
		$this->_view->register_function("class", "smarty_function_class");
		$this->_view->register_function("button", "smarty_function_button");
		$this->_view->register_function('field', 'smarty_function_field');
		$this->_view->register_function('form', 'smarty_function_form');
		$this->_view->register_function('getp', 'smarty_function_getp');
		$this->_view->register_function('getpp', 'smarty_function_getpp');
		$this->_view->register_modifier("price", strstr($_SERVER["SCRIPT_FILENAME"], 'admin.php') ? "getAdminPrice" : "getPrice");
		$this->_view->register_modifier("weight", "getWeight");
		$this->_view->register_modifier("gs", "gs");
		$this->_view->register_modifier("stripslashes", "stripslashes");
		$this->_view->register_modifier('gn', 'smarty_modifier_mynum');
		$this->_view->register_modifier("smartround", "myNum");
		$this->_view->register_modifier("htmlspecialchars", "smarty_modifier_htmlspecialchars");

		$this->_view->assign("settings", $this->_settings);
		$this->_view->assign("index_url", $this->_settings["GlobalHttpUrl"]."/".$this->_settings["INDEX"]);
		
		foreach($this->_settings as $key=>$value) $this->_view->assign($key, $value);

		//$this->_view->assign('', getp());
		//$this->_view->assign('', getpp());

		$this->_permFile = getFilePermissionMode();
		$this->_permDir = getDirectoryPermissionMode();

		//if (defined('DEVMODE') && DEVMODE) $this->assemble();
	}
	
	/**
	 * Get static instance
	 * @staticvar string $instance
	 * @return self 
	 */
	public static function getInstance()
	{
		static $instance = null;
		if (is_null($instance)) $instance = new self;
		return $instance;
	}

	/**
	 * Sets templates directory
	 * @param string $directory
	 */
	public function setTemplateDir($directory)
	{
		$this->_view->template_dir = $this->_view->config_dir = $directory;
	}
	
	/**
	 * Sets smart template directory
	 * @param string $directory
	 */
	public function setCompileDir($directory)
	{
		if (!is_dir($directory)) mkdir($directory, $this->_permDir, true);
		$this->_view->compile_dir = $directory;
	}

	/**
	 * Assign variable
	 * @param type $key
	 * @param type $value 
	 */
	public function assign($key, $value)
	{
		$this->vars[$key] = $value;
	}

	/**
	 * Renders admin view
	 *
	 * @param string $view 
	 * @return void
	 */
	public function render($view)
	{
		echo $this->fetch($view);
	}

	/**
	 *
	 * @param type $view
	 * @return type 
	 */
	public function fetch($view)
	{
		foreach ($this->vars as $key => $value)
		{
			$this->_view->assign($key, $value);
		}

		return $this->_view->fetch('templates/'.$view.'.html');
	}
}