<?php 
	function getPrice($amount)
	{
		global $settings, $_SESSION, $currencies;
		$cc = getCurrentAdminCurrency();

		return $cc["symbol_left"].number_format($amount * (float) $cc["exchange_rate"], $cc["decimal_places"], $settings["LocalizationCurrencyDecimalSymbol"], $settings["LocalizationCurrencySeparatingSymbol"]).$cc["symbol_right"];
	}

	function getAdminPrice($amount)
	{
		global $settings, $_SESSION, $currencies;
		$cc = getCurrentAdminCurrency();

		return $cc["symbol_left"].number_format($amount * $cc["exchange_rate"], $cc["decimal_places"], $settings["LocalizationCurrencyDecimalSymbol"], $settings["LocalizationCurrencySeparatingSymbol"]).$cc["symbol_right"];
	}

	function getCurrentAdminCurrency()
	{
		global $currencies, $db;

		if (isset($_SESSION['admin_currency']))
		{
			return $_SESSION['admin_currency'];
		}
		else
		{
			if (is_null($currencies))
			{
				require_once dirname(dirname(__FILE__)).'/classes/class.currencies.php';

				$currencies = new Currencies($db);
			}

			$_SESSION["admin_currency"] = $admin_currency = $currencies->getDefaultCurrency();

			return $admin_currency;
		}
	}

	function getWeight($weight)
	{
		global $settings;
		return number_format($weight, 2, ".", ",")." ".$settings["LocalizationWeightUnits"];
	}

	function weightToLbs($weight){
		global $settings;
		if($settings["LocalizationWeightUnits"] == "kg"){
			return $weight / 0.45359;
		}
		else{
			return $weight;
		}
	}
	
	function weightToKg($weight){
		global $settings;
		if($settings["LocalizationWeightUnits"] == "kg"){
			return $weight;
		}
		else{
			return $weight * 0.45359;
		}
	}