<?php 

	function getShippingCountries($db){
		$db->query("SELECT country FROM ".DB_PREFIX."shipping_selected");
		$a = array();
		while($db->moveNext()){
			$cc = explode(",", $db->col["country"]);
			for($i=0; $i<count($cc); $i++){
				$cc[$i] = trim($cc[$i]);
				if($cc[$i] != ""){
					if(!in_array($cc[$i], $a)){
						$a[] = $cc[$i];
					}
				}
			}
		}
		return count($a)>0?$a:false;
	}
	
	/**
	 * DEPRECATED
	 * @param type $db
	 * @return string 
	 */
	function getShippingCountriesOptions($db){
		$db->query("SELECT country FROM ".DB_PREFIX."shipping_selected");
		$a = array();
		while($db->moveNext()){
			$cc = explode(",", $db->col["country"]);
			for($i=0; $i<count($cc); $i++){
				$cc[$i] = trim($cc[$i]);
				if($cc[$i] != ""){
					if(!in_array($cc[$i], $a)){
						$a[] = $cc[$i];
					}
				}
			}
		}
		if(in_array(0, $a) || count($a) == 0){
			return false;
		}
		else{
			$db->query("SELECT ".DB_PREFIX."countries.* FROM ".DB_PREFIX."countries WHERE ".DB_PREFIX."countries.available='Yes' ORDER BY ".DB_PREFIX."countries.country_priority, ".DB_PREFIX."countries.name");
			$options = "";
			while($db->moveNext()){
				if(in_array($db->col["coid"], $a)){
					$options.='<option value="'.$db->col["coid"].'" '.($db->col["coid"]==$coid?"selected":"").'>'.gs($db->col["name"])."</option>\r\n";
				}
			}
			return $options;
		}
		return count($a)>0?$a:false;
	}
	
	/**
	 * Canada Post - Likuid Communication
	 * @global type $settings
	 * @global type $cp_xml_result
	 * @global type $cp_orderid
	 * @global type $cp_delivery
	 * @param type $db
	 * @param type $data
	 * @param type $from
	 * @param type $to
	 * @param type $weight
	 * @param type $items
	 * @param type $items_price_based
	 * @param string $error_message
	 * @return type 
	 */
	function getCanadaPostShippingPrice($db, $data, $from, $to, $weight, $items, $items_price_based, &$error_message)
	{
		global $settings;
    	global $cp_xml_result;
    	global $cp_orderid;
    	require_once($settings["GlobalServerPath"]."/content/engine/engine_canada_post.php");

    	if(!isset($cp_xml_result)){    
			$db->query("SELECT name FROM ".DB_PREFIX."states WHERE stid='".(isset($to["state"])?intval($to["state"]):0)."'");
			$to_state = ($db->moveNext()?$state=$db->col["name"]:" ");

			$CanadaPost = new CanadaPost($settings["ShippingCPUrlRating"], $settings["ShippingCPMerchantID"], $settings);
			$CanadaPost->setOrigin($settings["ShippingOriginZip"]);
			$CanadaPost->setDestination(" ", $to_state, $to["country_iso_a2"], $to["zip"]);
			$CanadaPost->setOption("tat", $settings["ShippingCPTAT"]);
			if($settings["ShippingCPItemsValue"] != "no"){
				$CanadaPost->setOption("itemsvalue", $items_price_based);
			}
			
			$securityId = isset($_COOKIE["_pcod"]) ? $_COOKIE["_pcod"] : "";
			$securityId = $securityId == "" ? isset($_POST["_pcod"]) ? $_POST["_pcod"] : $securityId : $securityId;
			$securityId = $securityId == "" ? isset($_GET["_pcod"]) ? $_GET["_pcod"] : $securityId : $securityId;
			
			$db->query("SELECT * FROM ".DB_PREFIX."orders_content oc JOIN ".DB_PREFIX."orders o ON (oc.oid = o.oid) WHERE security_id='".$db->escape($securityId)."'");
			
			while($db->moveNext()){
				$CanadaPost->addItem($db->col["quantity"], $db->col["weight"], 1, 1, 1, $db->col["title"]);
			}
      
			$CanadaPost->createXMLRequest();
			$cp_xml_result = $CanadaPost->getQuote();
		}

		if(is_array($cp_xml_result)){
			foreach($cp_xml_result as $cp_method){
				if($cp_method["id"] == $data["method_id"]){
					global $cp_delivery;
					$cp_delivery = $cp_method["delivery"];
					$price = $cp_method["rate"];
					if($price > 0){
						//check advanced fee
						if($data["fee_type"] == "percent"){
							$price = $price + $price / 100 * $data["fee"];
						}
						if($data["fee_type"] == "amount"){
							$price = $price + $data["fee"];
						}
					}
					return normalizeNumber($price);
				}
			}
		}
		$error_message = "Please choose other shipping service.<br>We're so sorry, but selected one is not available for your order.";
		return false;
	}
	//////////////////////////////////////////////////////////////////////////////	
	//////////////////////////////////////////////////////////////////////////////

	
	function getFedexShippingPrice($db, $data, $from, $to, $weight, &$error_message, $service){
		global $settings;
		require_once($settings["GlobalServerPath"]."/content/engine/engine_fedex.php");
		$fedex = new FedExDC($settings["ShippingFedExAccountNumber"], $settings["ShippingFedExMeter"]);
		
		$params = array(
			0=>"022",						//transaction type
			1=>"CartOrder",					//order id
			3025=>$service,					//carrier code  FDXE / FDXD
				
			//origin
			8=>"",							//from state (blank at this release)
			9=>$from["zip"],				//from zip
			117=>$from["country_iso_a2"],		//from country
				
			//destination
			16=>"",							//to state
			17=>$to["zip"],					//to zip
			50=>$to["country_iso_a2"],			//to country
				
			75=>$settings["LocalizationWeightUnits"]=="lbs"?"LBS":"KGS",		//weight units (LBS, KGS)
			1273=>"01",						//FedEx Packaging Type, Set to other
			1274=>$data["method_id"],		//FedEx Service Type
				
			1401=>number_format($weight, 1, ".", ""), 	//Total Package Weight
				
			23=>"1",		//Bill Shipper
			116=>"1",		//Package Total
			//1415=>"100.00",	//Declared Value
			//68=>"USD"		//Currency name
		);
		
		$result = $fedex->global_rate_express($params);

		if($error = $fedex->getError()){
			$error_message = $error;
		}
		else{
			if($settings["ShippingFedExRatesWithVAT"]=="No" and isset($result[1642]))
				$shipping_price = $result[1419] - $result[1642];
			else
				$shipping_price = $result[1419];
			
			return $shipping_price;
		}
	}
	
	function getFedexFreightShippingPrice($db, $data, $from, $to, $weight, &$error_message)
	{
		global $settings;
		
		$url = 
			"http://www.fedexfreight.fedex.com/XMLRating.jsp?".
			"as_shipterms=prepaid".
			"&as_shzip=".$from["zip"].
			"&as_shcntry=".$from["country_iso_a2"].
			"&as_cnzip=".$to["zip"].
			"&as_cncntry=".$to["country_iso_a2"].
			"&as_class1=".$data["method_id"].
			"&as_weight1=".$weight;
			
		$c = curl_init($url);
		
		if ($settings["ProxyAvailable"] == "YES")
		{
			//curl_setopt($c, CURLOPT_VERBOSE, 1);
			if (defined("CURLOPT_PROXYTYPE") && defined("CURLPROXY_HTTP") && defined("CURLPROXY_SOCKS5"))
			{
				curl_setopt($c, CURLOPT_PROXYTYPE, $settings["ProxyType"] == "HTTP" ? CURLPROXY_HTTP : CURLPROXY_SOCKS5);
			}
			
			curl_setopt($c, CURLOPT_PROXY, $settings["ProxyAddress"].":".$settings["ProxyPort"]);
			
			if ($settings["ProxyRequiresAuthorization"] == "YES")
			{
				curl_setopt($c, CURLOPT_PROXYUSERPWD, $settings["ProxyUsername"].":".$settings["ProxyPassword"]);
			}

			curl_setopt($c, CURLOPT_TIMEOUT, 120);
		}
		
		curl_setopt($c, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($c, CURLOPT_SSL_VERIFYPEER, 1);
		curl_setopt($c, CURLOPT_CAPATH, $settings['GlobalServerPath'].$settings['SecuritySslDirectory']);
		curl_setopt($c, CURLOPT_CAINFO, $settings['GlobalServerPath'].$settings['SecuritySslDirectory'].'/'.$settings['SecuritySslPem']);
		$result = curl_exec($c);
		
		if (curl_errno($c) == 0)
		{
			$xmlParser = new XMLParser();
			$data = $xmlParser->parse($result);
			
			if (isset($data["RatingResults"][0]["NetFreightCharges"][0]))
			{
				$price = $data["RatingResults"][0]["NetFreightCharges"][0];
				return normalizeNumber($price);		
			}
		}
		else
		{
			$error_message = curl_error($c);
		}
		return false;
	}
	
	
	////////////////////////////////////////////////
	// USPS Domestic
	function getUSPSDomesticShippingPrice($db, $data, $from, $to, $weight, &$error_message, $defaultCurrencyCode = 'USD', $currencyExchangeRates = array())
	{
		global $settings;
		require_once($settings["GlobalServerPath"]."/content/engine/engine_usps.php");
		$usps = new USPS;
		$usps->setUSPSSettings();
		//$usps->setServer($settings["ShippingUSPSUrl"]);
		//$usps->setUserName($settings["ShippingUSPSUserID"]);
		//$usps->setPass($settings["ShippingUSPSUserPassword"]);
		
		$usps->setDestZip($to["zip"]); 
		$usps->setOrigZip($from["zip"]); 
		
		if ($data["method_id"] == "First Class")
		{
			$method_name = explode(" ", $data["method_name"]);
			
			if (isset($method_name[2]))
			{
				$usps->setFirstClassMethod($method_name[2]);
			}
			
			$weight_pounds = 0;
			$weight_ounces = ceil($weight * 16);
		}
		else
		{
			$weight_pounds = floor($weight);
			$weight_ounces = round(($weight - floor($weight)) * 16, 1);
		}
		
		$usps->setWeight($weight_pounds, $weight_ounces); 
		$usps->setService($data["method_id"]);
		$usps->setMachinable("True");
		
		$price = $usps->getDomesticPrice();   
		
		if ($price > 0)
		{
			// apply currency exchange rate
			if ($defaultCurrencyCode != 'USD' && isset($currencyExchangeRates['USD']))
			{
				$price = (float) $price / $currencyExchangeRates['USD'];
			}
			
			//check advanced fee
			if ($data["fee_type"] == "percent")
			{
				$price = $price + $price / 100 * $data["fee"];
			}
			
			if ($data["fee_type"] == "amount")
			{
				$price = $price + $data["fee"];
			}
			
			return $price;
		}
		else
		{
			$error_message = "Please choose other shipping service.<br>We're so sorry, but selected one is not available for your order.";
			return false;
		}
	}
	
	////////////////////////////////////////////////
	// USPS International
	function getUSPSInternationalShippingPrice($db, $data, $from, $to, $weight, &$error_message, $defaultCurrencyCode = 'USD', $currencyExchangeRates = array())
	{
		global $settings;
		require_once($settings["GlobalServerPath"]."/content/engine/engine_usps.php");
		$usps = new USPS;
		$usps->setUSPSSettings();
		
		$weight_pounds = floor($weight);
		$weight_ounces = round(($weight - floor($weight)) * 16, 1);
		$usps->setWeight($weight_pounds, $weight_ounces); 
		
		$usps->setCountry($to["country"]);
		$usps->setCountryCode($to["country_iso_a2"]);
		$usps->setMailType($data["method_id"]);
		$price = $usps->getInternationalPrice();
		
		if ($price > 0)
		{
			// apply currency exchange rate
			if ($defaultCurrencyCode != 'USD' && isset($currencyExchangeRates['USD']))
			{
				$price = (float) $price / $currencyExchangeRates['USD'];
			}
		
			//check advanced fee
			if ($data["fee_type"] == "percent")
			{
				$price = $price + $price / 100 * $data["fee"];
			}
			if ($data["fee_type"] == "amount")
			{
				$price = $price + $data["fee"];
			}
			
			return $price;
		}
		else
		{
			$error_message = "Please choose other shipping service.<br>We're so sorry, but selected one is not available for your order.";
			return false;
		}
	}
	
	/////////////////////////////////////////////////
	// UPS
	function getUpsShippingPrice($db, $data, $from, $to, $weight, &$error_message, $defaultCurrencyCode = 'USD', $currencyExchangeRates = array())
	{
		global $settings;
		$weight_units = strtoupper($settings["LocalizationWeightUnits"]);
		$weight_units = $weight_units == "LBS" ? "LBS" : "KGS";
		
		require_once($settings["GlobalServerPath"]."/content/engine/engine_ups.php");
		
		$ups = new UPS;
		//$ups->setServer("https://wwwcie.ups.com/ups.app/xml/Rate");
		$ups->setServer($settings["ShippingUPSUrl"]);
		
		$ups->setUserName($settings["ShippingUPSUserID"]);
		$ups->setPass($settings["ShippingUPSUserPassword"]);
		$ups->setAccessKey($settings["ShippingUPSAccessKey"]);
	    
		$ups->setResidential(isset($to["address_type"]) && ($to["address_type"] == "Residential") ? 1 : 0);
		
		$ups->setPickupType($settings["ShippingUPSRateChart"]); 
		$ups->setContainer($settings["ShippingUPSContainer"]);
		$ups->setWeightUnit($weight_units);
		$ups->setLengthUnit($settings["LocalizationLengthUnits"]);
		$ups->setCountry($to["country_iso_a2"],$from["country_iso_a2"]);
		
		$ups->setDestZip($to["zip"]); 
		$ups->setOrigZip($from["zip"]); 
		
		$ups->setWeight($weight); 
		$ups->setService($data["method_id"]);
		//$usps->setMachinable("True");
		
		$price = $ups->getShippingRate();
		
		if ($price && $price > 0)
		{
			// apply currency exchange rate
			if ($defaultCurrencyCode != 'USD' && isset($currencyExchangeRates['USD']))
			{
				$price = (float) $price / $currencyExchangeRates['USD'];
			}
			
			//check advanced fee
			if ($data["fee_type"] == "percent")
			{
				$price = $price + $price / 100 * $data["fee"];
			}
			
			if ($data["fee_type"] == "amount")
			{
				$price = $price + $data["fee"];
			}
			
			return $price;
		}
		else
		{
			$error_message = "Please choose other shipping service.<br>We're so sorry, but selected one is not available for your order.";
			return false;
		}
	}
	
	//////////////////////////////////////////////////
	// calculates Internal Shipping Price
	function getCustomShippingPrice($db, $data, $weight, $items, $items_price_based, &$error_message)
	{
		global $settings;
		$db->query("
			SELECT * FROM ".DB_PREFIX."shipping_custom_rates 
			WHERE 
				ssid = '".$data["ssid"]."' AND
				rate_min <= ".($data["method_id"]=="flat"?$items:($data["method_id"]=="price"?$items_price_based:$weight))." AND 
				rate_max >= ".($data["method_id"]=="flat"?$items:($data["method_id"]=="price"?$items_price_based:$weight))."
			ORDER BY rate_min LIMIT 1
		");
		
		if ($db->moveNext())
		{
			switch($data["method_id"])
			{
				case "base_weight" : 
				{
					return $price = $db->col["base"] + $db->col["price"] * $weight;
					break;
				}
				case "weight" :
				{
					return $price = $db->col["price"] * $weight;
					break;
				}
				case "flat" : 
				{
					return $price = $db->col["price"] * $items;
					break;
				}
				case "price" :
				{
					return $price = $db->col["price_type"]=="amount"?$db->col["price"]:(($items_price_based/100)*$db->col["price"]);
					break;
				}
				default : 
				{
					$error_message = "Incorrect shipping method. Please try again.";
					return false;
				}
			}
		}
		else
		{
			$error_message = "Can't determinate shipping price. Please try again.";
			return false;
		}
	}
	
	/**
	 * Calculates shipping price (based on method & type)
	 * @param DB $db
	 * @param array $from
	 * @param array $to
	 * @param float $weight
	 * @param array $items
	 * @param float $items_price_based
	 * @param int $ssid
	 * @param string $error_message
	 * @return type 
	 */
	function getShippingPrice($db, $from, $to, $weight, $items, $items_price_based, $ssid, &$error_message, $defaultCurrencyCode = 'USD', $currencyExchangeRates = array())
	{
		global $settings;
		
		$db->query("SELECT * FROM ".DB_PREFIX."shipping_selected WHERE ssid='".$ssid."'");
		
		if ($db->moveNext())
		{
			$data = $db->col;
			
			$items_price_based = is_array($items_price_based) ? $items_price_based : array('before_discount'=>$items_price_based, 'after_discount'=>$items_price_based);
			$items_price_based = $items_price_based[$data['method_calc_mode']];
			
			switch ($data["carrier_id"])
			{
				case "canada_post" : 
				{
					$price = getCanadaPostShippingPrice($db, $data, $from, $to, $weight, $items, $items_price_based, $error_message);
					return $price;
					break;
				}
				case "ups" : 
				{
					$price = getUpsShippingPrice($db, $data, $from, $to, $weight, $error_message, $defaultCurrencyCode, $currencyExchangeRates);
					return $price;
					break;
				}
				case "usps_domestic" : 
				{
					$price = getUSPSDomesticShippingPrice($db, $data, $from, $to, $weight, $error_message, $defaultCurrencyCode, $currencyExchangeRates);
					return $price;
					break;
				}
				case "usps_international" : 
				{
					$price = getUSPSInternationalShippingPrice($db, $data, $from, $to, $weight, $error_message, $defaultCurrencyCode, $currencyExchangeRates);
					return $price;
					break;
				}
				
				case "fedex_api_express_us" :
				case "fedex_api_freight_us" :
				case "fedex_api_ground_us" :
				case "fedex_api_intr" :
				case "fedex_api_intr_freight" :
				{
					$fedex = new Shipping_Fedex();
					$fedex->setApiKey($settings['ShippingFedExApiKey']);
					$fedex->setApiPassword($settings['ShippingFedExApiPassword']);
					$fedex->setShippingAccount($settings['ShippingFedExAccountNumber']);
					$fedex->setBillingAccount($settings['ShippingFedExBillingAccountNumber']);
					$fedex->setFreightAccount($settings['ShippingFedExFreightAccountNumber']);
					$fedex->setPreferredCurrency($defaultCurrencyCode);
					$fedex->setDefaultCurrency($defaultCurrencyCode);
					$fedex->setCurrencyExchangeRates($currencyExchangeRates);
					$fedex->setMeterNumber($settings['ShippingFedExMeter']);
					$fedex->setWeightUnits($settings['LocalizationWeightUnits'] == 'kg' ? 'KG' : 'LB');
					$fedex->setTotalWeight($weight);
					$fedex->setOriginAddress($from);
					$fedex->setDestinationAddress($to);
					$fedex->setServiceType($data["method_id"]);
					$fedex->setRateRule($settings["ShippingFedExRateRule"]);
					
					$price = $fedex->getShippingPrice();
					
					if ($price)
					{
						$price = $price + ($data["fee_type"]=='amount'?$data["fee"]:($price * $data["fee"])/100);
					}
					
					return $price;
					break;
				}
				

				/** START OF FEDEX LEGACY **/
				case "fedex_express" : 
				{
					$price = getFedexShippingPrice($db, $data, $from, $to, $weight, $error_message, "FDXE");
					$price = $price + ($data["fee_type"]=='amount'?$data["fee"]:($price * $data["fee"])/100);
					return $price;
					break; 
				}

				case "fedex_ground" : 
				{
					$price = getFedexShippingPrice($db, $data, $from, $to, $weight, $error_message, "FDXG");
					$price = $price + ($data["fee_type"]=='amount'?$data["fee"]:($price * $data["fee"])/100);
					return $price;
					break;
				}

				case "fedex_freight" : 
				{
					$price = getFedexFreightShippingPrice($db, $data, $from, $to, $weight, $error_message);
					$price = $price + ($data["fee_type"]=='amount'?$data["fee"]:($price * $data["fee"])/100);
					return $price;
					break;
				}
				/** END OF FEDEX LEGACY **/

				case "custom" : 
				{
					$price = getCustomShippingPrice($db, $data, $weight, $items, $items_price_based, $error_message);
					return $price;
					break;
				}
			}
		}
	}

	/**
	 * GET SHIPPING QUOTES, AND ASSIGN SMARTY VARS
	 * If handling included in shipping, returns data with handling included
	 * @param $db
	 * @param $user
	 * @param $order
	 * @param $shipping_quote_call
	 * @param $shipping_quote_address
	 */
	function getShippingQuotes(
		&$db, &$user, &$order, 
		$shipping_quote_call = false, $shipping_quote_address = false, $ignore_free_shipping = false, 
		$defaultCurrencyCode = 'USD', $currencyExchangeRates = array(),
		$bongoActive = false, &$bongoUsed
	)
	{
		global $shipping_error, $shipping_error_message;
		global $settings;
		
		$bongoUsed = false;

		$method_checked = false;
		
		$product_level_method_used = false;
		$shipping_price_at_product_level = 0;
		$product_level_method = false;
		$international_error = false;
		$shipping_methods = false;
		$shipping_methods_exist = false;
		
		$dollar_days_shipping_percent = 15;
		$dollar_days_shipping_min_amount = 6.95;
		
		$shipping_price_at_product_level = 0;
		$shipping_amount_for_price_based = 0;
		$shipping_amount_for_price_based_discounted = 0;
		$shipping_amount_for_price_based_exists = false;

		$shipping_weight = 0;
		$shipping_items_count = 0;
		$dollar_days_products_price = 0;
		$shipping_amount_dollar_days = 0;
		$shipping_amount_doba = 0;
		$doba_items = array();
		$shipping_digital = 1;

		if ($shipping_quote_call)
		{
			$shipping_address = $shipping_quote_address;
		}
		else
		{
			$order->getShippingAddress();
			$shipping_address = $order->shippingAddress;
		}

		// delivery to bongo instead of international address
		if ($bongoActive && $shipping_address['country_id'] != '1')
		{
			$shipping_address["country_id"] = 1;
			$shipping_address["state_id"] = $settings['bongocheckout_State'];
		}

		
		$order->checkShippingDigital();
	
		$shipping_error = isset($shipping_error) ? $shipping_error : false;
		$shipping_error_message = isset($shipping_error_message) ? $shipping_error_message : "";
	
		if (($settings["ShippingInternational"] == "NO") && ($shipping_address["country_id"] != $settings["ShippingOriginCountry"]))
		{
			$international_error = true;
		}
		elseif ($settings["ShippingCalcEnabled"] == "YES")
		{
			/**
			 * Select available shipping methods
			 */
			$query_result = $db->query("SELECT * FROM ".DB_PREFIX."shipping_selected WHERE ".DB_PREFIX."shipping_selected.hidden='No' ORDER BY priority");
			$shipping_methods_exist = $db->numRows()>1;
		
			$available_methods = array();
			$product_level_method = false;
		
			while (($data = $db->moveNext($query_result, MYSQL_ASSOC)) != false)
			{
				$accept_countries = explode(",", $data["country"]);
				$accept_states = explode(",", $data["state"]);
				
				/**
				 * Check do we ship to selected country
				 */
				if (($data["country"] == 0 || in_array($shipping_address["country_id"], $accept_countries)) && ($data["country_exclude"] != $shipping_address["country_id"]))
				{
					if ($data["state"] == 0 || in_array($shipping_address["state_id"], $accept_states))
					{
						if (($data["carrier_id"] == "custom") && ($data["method_id"] == "product_level") && ($product_level_method == false))
						{
							$product_level_method = $data;
						}
						else
						{
							$available_methods[] = $data;
						}
					}
				}
			}
		
			/**
			 * Check shipping on product level
			 */
			if ($product_level_method)
			{
				$query_result = $db->query("
					SELECT 
						".DB_PREFIX."orders_content.*,
						IF(".DB_PREFIX."products_shipping_price.is_price IS NULL, 'No', ".DB_PREFIX."products_shipping_price.is_price) AS product_is_shipping_price,
						IF(".DB_PREFIX."products_shipping_price.price IS NULL, 0.00, ".DB_PREFIX."products_shipping_price.price) AS product_shipping_price
					FROM ".DB_PREFIX."orders_content 
					LEFT JOIN ".DB_PREFIX."products_shipping_price ON 
						".DB_PREFIX."products_shipping_price.pid = ".DB_PREFIX."orders_content.pid AND 
						".DB_PREFIX."products_shipping_price.ssid='".intval($product_level_method["ssid"])."'
					WHERE ".DB_PREFIX."orders_content.oid='".intval($order->oid)."'
				");
			}
			else
			{
				$query_result = $db->query("
					SELECT 
						".DB_PREFIX."orders_content.*,
						'No' AS product_is_shipping_price,
						'0.00' AS product_shipping_price
					FROM ".DB_PREFIX."orders_content 
					WHERE ".DB_PREFIX."orders_content.oid='".intval($order->oid)."'
				");
			}
			
			//will be set to true if there are not only doba and dollar day products
			$ship_user_products = false;
			
			/**
			 * Get order items
			 */
			while (($item = $db->moveNext($query_result, MYSQL_ASSOC)) != false)
			{
				//check is there "real" items
				if ($item["digital_product"] == "No") $shipping_digital = 0;

				//check dollar days shipping
				if ($item["is_dollar_days"] == "Yes")
				{
					$dollar_days_products_price += $item["price"] * $item["quantity"];
				}
				//doba
				elseif ($item["is_doba"] == "Yes")
				{
					$doba_items[] = array(
						"item_id"=>$item["product_id"], 
						"quantity"=>$item["quantity"]
					);
				}
				//other "native cart" products
				else
				{
					$ship_user_products = true;
					
					if ($item["digital_product"] == "No")
					{
						/**
						 * Shipping price on product level
						 */
						if ($product_level_method && $item["product_is_shipping_price"] == 'Yes' && ($item["free_shipping"] == "No" || ($item["free_shipping"] == "Yes" && $ignore_free_shipping)))
						{
							$shipping_price_at_product_level += $item["product_shipping_price"] * $item["quantity"];
							$product_level_method_used = true;
						}
						
						/**
						 * Or global shipping methods
						 */
						if (($item["product_is_shipping_price"] == 'No') && ($item["free_shipping"] == "No" || ($item["free_shipping"] == "Yes" && $ignore_free_shipping)))
						{
							/**
							 * Calculate shipping total items count
							 */
							$shipping_items_count += $item["quantity"];
							
							/**
							 * Calculate shipping weight
							 */
							if ($item["weight"] > 0 )
							{
								$shipping_weight += $item["weight"] * $item["quantity"];
							}
							
							/**
							 * Calculate shipping product price
							 */
							if ($item["price"] > 0)
							{
								$shipping_amount_for_price_based += $item["price"] * $item["quantity"];
								$shipping_amount_for_price_based_exists = true;
							}
						}
					}
				}
			}
			
			/**
			 * Dollar Days
			 */
			if ($dollar_days_products_price > 0)
			{
				$shipping_amount_dollar_days = $dollar_days_products_price / 100 * $dollar_days_shipping_percent;
				
				if ($shipping_amount_dollar_days < $dollar_days_shipping_min_amount)
				{
					$shipping_amount_dollar_days = 	$dollar_days_shipping_min_amount;
				}
				
				/**
				 * Dollar days is a product-specific shipping method
				 */
				$product_level_method_used = true;
				$shipping_price_at_product_level += $shipping_amount_dollar_days;
			}

			/**
			 * Doba
			 */
			if (count($doba_items) > 0)
			{
				require_once("content/classes/class.doba_order.php");
				$dobaOrder = new DobaOrderAPI($settings, $db);
				
			 	$shipping_amount_doba = $dobaOrder->getShippingQuote($shipping_address, $doba_items);
				
				if ($shipping_amount_doba != false)
				{
					/**
					 * Doba shipping is product-specific, too
					 */
					$product_level_method_used = true;
					$shipping_price_at_product_level += $shipping_amount_doba;
				}
			}

			/**
			 * Promo and Discounts
			 */
			if ($order->promoDiscountAmount > 0)
			{
				$promo_discount_percent = $order->promoDiscountType == "percent" ? $order->promoDiscountValue : $order->promoDiscountValue / ($order->subtotalAmount / 100);
			}
			else
			{
				$promo_discount_percent = 0;
			}

			if ($order->discountAmount > 0)
			{
				$discount_percent = $order->discountType == "percent" ? $order->discountValue : $order->discountValue / ($order->subtotalAmount / 100);
			}
			else
			{
				$discount_percent = 0;
			}

			if ($shipping_amount_for_price_based_exists)
			{
				$shipping_amount_for_price_based_discounted =
					$shipping_amount_for_price_based -
					$shipping_amount_for_price_based / 100 * $promo_discount_percent -
					$shipping_amount_for_price_based / 100 * $discount_percent;
			}
			else
			{
				$shipping_amount_for_price_based_discounted = 
					$shipping_amount_for_price_based;
			}
			
			/**
			 * Add handling to shipping price at product level
			 */
			if ($settings["ShippingHandlingSeparated"] != "1" && $product_level_method_used && $shipping_price_at_product_level > 0)// && $shipping_price_at_product_level > 0)
			{
				$shipping_price_at_product_level = $shipping_price_at_product_level + $order->getHandlingAmount(false, false);
				$handling_added_at_product_level = true;
			}
			else
			{
				$handling_added_at_product_level = false;
			}
		
			/**
			 * And on product method level
			 */
			if (count($available_methods) > 0 && $ship_user_products)
			{
				$address_from = array(
					"address1" => $settings["ShippingOriginAddressLine1"],
					"address2" => $settings["ShippingOriginAddressLine2"],
					"city" => $settings["ShippingOriginCity"],
					"zip" => $settings["ShippingOriginCountry"] == "1" ? substr(trim($settings["ShippingOriginZip"]), 0, 5) : trim($settings["ShippingOriginZip"])
				);

				$db->query("SELECT * FROM ".DB_PREFIX."countries WHERE coid='".$settings["ShippingOriginCountry"]."'");
				if ($db->moveNext())
				{
					$address_from["country_id"] = $db->col["coid"];
					$address_from["country"] = $db->col["name"];
					$address_from["country_iso_a2"] = $db->col["iso_a2"];
					$address_from["country_iso_a3"] = $db->col["iso_a3"];
					$address_from["country_iso_number"] = $db->col["iso_number"];
				}
				else
				{
					$address_from["country_id"] = 1;
					$address_from["country"] = "United States";
					$address_from["country_iso_a2"] = "US";
					$address_from["country_iso_a3"] = "USA";
					$address_from["country_iso_number"] = "840";
				}
				
				$db->query("SELECT * FROM ".DB_PREFIX."states WHERE coid='".intval($address_from['country_id'])."' AND stid='".intval($settings["ShippingOriginState"])."'");

				if ($db->moveNext())
				{
					$address_from['state_id'] = $db->col["stid"];
					$address_from['state_name'] = $db->col["name"];
					$address_from['state_code'] = $db->col["short_name"];
				}
				else
				{
					$address_from['state_id'] = 0;
					$address_from['state_name'] = '';
					$address_from['state_code'] = '';
				}

				/**
				 * Prepare to(destination) shipping address
				 */
				if ($shipping_quote_call)
				{
					$db->query("SELECT * FROM ".DB_PREFIX."countries WHERE coid='".$shipping_quote_address["country_id"]."'");
					$db->moveNext();
					$address_to = array("address_type" => "Residential", "country" => $db->col["name"], "country_iso_a2" => $db->col["iso_a2"], "country_iso_a3" => $db->col["iso_a3"], "country_iso_number" => $db->col["iso_number"], "zip" => $shipping_quote_address["country_id"]=="1"?substr(trim($shipping_quote_address["shipping_zip"]), 0, 5):trim($shipping_quote_address["shipping_zip"]));
				}
				else
				{
					$db->query("
						SELECT 
							".DB_PREFIX."orders.shipping_address_type, 
							".DB_PREFIX."orders.shipping_name,
							".DB_PREFIX."orders.shipping_address1,
							".DB_PREFIX."orders.shipping_address2,
							".DB_PREFIX."orders.shipping_city,
							".DB_PREFIX."orders.shipping_province,
							".DB_PREFIX."orders.shipping_zip,
							".DB_PREFIX."orders.shipping_country, 
							".DB_PREFIX."countries.name AS country_name, 
							".DB_PREFIX."countries.iso_a2 AS country_iso_a2, 
							".DB_PREFIX."countries.iso_a3 AS country_iso_a3, 
							".DB_PREFIX."countries.iso_number AS country_iso_number,
							".DB_PREFIX."states.name AS state_name, 
							".DB_PREFIX."states.short_name AS state_code									
						FROM ".DB_PREFIX."orders 
						LEFT JOIN ".DB_PREFIX."countries ON ".DB_PREFIX."countries.coid = ".DB_PREFIX."orders.shipping_country
						LEFT JOIN ".DB_PREFIX."states ON ".DB_PREFIX."states.stid = ".DB_PREFIX."orders.shipping_state
						WHERE oid='".$order->oid."'
					");
					
					$db->moveNext();
					
					$address_to = array(
						"address_type" => $db->col["shipping_address_type"], 
						"name" => $db->col["shipping_name"],
						"address1" => $db->col["shipping_address1"],
						"address2" => $db->col["shipping_address2"],
						"city" => $db->col["shipping_city"],
						"state_name" => $db->col["state_name"] != "" ? $db->col["state_name"] : $db->col["shipping_province"],
						"state_code" => $db->col["state_code"] != "" ? $db->col["state_code"] : "",
						"country" => $db->col["country_name"], 
						"country_iso_a2" => $db->col["country_iso_a2"], 
						"country_iso_a3" => $db->col["country_iso_a3"], 
						"country_iso_number" => $db->col["country_iso_number"], 
						"zip" => $db->col["shipping_country"]=="1" ? substr(trim($db->col["shipping_zip"]), 0, 5) : trim($db->col["shipping_zip"])
					);
				}

				// delivery to bongo instead of international address
				if ($bongoActive && strtoupper($address_to['country_iso_a2']) != 'US')
				{
					$db->query("SELECT * FROM ".DB_PREFIX."countries WHERE coid='1'");
					$bongoCountryData = $db->moveNext();

					$db->query("SELECT * FROM ".DB_PREFIX."states WHERE stid='".intval($settings['bongocheckout_State'])."'");
					$bongoStateData = $db->moveNext();

					$address_to = array(
						"address_type" => "Business", 
						"name" => $settings["bongocheckout_Company_Name"].", attn. ".$settings["bongocheckout_Attention_To"],
						"address1" => $settings["bongocheckout_Address1"],
						"address2" => $settings["bongocheckout_Address2"],
						"city" => $settings["bongocheckout_City"],
						"state_name" => $bongoStateData["name"],
						"state_code" => $bongoStateData["short_name"],
						"country" => $bongoCountryData["name"],
						"country_iso_a2" => $bongoCountryData["iso_a2"], 
						"country_iso_a3" => $bongoCountryData["iso_a3"], 
						"country_iso_number" => $bongoCountryData["iso_number"], 
						"zip" => $settings["bongocheckout_Zip_Code"]
					);

					$bongoUsed = true;
				}


				/**
				 * Check ranges
				 */
				$shipping_methods = array();
				$shipping_method = isset($shipping_method) ? intval($shipping_method) : $order->shippingSSID;
			
				for ($i=0; $i<count($available_methods); $i++)
				{
					$available_method = $available_methods[$i];
					$available_method["shipping_price"] = 0;
					$may_be_added = false;
					
					// check custom shipping methods
					if ($available_method["carrier_id"] == "custom")
					{
						// check items count, price based and weight ranges
						if ($available_method["method_id"] == "flat")
						{
							$c = $shipping_items_count > 0 ? $shipping_items_count : 1;
							$db->query($q = "SELECT * FROM ".DB_PREFIX."shipping_custom_rates WHERE ssid='".$available_method["ssid"]."' AND rate_min <= ".$c." AND rate_max >= ".$c." ORDER BY rate_min LIMIT 1");
						}
						
						if ($available_method["method_id"] == "price" && $shipping_amount_for_price_based_exists)
						{
							if ($available_method['method_calc_mode'] == 'before_discount')
							{
								$db->query($q = "SELECT * FROM ".DB_PREFIX."shipping_custom_rates WHERE ssid='".$available_method["ssid"]."' AND rate_min <= ".$shipping_amount_for_price_based." AND rate_max >= ".$shipping_amount_for_price_based." ORDER BY rate_min LIMIT 1");
							}
							else
							{
								$db->query($q = "SELECT * FROM ".DB_PREFIX."shipping_custom_rates WHERE ssid='".$available_method["ssid"]."' AND rate_min <= ".$shipping_amount_for_price_based_discounted." AND rate_max >= ".$shipping_amount_for_price_based_discounted." ORDER BY rate_min LIMIT 1");
							}
						}
						
						if ($available_method["method_id"] == "base_weight" || $available_method["method_id"] == "weight")
						{
							$db->query($q = "SELECT * FROM ".DB_PREFIX."shipping_custom_rates WHERE ssid='".$available_method["ssid"]."' AND rate_min <= ".$shipping_weight." AND rate_max >= ".$shipping_weight." ORDER BY rate_min LIMIT 1");
						}
						
						if ($db->moveNext())
						{
							$may_be_added = true;
						}
					}
					//now for Fedex, UPS and USPS
					else
					{
						//check weight is in allowed range
						if ($available_method["weight_min"] <= $shipping_weight && $available_method["weight_max"] >= $shipping_weight && $available_method["exclude"] == "No")
						{
							$may_be_added = true;
						}
						//check weight is now in disallowed range
						if ($available_method["weight_min"] >= $shipping_weight && $available_method["weight_max"] <= $shipping_weight && $available_method["exclude"] == "Yes")
						{
							$may_be_added = true;
						}
					}

					//try to calculate shipping price
					if ($may_be_added == true)
					{
						$error_message = "";
						$result_shipping_price = getShippingPrice($db, $address_from, $address_to,
							$shipping_weight,
							$shipping_items_count,
							array(
								'before_discount'=>$shipping_amount_for_price_based, 
								'after_discount'=>$shipping_amount_for_price_based_discounted
							), //price based
							$available_method["ssid"],
							$error_message,
							$defaultCurrencyCode,
							$currencyExchangeRates
						);
						
						if ($error_message != "" || $result_shipping_price === false)
						{
							$may_be_added = false;
						}
						else
						{
							if (!$shipping_digital)
							{
								if ($settings["ShippingHandlingSeparated"] != "1" && (!$handling_added_at_product_level) && $result_shipping_price > 0)
								{
									$result_shipping_price = $result_shipping_price + $order->getHandlingAmount(false, false);
								}
							}
							$available_method["shipping_price"] = round($result_shipping_price, 2);
						}
						
						if ($may_be_added)
						{
							if (!$shipping_method)
							{
								$shipping_method = $available_method["ssid"];
							}
							
							$available_method["ssid"] = $available_method["ssid"];
							
							if ($shipping_method == $available_method["ssid"])
							{
								$available_method["checked"] = "yes";
								$method_checked = true;
							}
							else
							{
								$available_method["checked"] = "no";	
							}
							
							$available_method["method_name"] = gs($available_method["carrier_name"]).($available_method["carrier_id"]=="custom"?"":" - ".gs($available_method["method_name"]));
							$shipping_methods[] = $available_method;
						}
					}
				}
			}
		
			if ($product_level_method_used)
			{
				if (!$product_level_method)
				{
					$product_level_method = array(
						"ssid" => 0, 
						"carrie_id" => "custom", 
						"carrier_name" => "At product level",
						"method_id" => "product_level",
						"method_name" => "At product level",
						"priority" => "5",
						"country" => "0",
						"country_exclude" => "",
						"stat" => "0",
						"weight_min" => 0,
						"weight_max" => 1000000,
						"fee" => 0, 
						"fee_type" => "amount", 
						"exclude" => "No",
						"hidden" => "No"
					);
				}	
				$product_level_method["shipping_price"] = round($shipping_price_at_product_level, 2);			
				$_SESSION["product_level_method"] = $product_level_method;
			}
			else
			{
				unset($_SESSION["product_level_method"]);
			}
		}
		
		if (!$method_checked && $shipping_methods && is_array($shipping_methods))
		{
			foreach($shipping_methods as $key => $value)
			{
				$shipping_methods[$key]["checked"] = "yes";
				break;
			}
		}
		
		unset($_SESSION["USPS_InternationalCacheResponse"]);
		unset($_SESSION["USPS_InternationalCacheResponseEnvelope"]);
		unset($_SESSION["USPS_InternationalCacheResponsePackage"]);
		unset($_SESSION["USPS_InternationalCacheResponsePostcardsorAerogrammes"]);
		
		$return = 
			array(
				"shipping_price_at_product_level"=>round($shipping_price_at_product_level, 2),
				"shipping_methods"=>$shipping_methods, 
				"shipping_methods_count"=>$shipping_methods?count($shipping_methods):0,
				"product_level_method"=>$product_level_method_used?$product_level_method:false,
				"international_error"=>$international_error,
				"shipping_error"=>$shipping_error,
				"shipping_error_message"=>$shipping_error_message,
				"shipping_methods_exist"=>$shipping_methods_exist,
				"shipping_weight"=>$shipping_weight
			);

		return $return;
	}
	
	/**
	 * Filter alternative shipping quotes (ignored free products) by comparing to standard shipping quotes and removing duplicates 
	 * @param mixed $rates
	 * @param mixed $ratesA
	 */
	function filterAlternativeShippingQuotes($rates, $ratesA)
	{
		$_rates = false;
		if ($ratesA && is_array($ratesA) && isset($ratesA["shipping_methods"]) && is_array($ratesA["shipping_methods"]))
		{
			$_rates = array();
				
			// combine rates
			foreach ($ratesA["shipping_methods"] as $rateA)
			{
				$ssidFound = false;
						
				// add alternative method only when price is differrent or it does not existin in standard methods
				if ($rates && is_array($rates) && isset($rates["shipping_methods"]) && is_array($rates["shipping_methods"]))
				{
					foreach ($rates["shipping_methods"] as $rate)
					{
						if ($rateA["ssid"] == $rate["ssid"])
						{
							$ssidFound = true;
							if ($rateA["shipping_price"] != $rate["shipping_price"]) $_rates[] = $rateA;
						}
					}
				}
				if (!$ssidFound) $_rates[] = $rateA;
			}
			$ratesA["shipping_methods"] = $_rates;
			$ratesA["shipping_methods_count"] = count($_rates);
			return $ratesA;
		}
		return false;
	}
	
