<?php
/**
 * User order (archived)
 */

if (!defined("ENV")) exit();

if ($user->auth_ok)
{
	$order_id = isset($_REQUEST["order_id"]) ? intval($_REQUEST["order_id"]) : 0;
	$history_order_data = $user->getOrderData($order_id);
	
	if ($history_order_data)
	{
		$history_order_items = $user->getOrderItems($order_id);
		$history_user_data = $user->getUserData();
		
		$history_order_data["shipping_tracking"] = $history_order_data["shipping_tracking"] != "" ? unserialize($history_order_data["shipping_tracking"]) : false;
		
		if ($history_order_data["shipping_tracking_number"] != "")
		{
			if ($history_order_data["shipping_tracking_number_type"] == "UPS")
			{
				require_once("content/engine/engine_ups.php");
				$ups = new UPS();
				$ups->setUserName($settings["ShippingUPSUserID"]);
				$ups->setPass($settings["ShippingUPSUserPassword"]);
				$ups->setAccessKey($settings["ShippingUPSAccessKey"]);
				$ups->setTrackingServer($settings["ShippingUPSTrackingUrl"]);				
				$info=$ups->getTrackingInfo($history_order_data["shipping_tracking_number"]);
				view()->assign("tracking_info", $info);
			}
			if ($history_order_data["shipping_tracking_number_type"] == "USPS")
			{
				require_once("content/engine/engine_usps.php");
				$usps = new USPS();
				$usps->setUserName($settings["ShippingUSPSUserID"]);
				$usps->setPass($settings["ShippingUSPSUserPassword"]);
				$usps->setServer($settings["ShippingUSPSTrackingUrl"]);
				$result = $usps->track($history_order_data["shipping_tracking_number"]);
				if ($result)
				{
					view()->assign("tracking_info", $result);
				}
			}
		}
		
		view()->assign("history_order_data", $history_order_data);
		view()->assign("history_user_data", $history_user_data);
		view()->assign("history_order_items", $history_order_items);
		view()->assign("body", "templates/pages/account/order.html");
	}
	else
	{
		header("Location: ".$settings["GlobalHttpUrl"]."/index.php?p=404");
		_session_write_close();
		die();
	}
}
else
{
	view()->assign("body", "templates/account/auth-error.html");
}
