<?php
/**
 * Show users payment_profiles
 */

if (!defined("ENV")) exit();

if ($user->auth_ok)
{
	//country / state data
	require_once("content/classes/class.regions.php");
	$regions = new Regions($db);
	view()->assign("countries_states", json_encode($regions->getCountriesStatesForSite()));

	$months = array();
	for ($k = 1; $k <= 12; $k++)
	{
		$months[($k < 10 ? '0'.$k : $k)] = $k;
	}
	view()->assign('cc_expiration_months', $months);

	$years = array();
	for ($k = date("Y"); $k <= date("Y")+10; $k++)
	{
		$years[] = $k;
	}
	view()->assign('cc_expiration_years', $years);

	require_once("content/classes/class.payment_profile.php");
	$payment_profile = new Payment_Profile();

	$profiles = $payment_profile->getPaymentProfiles($db, $user);

	view()->assign("payment_id", $payment_profile->getDefaultPaymentMethodId($db));
	view()->assign("profiles", $profiles);

	view()->assign("body", "templates/pages/account/payment-profiles.html");
}
else
{
	view()->assign("body", "templates/pages/account/auth-error.html");
}